const blocks = (extFacePanels) => ([{
        "opcode": "SERIAL_PRINTLN",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "text": {
                "type": "string",
                "defaultValue": ""
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `Serial.println(/*{text}*/);`,
                "sections": {
                    "setup": `Serial.begin(115200);`
                }
            }
        },
        "handler": this.funcs.SERIAL_PRINTLN
    },
    {
        "opcode": "buzzer",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "status": {
                "type": "number",
                "defaultValue": 1
            },
            "del": {
                "type": "number",
                "defaultValue": 1
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `tone(22, /*{del}*/, /*{status}*/);`
            }
        },
        "handler": this.funcs.buzzer
    },
    {
        "opcode": "led_control",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "LED_CONTROL_STATUS"
            },
            "pin": {
                "type": "fieldMenu",
                "defaultValue": "45",
                "menu": "LED_CONTROL_PIN"
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                    "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
            }
        },
        "handler": this.funcs.led_control
    },
    {
        "opcode": "setDigital",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "pin": {
                "type": "fieldMenu",
                "defaultValue": "5",
                "menu": "SETDIGITAL_PIN"
            },
            "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "SETDIGITAL_STATUS"
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                    "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
            }
        },
        "handler": this.funcs.setDigital
    },
    {
        "opcode": "is_pressed_button",
        "blockType": "boolean",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "button_pin": {
                "type": "fieldMenu",
                "defaultValue": "23",
                "menu": "IS_PRESSED_BUTTON_BUTTON_PIN"
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `!digitalRead(/*{button_pin}*/)`,
                "sections": {
                    "setup": `pinMode(/*{button_pin}*/, INPUT);`
                }
            }
        },
        "handler": this.funcs.is_pressed_button
    },
    {
        "opcode": "BLOCK_1719068300620",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "pin": {
                "type": "fieldMenu",
                "defaultValue": "25",
                "menu": "BLOCK_1719068300620_PIN"
            },
            "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "SETDIGITAL_STATUS"
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                    "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1719068300620
    },
    {
        "opcode": "BLOCK_1719071535530",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "red": {
                "type": "number",
                "defaultValue": 1
            },
            "green": {
                "type": "number",
                "defaultValue": 1
            },
            "blue": {
                "type": "number",
                "defaultValue": 1
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `leds [0] = CRGB(/*{red}*/, /*{green}*/, /*{blue}*/);\r\nFastLED.show();`,
                "sections": {
                    "lib": `#include \"FastLED-2-final/FastLED.h\"`,
                    "declare": `#define NUM_LEDS 1\r\n#define DATA_PIN 43\r\nCRGB leds [ NUM_LEDS ];`,
                    "setup": `FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);\r\nFastLED.setBrightness(100);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1719071535530
    },
    {
        "opcode": "BLOCK_1721321922207",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {},
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `notone();`
            }
        },
        "handler": this.funcs.BLOCK_1721321922207
    }
]);

export default blocks;