(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.unknown = mod.exports;
  }
})(this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  !function (global) {
    "use strict";

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    var inModule = typeof module === "object";
    var runtime = global.regeneratorRuntime;

    if (runtime) {
      if (inModule) {
        module.exports = runtime;
      }

      return;
    }

    runtime = global.regeneratorRuntime = inModule ? module.exports || {} : {};

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self, context);
      return generator;
    }

    runtime.wrap = wrap;

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};

    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        prototype[method] = function (arg) {
          return this._invoke(method, arg);
        };
      });
    }

    runtime.isGeneratorFunction = function (genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };

    runtime.mark = function (genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;

        if (!(toStringTagSymbol in genFun)) {
          genFun[toStringTagSymbol] = "GeneratorFunction";
        }
      }

      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    runtime.awrap = function (arg) {
      return {
        __await: arg
      };
    };

    function AsyncIterator(generator) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;

          if (value && typeof value === "object" && hasOwn.call(value, "__await")) {
            return Promise.resolve(value.__await).then(function (value) {
              invoke("next", value, resolve, reject);
            }, function (err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return Promise.resolve(value).then(function (unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new Promise(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }

      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);

    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };

    runtime.AsyncIterator = AsyncIterator;

    runtime.async = function (innerFn, outerFn, self, tryLocsList) {
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
      return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;
          var record = tryCatch(innerFn, self, context);

          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (method === undefined) {
        context.delegate = null;

        if (context.method === "throw") {
          if (delegate.iterator.return) {
            context.method = "return";
            context.arg = undefined;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;

        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined;
        }
      } else {
        return info;
      }

      context.delegate = null;
      return ContinueSentinel;
    }

    defineIteratorMethods(Gp);
    Gp[toStringTagSymbol] = "Generator";

    Gp[iteratorSymbol] = function () {
      return this;
    };

    Gp.toString = function () {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    runtime.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      keys.reverse();
      return function next() {
        while (keys.length) {
          var key = keys.pop();

          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];

        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined;
            next.done = true;
            return next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    runtime.values = values;

    function doneResult() {
      return {
        value: undefined,
        done: true
      };
    }

    Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined;
        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined;
            }
          }
        }
      },
      stop: function () {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;

        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;

        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            context.method = "next";
            context.arg = undefined;
          }

          return !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },
      complete: function (record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          this.arg = undefined;
        }

        return ContinueSentinel;
      }
    };
  }(function () {
    return this || typeof self === "object" && self;
  }() || Function("return this")());
  const disableBlocks = {
    debug: [],
    upload: []
  };
  const mustLoginBlocks = [];

  const triggerBlocksStatus = async (mode, app) => {};

  class ExtImpl {}

  const extTranslationMap = {
    "zh": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "en": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен",
      "DIGITAL_PIN_PIN_0": "Blue",
      "DIGITAL_PIN_PIN_1": "Red",
      "DIGITAL_PIN_PIN_2": "Green",
      "DIGITAL_PIN_PIN_3": "Squeaker",
      "DIGITAL_PIN_STATUS_0": "On",
      "DIGITAL_PIN_STATUS_1": "Off",
      "Digital_Pin": "[pin] LED color [status]",
      "ANALOG_PIN_ANALOGPIN_0": "A0",
      "ANALOG_PIN_ANALOGPIN_1": "A1",
      "ANALOG_PIN_ANALOGPIN_2": "A2",
      "ANALOG_PIN_ANALOGPIN_3": "A3",
      "ANALOG_PIN_ANALOGPIN_4": "A4",
      "ANALOG_PIN_ANALOGPIN_5": "A5",
      "ANALOG_PIN_ANALOGPIN_6": "A6",
      "ANALOG_PIN_ANALOGPIN_7": "A7",
      "Analog_Pin": "On analog pin [AnalogPin] set value [value]",
      "BUTTONREAD_PIN_0": "SW1",
      "BUTTONREAD_PIN_1": "SW2",
      "ButtonRead": "Button status [pin]",
      "AdressLed": "Set value for color red [red], green [green], blue [blue]",
      "SERIALTEST_PORT_0": "Port 1",
      "UART_WRITE": "On [PORT] send [signal]",
      "BLOCK_1686748446699_PIN_0": "Squeaker",
      "BLOCK_1682536405540": "When Renics start"
    },
    "ru": {
      "renics_extention": "Расширение для платы Renics",
      "extensionName": "Расширение для платы Renics",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен",
      "DIGITAL_PIN_PIN_0": "Синий",
      "DIGITAL_PIN_PIN_1": "Красный",
      "DIGITAL_PIN_PIN_2": "Зеленый",
      "DIGITAL_PIN_PIN_3": "Пищалка",
      "DIGITAL_PIN_STATUS_0": "Включить",
      "DIGITAL_PIN_STATUS_1": "Выключить",
      "Digital_Pin": "[pin] цвет светодиода [status]",
      "ANALOG_PIN_ANALOGPIN_0": "A0",
      "ANALOG_PIN_ANALOGPIN_1": "A1",
      "ANALOG_PIN_ANALOGPIN_2": "A2",
      "ANALOG_PIN_ANALOGPIN_3": "A3",
      "ANALOG_PIN_ANALOGPIN_4": "A4",
      "ANALOG_PIN_ANALOGPIN_5": "A5",
      "ANALOG_PIN_ANALOGPIN_6": "A6",
      "ANALOG_PIN_ANALOGPIN_7": "A7",
      "Analog_Pin": "На аналоговый вход [AnalogPin] установить значение [value]",
      "BUTTONREAD_PIN_0": "SW1",
      "BUTTONREAD_PIN_1": "SW2",
      "ButtonRead": "Значение кнопки [pin]",
      "AdressLed": "Установить значение красного [red], зеленого [green], синего [blue]",
      "SERIALTEST_PORT_0": "Порт 1",
      "UART_WRITE": "Через [PORT] отправить [signal]",
      "BLOCK_1686748446699_PIN_0": "Пищалку",
      "BLOCK_1682536405540": "Когда Renics запустится"
    },
    "de": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "es": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "fr": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "id": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "ja": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "ja-jph": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "ko": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "pl": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "uk": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "zh-hant": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "nl": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "it": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "hr": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "pt": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "fi": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "tr": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    },
    "tk": {
      "renics_extention": "Renics extention",
      "extensionName": "Renics extention",
      "SERIAL_PRINTLN": "Вывести в COM-порт [text] ",
      "buzzer": "Включить звуковой сигнал с частотой [status] Гц длительсностью [del] сек.",
      "LED_CONTROL_STATUS_0": "Включить",
      "LED_CONTROL_STATUS_1": "Выключить",
      "LED_CONTROL_PIN_0": "Красный",
      "LED_CONTROL_PIN_1": "Зелёный",
      "LED_CONTROL_PIN_2": "Синий",
      "led_control": "[status]  [pin] светодиод",
      "SETDIGITAL_PIN_0": "OC3A",
      "SETDIGITAL_PIN_1": "OC3B",
      "SETDIGITAL_PIN_2": "OC3C",
      "SETDIGITAL_PIN_3": "OC4A",
      "SETDIGITAL_PIN_4": "OC4B",
      "SETDIGITAL_PIN_5": "OC4C",
      "SETDIGITAL_PIN_6": "OC2B",
      "SETDIGITAL_PIN_7": "OC2A",
      "SETDIGITAL_STATUS_0": "Включено",
      "SETDIGITAL_STATUS_1": "Выключено",
      "setDigital": "Установить цифровой вывод [pin] в состояние [status] ",
      "IS_PRESSED_BUTTON_BUTTON_PIN_0": "SW1",
      "IS_PRESSED_BUTTON_BUTTON_PIN_1": "SW2",
      "is_pressed_button": "Кнопка [button_pin] нажата",
      "BLOCK_1719068300620_PIN_0": "Красный",
      "BLOCK_1719068300620_PIN_1": "Зеленый",
      "BLOCK_1719068300620_PIN_2": "Желтый",
      "BLOCK_1719068300620": "Светодиод [pin] в состояние [status]",
      "BLOCK_1719071535530": "Адресный свтодиод, красный [red]  зеленый [green]   синий [blue] ",
      "BLOCK_1721321922207": "Выключить звуковой сигнал",
      "base": "Контроллер",
      "BLOCK_1698789325358_IR_PORT_0": "1",
      "BLOCK_1698789325358_IR_PORT_1": "2",
      "BLOCK_1698789325358_IR_PORT_2": "3",
      "BLOCK_1698789325358_IR_PORT_3": "4",
      "BLOCK_1698789325358_IR_PORT_4": "5",
      "BLOCK_1698789325358_IR_PORT_5": "6",
      "BLOCK_1698789325358_IR_PORT_6": "7",
      "BLOCK_1698789325358_IR_PORT_7": "8",
      "BLOCK_1698789325358_IR_PORT_8": "9",
      "BLOCK_1698789325358_IR_PORT_9": "10",
      "BLOCK_1698789325358_IR_PORT_10": "11",
      "BLOCK_1698789325358_IR_PORT_11": "12",
      "BLOCK_1698789325358": "Расстояние с ИК-дальномера на [ir_port]  порту",
      "BLOCK_1699086551609_AXIS_0": "X",
      "BLOCK_1699086551609_AXIS_1": "Y",
      "BLOCK_1699086551609_AXIS_2": "Z",
      "BLOCK_1699086551609": "Ускорение по оси [axis] м/c^2 ",
      "ACCELEROMETR_AXIS_0": "X",
      "ACCELEROMETR_AXIS_1": "Y",
      "ACCELEROMETR_AXIS_2": "Z",
      "accelerometr": "Угловая скорость [axis] */с",
      "sensors": "Сенсоры",
      "when_core_started": "Когда контроллер запущен"
    }
  };
  const codeSnippets = {
    arduinoc: {}
  };
  const extGenerators = [{
    lang: 'arduinoc',
    template: `// generated by mBlock5 for Renics Motherboard
// codes make you happy

//( include //)
#include <Arduino.h>
//( lib //)

//({
    this.$ALL_VARIABLES.length==0?'':this.$ALL_VARIABLES.map(v=>"float "+v+" = 0;").join('\\n')
}//)

//( declare //)


void _delay(float seconds) {
  long endTime = millis() + seconds * 1000;
  while(millis() < endTime) _loop();
}

//(
void setup() {
  //( setup //)
  //( code //)
}
//)

void _loop() {
  //( _loop //)
}

void loop() {
  _loop();
}`,
    splitor: {
      frame: {
        left: "//(",
        right: "//)"
      },
      expression: {
        left: "/*{",
        right: "}*/"
      }
    },
    reducers: [{
      name: 'include',
      reduce: codes => {
        let codes1 = [];

        for (let code of codes) {
          let codeStr = '';

          if (typeof code === 'string') {
            codeStr = code;
          } else if (typeof code === 'function') {
            codeStr = code();
          }

          if (codes1.indexOf(codeStr) === -1) {
            codes1.push(codeStr);
          }
        }

        if (codes1.length === 0) {
          return undefined;
        }

        return codes1.map(code => {
          return '#include ' + code;
        }).join('\n') + '\n';
      }
    }]
  }];
  const extSources = {
    arduino: [{
      filename: "FastLED-2-final/chipsets.h",
      code: "#ifndef __INC_CHIPSETS_H\n#define __INC_CHIPSETS_H\n\n#include \"pixeltypes.h\"\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// LPD8806 controller class - takes data/clock/select pin values (N.B. should take an SPI definition?)\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, uint8_t CLOCK_PIN, EOrder RGB_ORDER = RGB,  uint8_t SPI_SPEED = DATA_RATE_MHZ(24) >\nclass LPD8806Controller : public CLEDController {\n\ttypedef SPIOutput<DATA_PIN, CLOCK_PIN, SPI_SPEED> SPI;\n\n\tclass LPD8806_ADJUST {\n\tpublic:\n\t\t// LPD8806 spec wants the high bit of every rgb data byte sent out to be set.\n\t\t__attribute__((always_inline)) inline static uint8_t adjust(register uint8_t data) { return (data>>1) | 0x80; }\n\t\t__attribute__((always_inline)) inline static uint8_t adjust(register uint8_t data, register uint8_t scale) { return (scale8(data, scale)>>1) | 0x80; }\n\t\t__attribute__((always_inline)) inline static void postBlock(int len) { \n\t\t\tSPI::writeBytesValueRaw(0, ((len+63)>>6));\n\t\t}\n\n\t};\n\n\tSPI mSPI;\n\tint mClearedLeds;\n\n\tvoid checkClear(int nLeds) { \n\t\tif(nLeds > mClearedLeds) { \n\t\t\tclearLine(nLeds);\n\t\t\tmClearedLeds = nLeds;\n\t\t}\n\t}\n\t\n\tvoid clearLine(int nLeds) { \n\t\tint n = ((nLeds  + 63) >> 6);\n\t\tmSPI.writeBytesValue(0, n);\n\t}\npublic:\n\tLPD8806Controller()  {}\n\tvirtual void init() {\n\t\tmSPI.init();\n\t\tmClearedLeds = 0;\n\t}\n\n\tvirtual void clearLeds(int nLeds) { \n\t\tmSPI.select();\n\t\tmSPI.writeBytesValueRaw(0x80, nLeds * 3);\t\n\t\tmSPI.writeBytesValueRaw(0, ((nLeds*3+63)>>6));\n\t\tmSPI.release();\n\t}\n\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tmSPI.select();\n\t\tuint8_t a = 0x80 | (scale8(data[RGB_BYTE0(RGB_ORDER)], scale) >> 1);\n\t\tuint8_t b = 0x80 | (scale8(data[RGB_BYTE1(RGB_ORDER)], scale) >> 1);\n\t\tuint8_t c = 0x80 | (scale8(data[RGB_BYTE2(RGB_ORDER)], scale) >> 1);\n\t\tint iLeds = 0;\n\n\t\twhile(iLeds++ < nLeds) { \n\t\t\tmSPI.writeByte(a);\n\t\t\tmSPI.writeByte(b);\n\t\t\tmSPI.writeByte(c);\n\t\t}\n\n\t\t// latch in the world\n\t\tmSPI.writeBytesValueRaw(0, ((nLeds*3+63)>>6));\n\t\tmSPI.release();\n\t}\n\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale = 255) {\n\t\tmSPI.template writeBytes3<LPD8806_ADJUST, RGB_ORDER>((byte*)data, nLeds * 3, scale);\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void show(const struct CARGB *data, int nLeds, uint8_t scale) {\n\t\tcheckClear(nLeds);\n\t\tmSPI.template writeBytes3<1, LPD8806_ADJUST, RGB_ORDER>((byte*)data, nLeds * 4, scale);\n\t}\n#endif\n};\n\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// WS2801 definition - takes data/clock/select pin values (N.B. should take an SPI definition?)\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, uint8_t CLOCK_PIN, EOrder RGB_ORDER = RGB, uint8_t SPI_SPEED = DATA_RATE_MHZ(1)>\nclass WS2801Controller : public CLEDController {\n\ttypedef SPIOutput<DATA_PIN, CLOCK_PIN, SPI_SPEED> SPI;\n\tSPI mSPI;\n\tCMinWait<500>  mWaitDelay;\npublic:\n\tWS2801Controller() {}\n\n\tvirtual void init() { \n\t\tmSPI.init();\n\t    mWaitDelay.mark();\n\t}\n\n\tvirtual void clearLeds(int nLeds) { \n\t\tmWaitDelay.wait();\n\t\tmSPI.writeBytesValue(0, nLeds*3);\n\t\tmWaitDelay.mark();\n\t}\n\t\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tmWaitDelay.wait();\n\t\tmSPI.select();\n\t\tuint8_t a = scale8(data[RGB_BYTE0(RGB_ORDER)], scale);\n\t\tuint8_t b = scale8(data[RGB_BYTE1(RGB_ORDER)], scale);\n\t\tuint8_t c = scale8(data[RGB_BYTE2(RGB_ORDER)], scale);\n\n\t\twhile(nLeds--) { \n\t\t\tmSPI.writeByte(a);\n\t\t\tmSPI.writeByte(b);\n\t\t\tmSPI.writeByte(c);\n\t\t}\n\t\tmSPI.waitFully();\n\t\tmSPI.release();\n\t\tmWaitDelay.mark();\n\t}\n\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale) {\n\t\tmWaitDelay.wait();\n\t\tmSPI.template writeBytes3<0, RGB_ORDER>((byte*)data, nLeds * 3, scale);\n\t\tmWaitDelay.mark();\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale) {\n\t\tmWaitDelay.wait();\n\t\tmSPI.template writeBytes3<1, RGB_ORDER>((byte*)data, nLeds * 4, scale);\n\t\tmWaitDelay.mark();\n\t}\n#endif\n};\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// SM16716 definition - takes data/clock/select pin values (N.B. should take an SPI definition?)\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, uint8_t CLOCK_PIN, EOrder RGB_ORDER = RGB, uint8_t SPI_SPEED = DATA_RATE_MHZ(16)>\nclass SM16716Controller : public CLEDController {\n\ttypedef SPIOutput<DATA_PIN, CLOCK_PIN, SPI_SPEED> SPI;\n\tSPI mSPI;\n\n\tvoid writeHeader() { \n\t\t// Write out 50 zeros to the spi line (6 blocks of 8 followed by two single bit writes)\n\t\tmSPI.select();\n\t\tmSPI.writeBytesValueRaw(0, 6);\n\t\tmSPI.waitFully();\n\t\tmSPI.template writeBit<0>(0);\n\t\tmSPI.template writeBit<0>(0);\n\t\tmSPI.release();\n\t}\n\npublic:\n\tSM16716Controller() {}\n\n\tvirtual void init() { \n\t\tmSPI.init();\n\t}\n\n\tvirtual void clearLeds(int nLeds) { \n\t\tmSPI.select();\n\t\twhile(nLeds--) { \n\t\t\tmSPI.template writeBit<0>(1);\n\t\t\tmSPI.writeByte(0);\n\t\t\tmSPI.writeByte(0);\n\t\t\tmSPI.writeByte(0);\n\t\t}\n\t\tmSPI.waitFully();\n\t\tmSPI.release();\n\t\twriteHeader();\n\t}\n\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tmSPI.select();\n\t\tuint8_t a = scale8(data[RGB_BYTE0(RGB_ORDER)], scale);\n\t\tuint8_t b = scale8(data[RGB_BYTE1(RGB_ORDER)], scale);\n\t\tuint8_t c = scale8(data[RGB_BYTE2(RGB_ORDER)], scale);\n\n\t\twhile(nLeds--) { \n\t\t\tmSPI.template writeBit<0>(1);\n\t\t\tmSPI.writeByte(a);\n\t\t\tmSPI.writeByte(b);\n\t\t\tmSPI.writeByte(c);\n\t\t}\n\t\twriteHeader();\n\t\tmSPI.release();\n\t}\n\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale = 255) {\n\t\t// Make sure the FLAG_START_BIT flag is set to ensure that an extra 1 bit is sent at the start\n\t\t// of each triplet of bytes for rgb data\n\t\t// writeHeader();\n\t\tmSPI.template writeBytes3<FLAG_START_BIT, RGB_ORDER>((byte*)data, nLeds * 3, scale);\n\t\twriteHeader();\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void show(const struct CARGB *data, int nLeds, uint8_t scale = 255) {\n\t\tmSPI.writeBytesValue(0, 6);\n\t\tmSPI.template writeBit<0>(0);\n\t\tmSPI.template writeBit<0>(0);\n\n\t\t// Make sure the FLAG_START_BIT flag is set to ensure that an extra 1 bit is sent at the start\n\t\t// of each triplet of bytes for rgb data\n\t\tmSPI.template writeBytes3<1 | FLAG_START_BIT, RGB_ORDER>((byte*)data, nLeds * 4, scale);\n\t}\n#endif\n};\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Clockless template instantiations - see clockless.h for how the timing values are used\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\n#if defined(LIB8_ATTINY) && (F_CPU == 8000000)\n// WS2811@8Mhz 2 clocks, 5 clocks, 3 clocks\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller800Khz : public ClocklessController_Trinket<DATA_PIN, 2, 5, 3, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller400Khz : public ClocklessController_Trinket<DATA_PIN, 4, 10, 6, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass UCS1903Controller400Khz : public ClocklessController_Trinket<DATA_PIN, 4, 12, 4, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1809Controller800Khz : public ClocklessController<DATA_PIN, 2, 5, 3, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1803Controller400Khz : public ClocklessController<DATA_PIN, 6, 6, 6, RGB_ORDER> {};\n\n#elif defined(LIB8_ATTINY) && (F_CPU == 16000000)\n\n// WS2811@16Mhz 4 clocks, 10 clocks, 6 clocks\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller800Khz : public ClocklessController_Trinket<DATA_PIN, 4, 10, 6, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller400Khz : public ClocklessController_Trinket<DATA_PIN, 8, 20, 12, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass UCS1903Controller400Khz : public ClocklessController_Trinket<DATA_PIN, 8, 24, 8, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1809Controller800Khz : public ClocklessController<DATA_PIN, 4, 10, 6, RGB_ORDER> {};\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1803Controller400Khz : public ClocklessController<DATA_PIN, 12, 12, 12, RGB_ORDER> {};\n\n#else\n// UCS1903 - 500ns, 1500ns, 500ns\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass UCS1903Controller400Khz : public ClocklessController<DATA_PIN, NS(500), NS(1500), NS(500), RGB_ORDER> {};\n#if NO_TIME(500, 1500, 500) \n#warning \"Not enough clock cycles available for the UCS103\"\n#endif\n\n// TM1809 - 350ns, 350ns, 550ns\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1809Controller800Khz : public ClocklessController<DATA_PIN, NS(350), NS(350), NS(550), RGB_ORDER> {};\n#if NO_TIME(350, 350, 550) \n#warning \"Not enough clock cycles available for the TM1809\"\n#endif\n\n// WS2811 - 400ns, 400ns, 450ns \ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller800Khz : public ClocklessController<DATA_PIN, NS(400), NS(400), NS(450), RGB_ORDER> {};\n#if NO_TIME(400, 400, 450) \n#warning \"Not enough clock cycles available for the WS2811 (800khz)\"\n#endif\n\n// WS2811@400khz - 800ns, 800ns, 900ns \ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass WS2811Controller400Khz : public ClocklessController<DATA_PIN, NS(800), NS(800), NS(900), RGB_ORDER> {};\n#if NO_TIME(800, 800, 900) \n#warning \"Not enough clock cycles available for the WS2811 (400Khz)\"\n#endif\n\n// 750NS, 750NS, 750NS\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB>\nclass TM1803Controller400Khz : public ClocklessController<DATA_PIN, NS(750), NS(750), NS(750), RGB_ORDER> {};\n#if NO_TIME(750, 750, 750) \n#warning \"Not enough clock cycles available for the UCS103\"\n#endif\n#endif\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/clockless.h",
      code: "#ifndef __INC_CLOCKLESS_H\n#define __INC_CLOCKLESS_H\n\n#include \"controller.h\"\n#include \"lib8tion.h\"\n#include \"delay.h\"\n#include <avr/interrupt.h> // for cli/se definitions\n\n// Scaling macro choice\n#if defined(LIB8_ATTINY)\n#  define INLINE_SCALE(B, SCALE) delaycycles<3>()\n#  warning \"No hardware multiply, inline brightness scaling disabled\"\n#else\n#   define INLINE_SCALE(B, SCALE) B = scale8_LEAVING_R1_DIRTY(B, SCALE)\n#endif\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Base template for clockless controllers.  These controllers have 3 control points in their cycle for each bit.  The first point\n// is where the line is raised hi.  The second point is where the line is dropped low for a zero.  The third point is where the \n// line is dropped low for a one.  T1, T2, and T3 correspond to the timings for those three in clock cycles.\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, int T1, int T2, int T3, EOrder RGB_ORDER = RGB, int WAIT_TIME = 50>\nclass ClocklessController : public CLEDController {\n\ttypedef typename FastPin<DATA_PIN>::port_ptr_t data_ptr_t;\n\ttypedef typename FastPin<DATA_PIN>::port_t data_t;\n\n\tdata_t mPinMask;\n\tdata_ptr_t mPort;\n\tCMinWait<WAIT_TIME> mWait;\npublic:\n\tvirtual void init() { \n\t\tFastPin<DATA_PIN>::setOutput();\n\t\tmPinMask = FastPin<DATA_PIN>::mask();\n\t\tmPort = FastPin<DATA_PIN>::port();\n\t}\n\n\n\tvirtual void clearLeds(int nLeds) {\n\t\tshowColor(CRGB(0, 0, 0), nLeds, 0);\n\t}\n\n\t// set all the leds on the controller to a given color\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tmWait.wait();\n\t\tcli();\n\n\t\tshowRGBInternal<0, false>(nLeds, scale, (const byte*)&data);\n\n\t\t// Adjust the timer\n\t\tlong microsTaken = CLKS_TO_MICROS((long)nLeds * 24 * (T1 + T2 + T3));\n\t\tMS_COUNTER += (microsTaken / 1000);\n\t\tsei();\n\t\tmWait.mark();\n\t}\n\n\tvirtual void show(const struct CRGB *rgbdata, int nLeds, uint8_t scale = 255) { \n\t\tmWait.wait();\n\t\tcli();\n\n\t\tshowRGBInternal<0, true>(nLeds, scale, (const byte*)rgbdata);\n\n\t\t// Adjust the timer\n\t\tlong microsTaken = CLKS_TO_MICROS((long)nLeds * 24 * (T1 + T2 + T3));\n\t\tMS_COUNTER += (microsTaken / 1000);\n\t\tsei();\n\t\tmWait.mark();\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void show(const struct CARGB *rgbdata, int nLeds, uint8_t scale = 255) { \n\t\tmWait.wait();\n\t\tcli();\n\n\t\tshowRGBInternal<1, true>(nLeds, scale, (const byte*)rgbdata);\n\n\t\t// Adjust the timer\n\t\tlong microsTaken = CLKS_TO_MICROS((long)nLeds * 24 * (T1 + T2 + T3));\n\t\tMS_COUNTER += (microsTaken / 1000);\n\t\tsei();\n\t\tmWait.mark();\n\t}\n#endif\n\n#if defined(__MK20DX128__)\n\tinline static void write8Bits(register data_ptr_t port, register data_t hi, register data_t lo, register uint32_t & b)  __attribute__ ((always_inline)) {\n\t\t// TODO: hand rig asm version of this method.  The timings are based on adjusting/studying GCC compiler ouptut.  This\n\t\t// will bite me in the ass at some point, I know it.\n\t\tfor(register uint32_t i = 7; i > 0; i--) { \n\t\t\tFastPin<DATA_PIN>::fastset(port, hi);\n\t\t\tdelaycycles<T1 - 5>(); // 5 cycles - 2 store, 1 and, 1 test, 1 if\n\t\t\tif(b & 0x80) { FastPin<DATA_PIN>::fastset(port, hi); } else { FastPin<DATA_PIN>::fastset(port, lo); }\n\t\t\tb <<= 1;\n\t\t\tdelaycycles<T2 - 2>(); // 2 cycles,  1 store/skip,  1 shift \n\t\t\tFastPin<DATA_PIN>::fastset(port, lo);\n\t\t\tdelaycycles<T3 - 5>(); // 3 cycles, 2 store, 1 sub, 1 branch backwards\n\t\t}\n\t\t// delay an extra cycle because falling out of the loop takes on less cycle than looping around\n\t\tdelaycycles<1>();\n\n\t\tFastPin<DATA_PIN>::fastset(port, hi);\n\t\tdelaycycles<T1 - 6>();\n\t\tif(b & 0x80) { FastPin<DATA_PIN>::fastset(port, hi); } else { FastPin<DATA_PIN>::fastset(port, lo); }\n\t\tdelaycycles<T2 - 2>(); // 4 cycles, 2 store, store/skip\n\t\tFastPin<DATA_PIN>::fastset(port, lo);\n\t}\n\n\t// This method is made static to force making register Y available to use for data on AVR - if the method is non-static, then \n\t// gcc will use register Y for the this pointer.\n\ttemplate<int SKIP, bool ADVANCE> static void showRGBInternal(register int nLeds, register uint8_t scale, register const byte *rgbdata) {\n\t\tregister byte *data = (byte*)rgbdata;\n\t\tregister data_t mask = FastPin<DATA_PIN>::mask();\n\t\tregister data_ptr_t port = FastPin<DATA_PIN>::port();\n\t\tnLeds *= (3 + SKIP);\n\t\tregister uint8_t *end = data + nLeds; \n\t\tregister data_t hi = *port | mask;\n\t\tregister data_t lo = *port & ~mask;\n\t\t*port = lo;\n\n\t\tregister uint32_t b;\n\t\tb = ((ADVANCE)?data:rgbdata)[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\tb = scale8(b, scale);\n\t\twhile(data < end) { \n\t\t\t// Write first byte, read next byte\n\t\t\twrite8Bits(port, hi, lo, b);\n\n\t\t\tb = ((ADVANCE)?data:rgbdata)[SKIP + RGB_BYTE1(RGB_ORDER)];\n\t\t\tINLINE_SCALE(b, scale);\n\t\t\tdelaycycles<T3 - 5>(); // 1 store, 2 load, 1 mul, 1 shift, \n\n\t\t\t// Write second byte\n\t\t\twrite8Bits(port, hi, lo, b);\n\n\t\t\tb = ((ADVANCE)?data:rgbdata)[SKIP + RGB_BYTE2(RGB_ORDER)];\n\t\t\tINLINE_SCALE(b, scale);\n\n\t\t\tdata += 3 + SKIP;\n\t\t\tif((RGB_ORDER & 0070) == 0) {\n\t\t\t\tdelaycycles<T3 - 6>(); // 1 store, 2 load, 1 mul, 1 shift,  1 adds if BRG or GRB\n\t\t\t} else {\n\t\t\t\tdelaycycles<T3 - 5>(); // 1 store, 2 load, 1 mul, 1 shift, \n\t\t\t}\n\n\t\t\t// Write third byte\n\t\t\twrite8Bits(port, hi, lo, b);\n\n\t\t\tb = ((ADVANCE)?data:rgbdata)[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\t\tINLINE_SCALE(b, scale);\n\n\t\t\tdelaycycles<T3 - 11>(); // 1 store, 2 load (with increment), 1 mul, 1 shift, 1 cmp, 1 branch backwards, 1 movim\n\t\t};\n\t}\n\n#else // AVR loop/implementation\n\n\ttemplate <int N, int ADJ>inline static void bitSetLast(register data_ptr_t port, register data_t hi, register data_t lo, register uint8_t b) { \n\t\t// First cycle\n\t\tFastPin<DATA_PIN>::fastset(port, hi); \t\t\t\t\t\t\t// 1 clock cycle if using out, 2 otherwise\n\t\tdelaycycles<T1 - (_CYCLES(DATA_PIN))>();\t\t\t\t\t// 1st cycle length minus 1 clock for out, 1 clock for sbrs\n\t\t__asm__ __volatile__ (\"sbrs %0, %1\" :: \"r\" (b), \"M\" (N) :); // 1 clock for check (+1 if skipping, next op is also 1 clock)\n\n\t\t// Second cycle\n\t\tFastPin<DATA_PIN>::fastset(port, lo);\t\t\t\t\t\t\t// 1/2 clock cycle if using out\n\t\tdelaycycles<T2 - (_CYCLES(DATA_PIN))>(); \t\t\t\t\t\t// 2nd cycle length minus 1/2 clock for out\n\n\t\t// Third cycle\n\t\tFastPin<DATA_PIN>::fastset(port, lo);\t\t\t\t\t\t\t// 1/2 clock cycle if using out\n\t\tdelaycycles<T3 - (_CYCLES(DATA_PIN) + ADJ)>();\t\t\t\t// 3rd cycle length minus the passed in adjustment \n\t}\n\n\t// This method is made static to force making register Y available to use for data on AVR - if the method is non-static, then \n\t// gcc will use register Y for the this pointer.\n\ttemplate<int SKIP, bool ADVANCE> static void showRGBInternal(register int nLeds, register uint8_t scale, register const byte *rgbdata) {\n\t\tregister byte *data = (byte*)rgbdata;\n\t\tregister data_t mask = FastPin<DATA_PIN>::mask();\n\t\tregister data_ptr_t port = FastPin<DATA_PIN>::port();\n\t\tnLeds *= (3 + SKIP);\n\t\tregister uint8_t *end = data + nLeds; \n\t\tregister data_t hi = *port | mask;\n\t\tregister data_t lo = *port & ~mask;\n\t\t*port = lo;\n\n#if 0\n\t\tregister uint8_t b = *data++;\n\t\twhile(data <= end) { \n\t\t\tbitSetFast<7>(port, hi, lo, b);\n\t\t\tbitSetFast<6>(port, hi, lo, b);\n\t\t\tbitSetFast<5>(port, hi, lo, b);\n\t\t\tbitSetFast<4>(port, hi, lo, b);\n\t\t\tbitSetFast<3>(port, hi, lo, b);\n\t\t\t// Leave an extra 2 clocks for the next byte load\n\t\t\tbitSetLast<2, 2>(port, hi, lo, b);\n\t\t\tregister uint8_t next = *data++;\n\t\t\t// Leave an extra 4 clocks for the scale\n\t\t\tbitSetLast<1, 4>(port, hi, lo, b);\n\t\t\tnext = scale8(next, scale);\n\t\t\tbitSetLast<0, END_OF_LOOP>(port, hi, lo, b);\n\t\t\tb = next;\n\t\t}\n#else\n\t\tregister uint8_t b;\n\n\t\tif(ADVANCE) { \n\t\t\tb = data[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\t} else { \n\t\t\tb = rgbdata[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\t}\n\t\tb = scale8_LEAVING_R1_DIRTY(b, scale);\n\n\t\tregister uint8_t c;\n\t\tregister uint8_t d;\n\t\twhile(data < end) { \n\t\t\tfor(register byte x=5; x; x--) {\n\t\t\t\tbitSetLast<7, 4>(port, hi, lo, b);\n\t\t\t\tb <<= 1;\n\t\t\t}\n\t\t\tdelaycycles<1>();\n\t\t\tbitSetLast<7, 1>(port, hi, lo, b);\n\t\t\tdelaycycles<1>();\n\n\t\t\t// Leave an extra 4 clocks for the load/scale\n\t\t\tbitSetLast<6, 6>(port, hi, lo, b);\n\t\t\tif(ADVANCE) { \n\t\t\t\tc = data[SKIP + RGB_BYTE1(RGB_ORDER)];\n\t\t\t} else { \n\t\t\t\tc = rgbdata[SKIP + RGB_BYTE1(RGB_ORDER)];\n\t\t\t\tdelaycycles<1>();\n\t\t\t}\n\t\t\tINLINE_SCALE(c, scale);\n\t\t\tbitSetLast<5, 1>(port, hi, lo, b);\n\t\t\t\n\t\t\tfor(register byte x=5; x; x--) {\n\t\t\t\tbitSetLast<7, 4>(port, hi, lo, c);\n\t\t\t\tc <<= 1;\n\t\t\t}\n\t\t\tdelaycycles<1>();\n\t\t\tbitSetLast<7, 1>(port, hi, lo, c);\n\t\t\tdelaycycles<1>();\n\t\t\t\n\t\t\t// Leave an extra 4 clocks for the load/scale\n\t\t\tbitSetLast<6, 6>(port, hi, lo, c);\n\t\t\tif(ADVANCE) { \n\t\t\t\td = data[SKIP + RGB_BYTE2(RGB_ORDER)];\n\t\t\t} else { \n\t\t\t\td = rgbdata[SKIP + RGB_BYTE2(RGB_ORDER)];\n\t\t\t\tdelaycycles<1>();\n\t\t\t}\n\t\t\tINLINE_SCALE(d, scale);\n\t\t\tbitSetLast<5, 1>(port, hi, lo, c);\n\t\t\t\n\t\t\tfor(register byte x=5; x; x--) {\n\t\t\t\tbitSetLast<7, 4>(port, hi, lo, d);\n\t\t\t\td <<= 1;\n\t\t\t}\n\t\t\tdelaycycles<1>();\n\t\t\t// Leave an extra clock for the data pointer advance\n\t\t\tbitSetLast<7, 2>(port, hi, lo, d);\n\t\t\tdata += (SKIP + 3);\n\t\t\t// Leave an extra 4 clocks for the load/scale\n\t\t\tbitSetLast<6, 6>(port, hi, lo, d);\n\t\t\tif(ADVANCE) { \n\t\t\t\tb = data[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\t\t} else { \n\t\t\t\tb = rgbdata[SKIP + RGB_BYTE0(RGB_ORDER)];\n\t\t\t\tdelaycycles<1>();\n\t\t\t}\n\t\t\tINLINE_SCALE(b, scale);\n\t\t\tbitSetLast<5, 6>(port, hi, lo, d);\n\t\t}\n\t\tcleanup_R1();\n#endif\n\t}\n#endif\n#ifdef SUPPORT_ARGB\n\tvirtual void showARGB(struct CARGB *data, int nLeds) { \n\t\t// TODO: IMPLEMENTME\n\t}\n#endif\n};\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/clockless_trinket.h",
      code: "#ifndef __INC_CLOCKLESS_TRINKET_H\n#define __INC_CLOCKLESS_TRINKET_H\n\n#include \"controller.h\"\n#include \"lib8tion.h\"\n#include \"delay.h\"\n#include <avr/interrupt.h> // for cli/se definitions\n\n\n// Scaling macro choice\n#ifndef TRINKET_SCALE\n#define TRINKET_SCALE 1\n#endif\n\n// Variations on the functions in delay.h - w/a loop var passed in to preserve registers across calls by the optimizer/compiler\ntemplate<int CYCLES> inline void _dc(register uint8_t & loopvar);\n\ntemplate<int _LOOP, int PAD> inline void _dc_AVR(register uint8_t & loopvar) { \n\t_dc<PAD>(loopvar);\n\tasm __volatile__ ( \"LDI %[loopvar], %[_LOOP]\\n\\tL_%=: DEC %[loopvar]\\n\\t BRNE L_%=\\n\\t\" : \n\t\t\t\t\t\t\t[loopvar] \"+a\" (loopvar) : [_LOOP] \"M\" (_LOOP) : );\n}\n\ntemplate<int CYCLES> __attribute__((always_inline)) inline void _dc(register uint8_t & loopvar) { \n\t_dc_AVR<CYCLES/3,CYCLES%3>(loopvar);\n}\ntemplate<> __attribute__((always_inline)) inline void _dc<0>(register uint8_t & loopvar) {}\ntemplate<> __attribute__((always_inline)) inline void _dc<1>(register uint8_t & loopvar) {asm __volatile__(\"cp r0,r0\":::);}\ntemplate<> __attribute__((always_inline)) inline void _dc<2>(register uint8_t & loopvar) {asm __volatile__(\"rjmp .+0\":::);}\n\n#define D1(ADJ) _dc<T1-(2+ADJ)>(loopvar);\n#define D2(ADJ) _dc<T2-(1+ADJ)>(loopvar);\n#define D3(ADJ) _dc<T3-(1+ADJ)>(loopvar);\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Base template for clockless controllers.  These controllers have 3 control points in their cycle for each bit.  The first point\n// is where the line is raised hi.  The second point is where the line is dropped low for a zero.  The third point is where the \n// line is dropped low for a one.  T1, T2, and T3 correspond to the timings for those three in clock cycles.\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, int T1, int T2, int T3, EOrder RGB_ORDER = RGB, int WAIT_TIME = 50>\nclass ClocklessController_Trinket : public CLEDController {\n\ttypedef typename FastPin<DATA_PIN>::port_ptr_t data_ptr_t;\n\ttypedef typename FastPin<DATA_PIN>::port_t data_t;\n\n\tCMinWait<WAIT_TIME> mWait;\npublic:\n\tvirtual void init() { \n\t\tFastPin<DATA_PIN>::setOutput();\n\t}\n\n\tvirtual void clearLeds(int nLeds) {\n\t\tstatic byte zeros[3] = {0,0,0};\n\t\tshowRGBInternal_AdjTime(0, false, nLeds, 0, zeros);\n\t}\n\n\t// set all the leds on the controller to a given color\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tshowRGBInternal_AdjTime(0, false, nLeds, scale, (const byte*)&data);\n\t}\n\n\tvirtual void show(const struct CRGB *rgbdata, int nLeds, uint8_t scale = 255) { \n\t\tshowRGBInternal_AdjTime(0, true, nLeds, scale, (const byte*)rgbdata);\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void show(const struct CARGB *rgbdata, int nLeds, uint8_t scale = 255) { \n\t\tshowRGBInternal_AdjTime(1, true, nLeds, scale, (const byte*)rgbdata);\n\t}\n#endif\n\n\tvoid __attribute__ ((noinline)) showRGBInternal_AdjTime(int skip, bool advance, int nLeds, uint8_t scale,  const byte *rgbdata) {\n\t\tmWait.wait();\n\t\tcli();\n\n\t\tshowRGBInternal(skip, advance, nLeds, scale, rgbdata);\n\n\n\t\t// Adjust the timer\n\t\tlong microsTaken = CLKS_TO_MICROS((long)nLeds * 24 * (T1 + T2 + T3));\n\t\tMS_COUNTER += (microsTaken / 1000);\n\t\tsei();\n\t\tmWait.mark();\n\t}\n\n#define USE_ASM_MACROS\n\n#define ASM_VARS : /* write variables */\t\t\t\t\\\n\t\t\t\t[b0] \"+r\" (b0),\t\t\t\t\t\t\t\\\n\t\t\t\t[b1] \"+r\" (b1),\t\t\t\t\t\t\t\\\n\t\t\t\t[b2] \"+r\" (b2),\t\t\t\t\t\t\t\\\n\t\t\t\t[count] \"+x\" (count),\t\t\t\t\t\\\n\t\t\t\t[scale_base] \"+r\" (scale_base),\t\t\t\\\n\t\t\t\t[data] \"+z\" (data),\t\t\t\t\t\t\\\n\t\t\t\t[loopvar] \"+a\" (loopvar)\t\t\t\t\\\n\t\t\t\t: /* use variables */\t\t\t\t\t\\\n\t\t\t\t[hi] \"r\" (hi),\t\t\t\t\t\t\t\\\n\t\t\t\t[lo] \"r\" (lo),\t\t\t\t\t\t\t\\\n\t\t\t\t[scale] \"r\" (scale),\t\t\t\t\t\\\n\t\t\t\t[ADV] \"r\" (advanceBy),\t\t\t\t\t\\\n\t\t\t\t[zero] \"r\" (zero),\t\t\t\t\t\t\\\n\t\t\t\t[O0] \"M\" (RGB_BYTE0(RGB_ORDER)),\t\t\\\n\t\t\t\t[O1] \"M\" (RGB_BYTE1(RGB_ORDER)),\t\t\\\n\t\t\t\t[O2] \"M\" (RGB_BYTE2(RGB_ORDER)),\t\t\\\n\t\t\t\t[PORT] \"M\" (FastPin<DATA_PIN>::port()-0x20)\t\t\t\t\t\t\\\n\t\t\t\t: /* clobber registers */\t\t\t\t\n\n\n// 1 cycle, write hi to the port\n#define HI1 asm __volatile__(\"out %[PORT], %[hi]\" ASM_VARS );\n// 1 cycle, write lo to the port\n#define LO1 asm __volatile__(\"out %[PORT], %[lo]\" ASM_VARS );\n// 2 cycles, sbrs on flipping the lne to lo if we're pushing out a 0\n#define QLO2(B, N) asm __volatile__(\"sbrs %[\" #B \"], \" #N ASM_VARS ); LO1;\n// load a byte from ram into the given var with the given offset\n#define LD2(B,O) asm __volatile__(\"ldd %[\" #B \"], Z + %[\" #O \"]\" ASM_VARS );\n// 3 cycles - load a byte from ram into the scaling scratch space with the given offset, clear the target var\n#define LDSCL3(B,O) asm __volatile__(\"ldd %[scale_base], Z + %[\" #O \"]\\n\\tclr %[\" #B \"]\" ASM_VARS );\n// 2 cycles - increment the data pointer\n#define IDATA2 asm __volatile__(\"add %A[data], %A[ADV]\\n\\tadc %B[data], %B[ADV]\"  ASM_VARS );\n// 2 cycles - decrement the counter\n#define DCOUNT2 asm __volatile__(\"sbiw %[count], 1\" ASM_VARS );\n// 2 cycles - jump to the beginning of the loop\n#define JMPLOOP2 asm __volatile__(\"rjmp 1b\" ASM_VARS );\n// 2 cycles - jump out of the loop\n#define BRLOOP1 asm __volatile__(\"breq 2f\" ASM_VARS );\n// 2 cycles - perform one step of the scaling (if a given bit is set in scale, add scale-base to the scratch space)\n#define SCALE2(B, N) asm __volatile__(\"sbrc %[scale], \" #N \"\\n\\tadd %[\" #B \"], %[scale_base]\" ASM_VARS );\n// 1 cycle - rotate right, pulling in from carry\n#define ROR1(B) asm __volatile__(\"ror %[\" #B \"]\" ASM_VARS );\n// 1 cycle, clear the carry bit\n#define CLC1 asm __volatile__(\"clc\" ASM_VARS );\n// 1 cycle, move one register to another\n#define MOV1(B1, B2) asm __volatile__(\"mov %[\" #B1 \"], %[\" #B2 \"]\" ASM_VARS );\n// 4 cycles, rotate, clear carry, scale next bit\n#define RORSC4(B, N) ROR1(B) CLC1 SCALE2(B, N)\n// 4 cycles, scale bit, rotate, clear carry\n#define SCROR4(B, N) SCALE2(B,N) ROR1(B) CLC1\n// define the beginning of the loop\n#define LOOP asm __volatile__(\"1:\" ASM_VARS );\n#define DONE asm __volatile__(\"2:\" ASM_VARS );\n// delay time\n\n\n\t// This method is made static to force making register Y available to use for data on AVR - if the method is non-static, then \n\t// gcc will use register Y for the this pointer.\n\tstatic void __attribute__ ((noinline)) showRGBInternal(int skip, bool advance, int nLeds, uint8_t scale,  const byte *rgbdata) {\n\t\tbyte *data = (byte*)rgbdata;\n\t\tdata_t mask = FastPin<DATA_PIN>::mask();\n\t\tdata_ptr_t port = FastPin<DATA_PIN>::port();\n\t\t// register uint8_t *end = data + nLeds; \n\t\tdata_t hi = *port | mask;\n\t\tdata_t lo = *port & ~mask;\n\t\t*port = lo;\n\n\t\tuint8_t b0, b1, b2;\n\t\tuint16_t count = nLeds;\n\t\tuint8_t scale_base = 0;\n\t\tuint16_t advanceBy = advance ? (skip+3) : 0;\n\t\tconst uint8_t zero = 0;\n\t\tb0 = data[RGB_BYTE0(RGB_ORDER)];\n\t\tb0 = scale8(b0, scale);\n\t\tb1 = data[RGB_BYTE1(RGB_ORDER)];\n\t\tb2 = 0;\n\t\tregister uint8_t loopvar;\n\n\t\tif(RGB_ORDER == RGB) {\n\t\t\t// If the rgb order is RGB, we can cut back on program space usage by making a much more compact\n\t\t\t// representation.\n\n\t\t\t// multiply count by 3, don't use * because there's no hardware multiply\n\t\t\tcount = count+(count<<1);\n\t\t\tadvanceBy = advance ? 1 : 0;\n\t\t\t{\n\t\t\t\t/* asm */\n\t\t\t\tLOOP\n\t\t\t\t// Sum of the clock counts across each row should be 10 for 8Mhz, WS2811\n#if TRINKET_SCALE\n\t\t\t\t// Inline scaling, RGB ordering matches byte ordering\n\t\t\t\tHI1\tD1(0) QLO2(b0, 7) LDSCL3(b1,O1) D2(3) \tLO1 SCALE2(b1,0) \tD3(2)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 6) RORSC4(b1,1) \tD2(4)\tLO1 ROR1(b1) CLC1 \tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 5) SCROR4(b1,2)\tD2(4)\tLO1 SCALE2(b1,3)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 4) RORSC4(b1,4) \tD2(4)\tLO1 ROR1(b1) CLC1\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 3) SCROR4(b1,5) \tD2(4)\tLO1 SCALE2(b1,6)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 2) RORSC4(b1,7) \tD2(4)\tLO1 ROR1(b1) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b0, 1) IDATA2 \t\tD2(2)\tLO1 \t\t\t\tD3(0)\n\t\t\t\t// In the last bit's first block, we decrement and branch to done if we decremented to 0\n\t\t\t\tHI1 D1(0) QLO2(b0, 0) DCOUNT2 BRLOOP1 MOV1(b0, b1) D2(4) \tLO1 D3(2) JMPLOOP2\n#else\n\t\t\t\t// no inline scaling, RGB ordering matches byte ordering\n\t\t\t\tHI1\tD1(0) QLO2(b0, 7) LD2(b1,O1)\tD2(2)\tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 6) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 5) \t\t\t\tD2(0)\tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 4) \t\t\t\tD2(0)\tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 3) \t\t\t\tD2(0)\tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 2) \t\t\t\tD2(0)\tLO1 D3(0)\n\t\t\t\tHI1 D1(0) QLO2(b0, 1) IDATA2 \t\tD2(2)\tLO1 D3(0)\n\t\t\t\t// In the last bit's first block, we decrement and branch to done if we decremented to 0\n\t\t\t\tHI1 D1(0) QLO2(b2, 0) DCOUNT2 BRLOOP1 MOV1(b0,b1) D2(4) LO1 D3(2) JMPLOOP2\t\n#endif\t\t\t\n\t\t\t\tDONE\n\t\t\t\tD2(4) LO1 D3(0)\n\t\t\t}\n\t\t} \n\t\telse\n\t\t{\n\t\t\t{\n\t\t\t\t/* asm */\n\t\t\t\tLOOP\n\t\t\t\t// Sum of the clock counts across each row should be 10 for 8Mhz, WS2811\n#if TRINKET_SCALE\n\t\t\t\t// Inline scaling - RGB ordering\n\t\t\t\tHI1 D1(0) QLO2(b0, 7) LDSCL3(b1,O1) \tD2(3)\tLO1 SCALE2(b1,0)\tD3(2)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 6) RORSC4(b1,1) \t\tD2(4)\tLO1 ROR1(b1) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b0, 5) SCROR4(b1,2)\t\tD2(4)\tLO1 SCALE2(b1,3)\tD3(2)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 4) RORSC4(b1,4) \t\tD2(4)\tLO1 ROR1(b1) CLC1\tD3(2)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 3) SCROR4(b1,5) \t\tD2(4)\tLO1 SCALE2(b1,6)\tD3(2)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 2) RORSC4(b1,7) \t\tD2(4)\tLO1 ROR1(b1) CLC1\tD3(2)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 1) \t\t\t\t \tD2(0)\tLO1 \t\t\t\tD3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 0) \t \t\t\t\tD2(0)\tLO1 \t\t\t\tD3(0)\n\t\t\t\tHI1\tD1(0) QLO2(b1, 7) LDSCL3(b2,O2) \tD2(3)\tLO1 SCALE2(b2,0)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 6) RORSC4(b2,1) \t\tD2(4)\tLO1 ROR1(b2) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b1, 5) SCROR4(b2,2)\t\tD2(4)\tLO1 SCALE2(b2,3)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 4) RORSC4(b2,4) \t\tD2(4)\tLO1 ROR1(b2) CLC1\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 3) SCROR4(b2,5) \t\tD2(4)\tLO1 SCALE2(b2,6)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 2) RORSC4(b2,7) \t\tD2(4)\tLO1 ROR1(b2) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b1, 1) \t \t\t\t\tD2(0)\tLO1 \t\t\t\tD3(0)\n\t\t\t\tHI1 D1(0) QLO2(b1, 0) IDATA2 \t\t\tD2(2) \tLO1 \t\t\t\tD3(0)\n\t\t\t\tHI1\tD1(0) QLO2(b2, 7) LDSCL3(b0,O0) \tD2(3)\tLO1 SCALE2(b0,0)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 6) RORSC4(b0,1) \t\tD2(4)\tLO1 ROR1(b0) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b2, 5) SCROR4(b0,2)\t\tD2(4)\tLO1 SCALE2(b0,3)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 4) RORSC4(b0,4) \t\tD2(4)\tLO1 ROR1(b0) CLC1\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 3) SCROR4(b0,5) \t\tD2(4)\tLO1 SCALE2(b0,6)\tD3(2)\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 2) RORSC4(b0,7) \t\tD2(4)\tLO1 ROR1(b0) CLC1\tD3(2)\n\t\t\t\tHI1 D1(0) QLO2(b2, 1) \t\t\t\t\tD2(0)\tLO1 \t\t\t\tD3(0)\n\t\t\t\tHI1 D1(0) QLO2(b2, 0) DCOUNT2 BRLOOP1 \tD2(3) \tLO1 D3(2) JMPLOOP2\t\n#else\n\t\t\t\t// no inline scaling - non-straight RGB ordering\n\t\t\t\tHI1\tD1(0) QLO2(b0, 7) LD2(b1,O1)\tD2(2)\tLO1 D3(0)\n\t\t\t\tHI1 D1(0) QLO2(b0, 6) \t\t\t\tD2(0) \tLO1 D3(0)\n\t\t\t\tHI1 D1(0) QLO2(b0, 5) \t\t\t\tD2(0) \tLO1 D3(0)\n\t\t\t\tHI1 D1(0) QLO2(b0, 4) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 3) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 2) \t\t\t\tD2(0)\tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 1) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b0, 0) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1\tD1(0) QLO2(b1, 7) LD2(b2,O2) \tD2(2)\tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 6) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 5) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 4) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 3) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 2) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 1) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b1, 0) IDATA2 \t\tD2(2)\tLO1 D3(0)\t\t\t\n\t\t\t\tHI1\tD1(0) QLO2(b2, 7) LD2(b0,O0) \tD2(2)\tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 6) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 5) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 4) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 3) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 2) \t\t\t\tD2(0) \tLO1 D3(0)\t\t\n\t\t\t\tHI1 D1(0) QLO2(b2, 1) \t\t\t\tD2(0) \tLO1 D3(0)\n\t\t\t\tHI1 D1(0) QLO2(b2, 0) DCOUNT2 BRLOOP1 D2(3) \t\tLO1 D3(2) JMPLOOP2\t\n#endif\t\t\t\n\t\t\t\tDONE\n\t\t\t\tD2(4) LO1 D3(0)\n\t\t\t}\n\t\t}\n\t}\n\n#ifdef SUPPORT_ARGB\n\tvirtual void showARGB(struct CARGB *data, int nLeds) { \n\t\t// TODO: IMPLEMENTME\n\t}\n#endif\n};\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/controller.h",
      code: "#ifndef __INC_CONTROLLER_H\n#define __INC_CONTROLLER_H\n\n#include <avr/io.h>\n#include \"pixeltypes.h\"\n\n\n#define RGB_BYTE0(X) ((X>>6) & 0x3) \n#define RGB_BYTE1(X) ((X>>3) & 0x3) \n#define RGB_BYTE2(X) ((X) & 0x3)\n\n// operator byte *(struct CRGB[] arr) { return (byte*)arr; }\n\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n// \n// LED Controller interface definition\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\n/// Base definition for an LED controller.  Pretty much the methods that every LED controller object will make available.  \n/// Note that the showARGB method is not impelemented for all controllers yet.   Note also the methods for eventual checking\n/// of background writing of data (I'm looking at you, teensy 3.0 DMA controller!).  If you want to pass LED controllers around\n/// to methods, make them references to this type, keeps your code saner.  However, most people won't be seeing/using these objects\n/// directly at all\nclass CLEDController { \npublic:\n\t// initialize the LED controller\n\tvirtual void init() = 0;\n\n\t// reset any internal state to a clean point\n\tvirtual void reset() { init(); } \n\n\t// clear out/zero out the given number of leds.\n\tvirtual void clearLeds(int nLeds) = 0;\n\n\t// set all the leds on the controller to a given color\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) = 0;\n\n\t// note that the uint8_ts will be in the order that you want them sent out to the device. \n\t// nLeds is the number of RGB leds being written to\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale = 255) = 0;\n\n#ifdef SUPPORT_ARGB\n\t// as above, but every 4th uint8_t is assumed to be alpha channel data, and will be skipped\n\tvirtual void show(const struct CARGB *data, int nLeds, uint8_t scale = 255) = 0;\n#endif\n\t\n\t// is the controller ready to write data out\n\tvirtual bool ready() { return true; }\n\n\t// wait until the controller is ready to write data out \n\tvirtual void wait() { return; }\n\n};\n\n#endif"
    }, {
      filename: "FastLED-2-final/delay.h",
      code: "#ifndef __INC_DELAY_H\n#define __INC_DELAY_H\n\n////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Clock cycle counted delay loop\n//\n////////////////////////////////////////////////////////////////////////////////////////////\n\n#if defined(__arm__) \n# define NOP __asm__ __volatile__ (\"nop\\n\");\n# define NOP2 __asm__ __volatile__ (\"nop\\n\\tnop\");\n#else\n#  define NOP __asm__ __volatile__ (\"cp r0,r0\\n\");\n#  define NOP2 __asm__ __volatile__ (\"rjmp .+0\");\n#endif\n\n// predeclaration to not upset the compiler\ntemplate<int CYCLES> inline void delaycycles();\n\n// TODO: ARM version of _delaycycles_\n// worker template - this will nop for LOOP * 3 + PAD cycles total\ntemplate<int LOOP, int PAD> inline void _delaycycles_AVR() { \n\tdelaycycles<PAD>();\n\t// the loop below is 3 cycles * LOOP.  the LDI is one cycle,\n\t// the DEC is 1 cycle, the BRNE is 2 cycles if looping back and\n\t// 1 if not (the LDI balances out the BRNE being 1 cycle on exit)\n\t__asm__ __volatile__ ( \n\t\t\"\t\tLDI R16, %0\\n\"\n\t\t\"L_%=:  DEC R16\\n\"\n\t\t\"\t\tBRNE L_%=\\n\"\n\t\t: /* no outputs */ \n\t\t: \"M\" (LOOP) \n\t\t: \"r16\"\n\t\t);\n}\n\n// usable definition\n#if !defined(__MK20DX128__)\ntemplate<int CYCLES> __attribute__((always_inline)) inline void delaycycles() { \n\t_delaycycles_AVR<CYCLES / 3, CYCLES % 3>();\t\n}\n#else\ntemplate<int CYCLES> __attribute__((always_inline)) inline void delaycycles() { \n\tNOP; delaycycles<CYCLES-1>();\n}\n#endif\n\n// pre-instantiations for values small enough to not need the loop, as well as sanity holders\n// for some negative values.\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-6>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-5>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-4>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-3>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-2>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<-1>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<0>() {}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<1>() {NOP;}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<2>() {NOP2;}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<3>() {NOP;NOP2;}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<4>() {NOP2;NOP2;}\ntemplate<> __attribute__((always_inline)) inline void delaycycles<5>() {NOP2;NOP2;NOP;}\n\n// Some timing related macros/definitions \n\n// Macro to convert from nano-seconds to clocks and clocks to nano-seconds\n// #define NS(_NS) (_NS / (1000 / (F_CPU / 1000000L)))\n#if F_CPU < 96000000\n#define NS(_NS) ( (_NS * (F_CPU / 1000000L))) / 1000\n#define CLKS_TO_MICROS(_CLKS) ((long)(_CLKS)) / (F_CPU / 1000000L)\n#else\n#define NS(_NS) ( (_NS * (F_CPU / 2000000L))) / 1000\n#define CLKS_TO_MICROS(_CLKS) ((long)(_CLKS)) / (F_CPU / 2000000L)\n#endif\n\n//  Macro for making sure there's enough time available\n#define NO_TIME(A, B, C) (NS(A) < 3 || NS(B) < 3 || NS(C) < 6)\n\n#if defined(__MK20DX128__)\n   extern volatile uint32_t systick_millis_count;\n#  define MS_COUNTER systick_millis_count\n#else\n#  if defined(CORE_TEENSY)\n     extern volatile unsigned long timer0_millis_count;\n#    define MS_COUNTER timer0_millis_count\n#  else\n     extern volatile unsigned long timer0_millis;\n#    define MS_COUNTER timer0_millis\n#  endif\n#endif\n\n#endif"
    }, {
      filename: "FastLED-2-final/dmx.h",
      code: "#ifndef __INC_DMX_H\n#define __INC_DMX_H\n\n//#ifdef DmxSimple_H\n//#if USE_DMX_SIMPLE\n#ifdef FASTSPI_USE_DMX_SIMPLE\n#include<DmxSimple.h>\n// note - dmx simple must be included before FastSPI for this code to be enabled\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB> class DMXController : public CLEDController {\npublic:\n\t// initialize the LED controller\n\tvirtual void init() { DmxSimple.usePin(DATA_PIN); }\n\n\t// reset any internal state to a clean point\n\tvirtual void reset() { init(); } \n\n\t// clear out/zero out the given number of leds.\n\tvirtual void clearLeds(int nLeds) {\n\t\tint count = min(nLeds * 3, DMX_SIZE);\n\t\tfor(int iChannel = 1; iChannel <= count; iChannel++) { DmxSimple.write(iChannel, 0); }\n\t}\n\n\t// set all the leds on the controller to a given color\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tint count = min(nLeds, DMX_SIZE / 3);\n\t\tint iChannel = 1;\n\t\tfor(int i = 0; i < count; i++) {\n\t\t\tDmxSimple.write(iChannel++, scale8(data[RGB_BYTE0(RGB_ORDER)], scale));\n\t\t\tDmxSimple.write(iChannel++, scale8(data[RGB_BYTE1(RGB_ORDER)], scale));\n\t\t\tDmxSimple.write(iChannel++, scale8(data[RGB_BYTE2(RGB_ORDER)], scale));\n\t\t}\n\t}\n\n\t// note that the uint8_ts will be in the order that you want them sent out to the device. \n\t// nLeds is the number of RGB leds being written to\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale = 255) {\n\t\tint count = min(nLeds, DMX_SIZE / 3);\n\t\tint iChannel = 1;\n\t\tfor(int i = 0; i < count; i++) {\n\t\t\tDmxSimple.write(iChannel++, scale8(data[i][RGB_BYTE0(RGB_ORDER)], scale));\n\t\t\tDmxSimple.write(iChannel++, scale8(data[i][RGB_BYTE1(RGB_ORDER)], scale));\n\t\t\tDmxSimple.write(iChannel++, scale8(data[i][RGB_BYTE2(RGB_ORDER)], scale));\n\t\t}\n\n\t}\n\n#ifdef SUPPORT_ARGB\n\t// as above, but every 4th uint8_t is assumed to be alpha channel data, and will be skipped\n\tvirtual void show(const struct CARGB *data, int nLeds, uint8_t scale = 255) = 0;\n#endif\n\t\n\t// is the controller ready to write data out\n\tvirtual bool ready() { return true; }\n\n\t// wait until the controller is ready to write data out \n\tvirtual void wait() { return; }\n\n};\n\n#elif defined(FASTSPI_USE_DMX_SERIAL)\n\ntemplate <uint8_t DATA_PIN, EOrder RGB_ORDER = RGB> class DMXController : public CLEDController {\npublic:\n\t// initialize the LED controller\n\tvirtual void init() { DMXSerial.init(DMXController); }\n\n\t// reset any internal state to a clean point\n\tvirtual void reset() { init(); } \n\n\t// clear out/zero out the given number of leds.\n\tvirtual void clearLeds(int nLeds) {\n\t\tint count = min(nLeds * 3, DMX_SIZE);\n\t\tfor(int iChannel = 0; iChannel < count; iChannel++) { DmxSimple.write(iChannel, 0); }\n\t}\n\n\t// set all the leds on the controller to a given color\n\tvirtual void showColor(const struct CRGB & data, int nLeds, uint8_t scale = 255) {\n\t\tint count = min(nLeds, DMX_SIZE / 3);\n\t\tint iChannel = 0;\n\t\tfor(int i = 0; i < count; i++) {\n\t\t\tDMXSerial.write(iChannel++, scale8(data[RGB_BYTE0(RGB_ORDER)], scale));\n\t\t\tDMXSerial.write(iChannel++, scale8(data[RGB_BYTE1(RGB_ORDER)], scale));\n\t\t\tDMXSerial.write(iChannel++, scale8(data[RGB_BYTE2(RGB_ORDER)], scale));\n\t\t}\n\t}\n\n\t// note that the uint8_ts will be in the order that you want them sent out to the device. \n\t// nLeds is the number of RGB leds being written to\n\tvirtual void show(const struct CRGB *data, int nLeds, uint8_t scale = 255) {\n\t\tint count = min(nLeds, DMX_SIZE / 3);\n\t\tint iChannel = 0;\n\t\tfor(int i = 0; i < count; i++) {\n\t\t\tDMXSerial.write(iChannel++, scale8(data[i][RGB_BYTE0(RGB_ORDER)], scale));\n\t\t\tDMXSerial.write(iChannel++, scale8(data[i][RGB_BYTE1(RGB_ORDER)], scale));\n\t\t\tDMXSerial.write(iChannel++, scale8(data[i][RGB_BYTE2(RGB_ORDER)], scale));\n\t\t}\n\n\t}\n\n#ifdef SUPPORT_ARGB\n\t// as above, but every 4th uint8_t is assumed to be alpha channel data, and will be skipped\n\tvirtual void show(const struct CARGB *data, int nLeds, uint8_t scale = 255) = 0;\n#endif\n\t\n\t// is the controller ready to write data out\n\tvirtual bool ready() { return true; }\n\n\t// wait until the controller is ready to write data out \n\tvirtual void wait() { return; }\n\t\n};\n\n#endif\n\n#endif"
    }, {
      filename: "FastLED-2-final/FastLED.cpp",
      code: "#include \"FastLED.h\"\n\n\nCFastLED LEDS;\nCFastLED & FastSPI_LED = LEDS;\nCFastLED & FastSPI_LED2 = LEDS;\nCFastLED & FastLED = LEDS;\n\nuint32_t CRGB::Squant = ((uint32_t)((__TIME__[4]-'0') * 28))<<16 | ((__TIME__[6]-'0')*50)<<8 | ((__TIME__[7]-'0')*28);\n\nCFastLED::CFastLED() { \n\t// clear out the array of led controllers\n\tm_nControllers = NUM_CONTROLLERS;\n\tm_nScale = 255;\n\tmemset8(m_Controllers, 0, m_nControllers * sizeof(CControllerInfo));\n}\n\nCLEDController *CFastLED::addLeds(CLEDController *pLed, \n\t\t\t\t\t\t\t\t\t   const struct CRGB *data, \n\t\t\t\t\t\t\t\t\t   int nLedsOrOffset, int nLedsIfOffset) { \n\tint nOffset = (nLedsIfOffset > 0) ? nLedsOrOffset : 0;\n\tint nLeds = (nLedsIfOffset > 0) ? nLedsIfOffset : nLedsOrOffset;\n\n\tint target = -1;\n\n\t// Figure out where to put the new led controller\n\tfor(int i = 0; i < m_nControllers; i++) { \n\t\tif(m_Controllers[i].pLedController == NULL) { \n\t\t\ttarget = i;\n\t\t\tbreak;\n\t\t}\n\t}\n\n\t// if we have a spot, use it!\n\tif(target != -1) {\n\t\tm_Controllers[target].pLedController = pLed;\n\t\tm_Controllers[target].pLedData = data;\n\t\tm_Controllers[target].nOffset = nOffset;\n\t\tm_Controllers[target].nLeds = nLeds;\n\t\tpLed->init();\n\t\treturn pLed;\n\t}\n\t\n\treturn NULL;\n}\n\nvoid CFastLED::show(uint8_t scale) { \n\tfor(int i  = 0; i < m_nControllers; i++) { \n\t\tif(m_Controllers[i].pLedController != NULL) { \n\t\t\tm_Controllers[i].pLedController->show(m_Controllers[i].pLedData + m_Controllers[i].nOffset, \n\t\t\t\t\t\t\t\t\t\t\t\t  m_Controllers[i].nLeds, scale);\n\t\t} else {\n\t\t\treturn;\n\t\t}\n\t}\n}\n\nvoid CFastLED::showColor(const struct CRGB & color, uint8_t scale) { \n\tfor(int i  = 0; i < m_nControllers; i++) { \n\t\tif(m_Controllers[i].pLedController != NULL) { \n\t\t\tm_Controllers[i].pLedController->showColor(color, m_Controllers[i].nLeds, scale);\n\t\t} else { \n\t\t\treturn;\n\t\t}\n\t}\n}\n\nvoid CFastLED::clear(boolean writeData) { \n\tif(writeData) { \n\t\tshowColor(CRGB(0,0,0), 0);\n\t}\n\tfor(int i = 0; i < m_nControllers; i++) { \n\t\tif(m_Controllers[i].pLedData != NULL) { \n\t\t\tmemset8((void*)m_Controllers[i].pLedData, 0, sizeof(struct CRGB) * m_Controllers[i].nLeds);\n\t\t} else {\n\t\t\treturn;\n\t\t}\n\t}\n}\n"
    }, {
      filename: "FastLED-2-final/FastLED.h",
      code: "#ifndef __INC_FASTSPI_LED2_H\n#define __INC_FASTSPI_LED2_H\n\n#include \"controller.h\"\n#include \"fastpin.h\"\n#include \"fastspi.h\"\n#include \"clockless.h\"\n#include \"clockless_trinket.h\"\n#include \"lib8tion.h\"\n#include \"hsv2rgb.h\"\n#include \"chipsets.h\"\n#include \"dmx.h\"\n\nenum ESPIChipsets {\n\tLPD8806,\n\tWS2801,\n\tSM16716\n};\n\nenum EClocklessChipsets {\n\tDMX,\n\tTM1809,\n\tTM1804,\n\tTM1803,\n\tWS2811,\n\tWS2812,\n\tWS2812B,\n\tWS2811_400,\n\tNEOPIXEL,\n\tUCS1903\n};\n\n#define NUM_CONTROLLERS 8\n\nclass CFastLED {\n\tstruct CControllerInfo { \n\t\tCLEDController *pLedController;\n\t\tconst struct CRGB *pLedData;\n\t\tint nLeds;\n\t\tint nOffset;\n\t};\n\n\tCControllerInfo\tm_Controllers[NUM_CONTROLLERS];\n\tint m_nControllers;\n\tuint8_t m_nScale;\n\npublic:\n\tCFastLED();\n\n\tCLEDController *addLeds(CLEDController *pLed, const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0);\n\n\ttemplate<ESPIChipsets CHIPSET,  uint8_t DATA_PIN, uint8_t CLOCK_PIN > CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\tswitch(CHIPSET) { \n\t\t\tcase LPD8806: { static LPD8806Controller<DATA_PIN, CLOCK_PIN> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2801: { static WS2801Controller<DATA_PIN, CLOCK_PIN> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase SM16716: { static SM16716Controller<DATA_PIN, CLOCK_PIN> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t}\n\t}\n\n\ttemplate<ESPIChipsets CHIPSET,  uint8_t DATA_PIN, uint8_t CLOCK_PIN, EOrder RGB_ORDER > CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\tswitch(CHIPSET) { \n\t\t\tcase LPD8806: { static LPD8806Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2801: { static WS2801Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase SM16716: { static SM16716Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t}\n\t}\n\t\n\ttemplate<ESPIChipsets CHIPSET,  uint8_t DATA_PIN, uint8_t CLOCK_PIN, EOrder RGB_ORDER, uint8_t SPI_DATA_RATE > CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\tswitch(CHIPSET) { \n\t\t\tcase LPD8806: { static LPD8806Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER, SPI_DATA_RATE> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2801: { static WS2801Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER, SPI_DATA_RATE> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase SM16716: { static SM16716Controller<DATA_PIN, CLOCK_PIN, RGB_ORDER, SPI_DATA_RATE> c; return addLeds(&c, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t}\n\t}\n\n#ifdef SPI_DATA\n\ttemplate<ESPIChipsets CHIPSET> CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\treturn addLeds<CHIPSET, SPI_DATA, SPI_CLOCK, RGB>(data, nLedsOrOffset, nLedsIfOffset);\n\t}\t\n\n\ttemplate<ESPIChipsets CHIPSET, EOrder RGB_ORDER> CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\treturn addLeds<CHIPSET, SPI_DATA, SPI_CLOCK, RGB_ORDER>(data, nLedsOrOffset, nLedsIfOffset);\n\t}\t\n\n\ttemplate<ESPIChipsets CHIPSET, EOrder RGB_ORDER, uint8_t SPI_DATA_RATE> CLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) { \n\t\treturn addLeds<CHIPSET, SPI_DATA, SPI_CLOCK, RGB_ORDER, SPI_DATA_RATE>(data, nLedsOrOffset, nLedsIfOffset);\n\t}\t\n\n#endif\n\n\ttemplate<EClocklessChipsets CHIPSET, uint8_t DATA_PIN> \n\tCLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) {\n\t\tswitch(CHIPSET) { \n#ifdef FASTSPI_USE_DMX_SIMPLE\n\t\t\tcase DMX: { static DMXController<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n#endif\n\t\t\tcase TM1809: { static TM1809Controller800Khz<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase TM1803: { static TM1803Controller400Khz<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase UCS1903: { static UCS1903Controller400Khz<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2812: \n\t\t\tcase WS2812B:\n\t\t\tcase WS2811: { static WS2811Controller800Khz<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase NEOPIXEL: { static WS2811Controller800Khz<DATA_PIN, GRB> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2811_400: { static WS2811Controller400Khz<DATA_PIN> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t}\n\t}\n\n\ttemplate<EClocklessChipsets CHIPSET, uint8_t DATA_PIN, EOrder RGB_ORDER> \n\tCLEDController *addLeds(const struct CRGB *data, int nLedsOrOffset, int nLedsIfOffset = 0) {\n\t\tswitch(CHIPSET) { \n#ifdef FASTSPI_USE_DMX_SIMPLE\n\t\t\tcase DMX: {static  DMXController<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n#endif\n\t\t\tcase TM1809: { static TM1809Controller800Khz<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase TM1803: { static TM1803Controller400Khz<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase UCS1903: { static UCS1903Controller400Khz<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2812: \n\t\t\tcase WS2812B:\n\t\t\tcase NEOPIXEL:\n\t\t\tcase WS2811: { static WS2811Controller800Khz<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t\tcase WS2811_400: { static WS2811Controller400Khz<DATA_PIN, RGB_ORDER> controller; return addLeds(&controller, data, nLedsOrOffset, nLedsIfOffset); }\n\t\t}\n\t}\n\n\tvoid setBrightness(uint8_t scale) { m_nScale = scale; }\n\tuint8_t getBrightness() { return m_nScale; }\n\n\t/// Update all our controllers with the current led colors, using the passed in brightness\n\tvoid show(uint8_t scale);\n\n\t/// Update all our controllers with the current led colors\n\tvoid show() { show(m_nScale); }\n\n\tvoid clear(boolean writeData = false);\n\n\tvoid showColor(const struct CRGB & color, uint8_t scale);\n\n\tvoid showColor(const struct CRGB & color) { showColor(color, m_nScale); }\n\n};\n\nextern CFastLED & FastSPI_LED;\nextern CFastLED & FastSPI_LED2;\nextern CFastLED & FastLED;\nextern CFastLED LEDS;\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/fastpin.h",
      code: "#ifndef __INC_FASTPIN_H\n#define __INC_FASTPIN_H\n\n#include<avr/io.h>\n\n// Arduino.h needed for convinience functions digitalPinToPort/BitMask/portOutputRegister and the pinMode methods.\n#include<Arduino.h>\n\n#define NO_PIN 255 \n\n// Class to ensure that a minimum amount of time has kicked since the last time run - and delay if not enough time has passed yet\n// this should make sure that chipsets that have \ntemplate<int WAIT> class CMinWait {\n\tlong mLastMicros;\npublic:\n\tCMinWait() { mLastMicros = 0; }\n\n\tvoid wait() { \n\t\tlong diff = micros() - mLastMicros;\n\t\twhile(diff < WAIT) { \n\t\t\tdiff = micros() - mLastMicros;\n\t\t}\n\t}\n\n\tvoid mark() { mLastMicros = micros(); }\n};\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Pin access class - needs to tune for various platforms (naive fallback solution?)\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\n#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define _CYCLES(_PIN) (((_PIN >= 62 ) || (_PIN>=42 && _PIN<=49) || (_PIN>=14 && _PIN <=17) || (_PIN>=6 && _PIN <=9)) ? 2 : 1)\n#else\n#define _CYCLES(_PIN) ((_PIN >= 24) ? 2 : 1)\n#endif\n\nclass Selectable {\npublic:\n\tvirtual void select() = 0;\n\tvirtual void release() = 0;\n\tvirtual bool isSelected() = 0;\n};\n\nclass Pin : public Selectable { \n\tuint8_t mPinMask;\n\tuint8_t mPin;\n\tvolatile uint8_t *mPort;\n\n\tvoid _init() { \n\t\tmPinMask = digitalPinToBitMask(mPin);\n\t\tmPort = portOutputRegister(digitalPinToPort(mPin));\n\t}\npublic:\n\tPin(int pin) : mPin(pin) { _init(); }\n\n\ttypedef volatile uint8_t * port_ptr_t;\n\ttypedef uint8_t port_t;\n\n\tinline void setOutput() { pinMode(mPin, OUTPUT); }\n\tinline void setInput() { pinMode(mPin, INPUT); }\n\n\tinline void hi() __attribute__ ((always_inline)) { *mPort |= mPinMask; } \n\tinline void lo() __attribute__ ((always_inline)) { *mPort &= ~mPinMask; }\n\n\tinline void strobe() __attribute__ ((always_inline)) { hi(); lo(); }\n\n\tinline void hi(register port_ptr_t port) __attribute__ ((always_inline)) { *port |= mPinMask; } \n\tinline void lo(register port_ptr_t port) __attribute__ ((always_inline)) { *port &= ~mPinMask; } \n\tinline void set(register port_t val) __attribute__ ((always_inline)) { *mPort = val; }\n\n\tinline void fastset(register port_ptr_t port, register port_t val) __attribute__ ((always_inline)) { *port  = val; }\n\n\tport_t hival() __attribute__ ((always_inline)) { return *mPort | mPinMask;  }\n\tport_t loval() __attribute__ ((always_inline)) { return *mPort & ~mPinMask; }\n\tport_ptr_t  port() __attribute__ ((always_inline)) { return mPort; }\n\tport_t mask() __attribute__ ((always_inline)) { return mPinMask; }\n\n\tvirtual void select() { hi(); }\n\tvirtual void release() { lo(); }\n\tvirtual bool isSelected() { return (*mPort & mPinMask) == mPinMask; }\n};\n\nclass OutputPin : public Pin {\npublic:\n\tOutputPin(int pin) : Pin(pin) { setOutput(); }\n};\n\nclass InputPin : public Pin {\npublic:\n\tInputPin(int pin) : Pin(pin) { setInput(); }\n};\n\n/// The simplest level of Pin class.  This relies on runtime functions durinig initialization to get the port/pin mask for the pin.  Most\n/// of the accesses involve references to these static globals that get set up.  This won't be the fastest set of pin operations, but it\n/// will provide pin level access on pretty much all arduino environments.  In addition, it includes some methods to help optimize access in\n/// various ways.  Namely, the versions of hi, lo, and fastset that take the port register as a passed in register variable (saving a global\n/// dereference), since these functions are aggressively inlined, that can help collapse out a lot of extraneous memory loads/dereferences.\n/// \n/// In addition, if, while writing a bunch of data to a pin, you know no other pins will be getting written to, you can get/cache a value of\n/// the pin's port register and use that to do a full set to the register.  This results in one being able to simply do a store to the register,\n/// vs. the load, and/or, and store that would be done normally.\n///\n/// There are platform specific instantiations of this class that provide direct i/o register access to pins for much higher speed pin twiddling.\n///\n/// Note that these classes are all static functions.  So the proper usage is Pin<13>::hi(); or such.  Instantiating objects is not recommended, \n/// as passing Pin objects around will likely -not- have the effect you're expecting.\ntemplate<uint8_t PIN> class FastPin { \n\tstatic uint8_t sPinMask;\n\tstatic volatile uint8_t *sPort;\n\tstatic void _init() { \n\t\tsPinMask = digitalPinToBitMask(PIN);\n\t\tsPort = portOutputRegister(digitalPinToPort(PIN));\n\t}\npublic:\n\ttypedef volatile uint8_t * port_ptr_t;\n\ttypedef uint8_t port_t;\n\n\tinline static void setOutput() { _init(); pinMode(PIN, OUTPUT); }\n\tinline static void setInput() { _init(); pinMode(PIN, INPUT); }\n\n\tinline static void hi() __attribute__ ((always_inline)) { *sPort |= sPinMask; } \n\tinline static void lo() __attribute__ ((always_inline)) { *sPort &= ~sPinMask; }\n\n\tinline static void strobe() __attribute__ ((always_inline)) { hi(); lo(); }\n\n\tinline static void hi(register port_ptr_t port) __attribute__ ((always_inline)) { *port |= sPinMask; } \n\tinline static void lo(register port_ptr_t port) __attribute__ ((always_inline)) { *port &= ~sPinMask; } \n\tinline static void set(register port_t val) __attribute__ ((always_inline)) { *sPort = val; }\n\n\tinline static void fastset(register port_ptr_t port, register port_t val) __attribute__ ((always_inline)) { *port  = val; }\n\n\tstatic port_t hival() __attribute__ ((always_inline)) { return *sPort | sPinMask;  }\n\tstatic port_t loval() __attribute__ ((always_inline)) { return *sPort & ~sPinMask; }\n\tstatic port_ptr_t  port() __attribute__ ((always_inline)) { return sPort; }\n\tstatic port_t mask() __attribute__ ((always_inline)) { return sPinMask; }\n};\n\ntemplate<uint8_t PIN> uint8_t FastPin<PIN>::sPinMask;\ntemplate<uint8_t PIN> volatile uint8_t *FastPin<PIN>::sPort;\n\n/// Class definition for a Pin where we know the port registers at compile time for said pin.  This allows us to make\n/// a lot of optimizations, as the inlined hi/lo methods will devolve to a single io register write/bitset.  \ntemplate<uint8_t PIN, uint8_t _MASK, typename _PORT, typename _DDR, typename _PIN> class _AVRPIN { \npublic:\n\ttypedef volatile uint8_t * port_ptr_t;\n\ttypedef uint8_t port_t;\n\t \n\tinline static void setOutput() { _DDR::r() |= _MASK; }\n\tinline static void setInput() { _DDR::r() &= ~_MASK; }\n\n\tinline static void hi() __attribute__ ((always_inline)) { _PORT::r() |= _MASK; }\n\tinline static void lo() __attribute__ ((always_inline)) { _PORT::r() &= ~_MASK; }\n\tinline static void set(register uint8_t val) __attribute__ ((always_inline)) { _PORT::r() = val; }\n\n\tinline static void strobe() __attribute__ ((always_inline)) { hi(); lo(); }\n\t\n\tinline static void hi(register port_ptr_t port) __attribute__ ((always_inline)) { hi(); }\n\tinline static void lo(register port_ptr_t port) __attribute__ ((always_inline)) { lo(); }\n\tinline static void fastset(register port_ptr_t port, register uint8_t val) __attribute__ ((always_inline)) { set(val); }\n\n\tinline static port_t hival() __attribute__ ((always_inline)) { return _PORT::r() | _MASK; }\n\tinline static port_t loval() __attribute__ ((always_inline)) { return _PORT::r() & ~_MASK; }\n\tinline static port_ptr_t port() __attribute__ ((always_inline)) { return &_PORT::r(); }\n\tinline static port_t mask() __attribute__ ((always_inline)) { return _MASK; }\n};\n\n/// Template definition for teensy 3.0 style ARM pins, providing direct access to the various GPIO registers.  Note that this\n/// uses the full port GPIO registers.  In theory, in some way, bit-band register access -should- be faster, however I have found\n/// that something about the way gcc does register allocation results in the bit-band code being slower.  It will need more fine tuning.\ntemplate<uint8_t PIN, uint32_t _MASK, typename _PDOR, typename _PSOR, typename _PCOR, typename _PTOR, typename _PDIR, typename _PDDR> class _ARMPIN { \npublic:\n\ttypedef volatile uint32_t * port_ptr_t;\n\ttypedef uint32_t port_t;\n\n\tinline static void setOutput() { pinMode(PIN, OUTPUT); } // TODO: perform MUX config { _PDDR::r() |= _MASK; }\n\tinline static void setInput() { pinMode(PIN, INPUT); } // TODO: preform MUX config { _PDDR::r() &= ~_MASK; }\n\n\tinline static void hi() __attribute__ ((always_inline)) { _PSOR::r() = _MASK; }\n\tinline static void lo() __attribute__ ((always_inline)) { _PCOR::r() = _MASK; }\n\tinline static void set(register port_t val) __attribute__ ((always_inline)) { _PDOR::r() = val; }\n\n\tinline static void strobe() __attribute__ ((always_inline)) { toggle(); toggle(); }\n\t\n\tinline static void toggle() __attribute__ ((always_inline)) { _PTOR::r() = _MASK; }\n\n\tinline static void hi(register port_ptr_t port) __attribute__ ((always_inline)) { hi(); }\n\tinline static void lo(register port_ptr_t port) __attribute__ ((always_inline)) { lo(); }\n\tinline static void fastset(register port_ptr_t port, register port_t val) __attribute__ ((always_inline)) { *port = val; }\n\n\tinline static port_t hival() __attribute__ ((always_inline)) { return _PDOR::r() | _MASK; }\n\tinline static port_t loval() __attribute__ ((always_inline)) { return _PDOR::r() & ~_MASK; }\n\tinline static port_ptr_t port() __attribute__ ((always_inline)) { return &_PDOR::r(); }\n\tinline static port_t mask() __attribute__ ((always_inline)) { return _MASK; }\n};\n\n/// Template definition for teensy 3.0 style ARM pins using bit banding, providing direct access to the various GPIO registers.  GCC \n/// does a poor job of optimizing around these accesses so they are not being used just yet.\ntemplate<uint8_t PIN, int _BIT, typename _PDOR, typename _PSOR, typename _PCOR, typename _PTOR, typename _PDIR, typename _PDDR> class _ARMPIN_BITBAND { \npublic:\n\ttypedef volatile uint32_t * port_ptr_t;\n\ttypedef uint32_t port_t;\n\n\tinline static void setOutput() { pinMode(PIN, OUTPUT); } // TODO: perform MUX config { _PDDR::r() |= _MASK; }\n\tinline static void setInput() { pinMode(PIN, INPUT); } // TODO: preform MUX config { _PDDR::r() &= ~_MASK; }\n\n\tinline static void hi() __attribute__ ((always_inline)) { *_PDOR::template rx<_BIT>() = 1; }\n\tinline static void lo() __attribute__ ((always_inline)) { *_PDOR::template rx<_BIT>() = 0; }\n\tinline static void set(register port_t val) __attribute__ ((always_inline)) { *_PDOR::template rx<_BIT>() = val; }\n\n\tinline static void strobe() __attribute__ ((always_inline)) { toggle(); toggle(); }\n\t\n\tinline static void toggle() __attribute__ ((always_inline)) { *_PTOR::template rx<_BIT>() = 1; }\n\n\tinline static void hi(register port_ptr_t port) __attribute__ ((always_inline)) { *port = 1;  }\n\tinline static void lo(register port_ptr_t port) __attribute__ ((always_inline)) { *port = 0; }\n\tinline static void fastset(register port_ptr_t port, register port_t val) __attribute__ ((always_inline)) { *port = val; }\n\n\tinline static port_t hival() __attribute__ ((always_inline)) { return 1; }\n\tinline static port_t loval() __attribute__ ((always_inline)) { return 0; }\n\tinline static port_ptr_t port() __attribute__ ((always_inline)) { return _PDOR::template rx<_BIT>(); }\n\tinline static port_t mask() __attribute__ ((always_inline)) { return 1; }\n};\n\n/// AVR definitions for pins.  Getting around  the fact that I can't pass GPIO register addresses in as template arguments by instead creating\n/// a custom type for each GPIO register with a single, static, aggressively inlined function that returns that specific GPIO register.  A similar\n/// trick is used a bit further below for the ARM GPIO registers (of which there are far more than on AVR!)\ntypedef volatile uint8_t & reg8_t;\n#define _R(T) struct __gen_struct_ ## T\n#define _RD8(T) struct __gen_struct_ ## T { static inline reg8_t r() { return T; }};\n#define _IO(L) _RD8(DDR ## L); _RD8(PORT ## L); _RD8(PIN ## L);\n#define _DEFPIN_AVR(PIN, MASK, L) template<> class FastPin<PIN> : public _AVRPIN<PIN, MASK, _R(PORT ## L), _R(DDR ## L), _R(PIN ## L)> {};\n\n// ARM definitions\n#define GPIO_BITBAND_ADDR(reg, bit) (((uint32_t)&(reg) - 0x40000000) * 32 + (bit) * 4 + 0x42000000)\n#define GPIO_BITBAND_PTR(reg, bit) ((uint32_t *)GPIO_BITBAND_ADDR((reg), (bit)))\n\ntypedef volatile uint32_t & reg32_t;\ntypedef volatile uint32_t * ptr_reg32_t;\n\n#define _RD32(T) struct __gen_struct_ ## T { static __attribute__((always_inline)) inline reg32_t r() { return T; } \\\n\ttemplate<int BIT> static __attribute__((always_inline)) inline ptr_reg32_t rx() { return GPIO_BITBAND_PTR(T, BIT); } };\n#define _IO32(L) _RD32(GPIO ## L ## _PDOR); _RD32(GPIO ## L ## _PSOR); _RD32(GPIO ## L ## _PCOR); _RD32(GPIO ## L ## _PTOR); _RD32(GPIO ## L ## _PDIR); _RD32(GPIO ## L ## _PDDR);\n\n#define _DEFPIN_ARM(PIN, BIT, L) template<> class FastPin<PIN> : public _ARMPIN<PIN, 1 << BIT, _R(GPIO ## L ## _PDOR), _R(GPIO ## L ## _PSOR), _R(GPIO ## L ## _PCOR), \\\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t_R(GPIO ## L ## _PTOR), _R(GPIO ## L ## _PDIR), _R(GPIO ## L ## _PDDR)> {}; \n\n// Don't use bit band'd pins for now, the compiler generates far less efficient code around them\n// #define _DEFPIN_ARM(PIN, BIT, L) template<> class Pin<PIN> : public _ARMPIN_BITBAND<PIN, BIT, _R(GPIO ## L ## _PDOR), _R(GPIO ## L ## _PSOR), _R(GPIO ## L ## _PCOR),\n// \t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t_R(GPIO ## L ## _PTOR), _R(GPIO ## L ## _PDIR), _R(GPIO ## L ## _PDDR)> {}; \n\n\n///////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Pin definitions for AVR and ARM.  If there are pin definitions supplied below for the platform being \n// built on, then much higher speed access will be possible, namely with direct GPIO register accesses.\n//\n///////////////////////////////////////////////////////////////////////////////////////////////////////////\n#if defined(FORCE_SOFTWARE_PINS)\n#warning \"Softwrae pin support forced pin access will be slightly slower.  See fastpin.h for info.\"\n#define NO_HARDWARE_PIN_SUPPORT\n\n#elif defined(__AVR_ATtiny85__) \n_IO(B);\n\n_DEFPIN_AVR(0, 0x01, B); _DEFPIN_AVR(1, 0x02, B); _DEFPIN_AVR(2, 0x04, B); _DEFPIN_AVR(3, 0x08, B);\n_DEFPIN_AVR(4, 0x10, B); _DEFPIN_AVR(5, 0x20, B);\n\n#elif defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168__)\n// Accelerated port definitions for arduino avrs\n_IO(D); _IO(B); _IO(C);\n_DEFPIN_AVR( 0, 0x01, D); _DEFPIN_AVR( 1, 0x02, D); _DEFPIN_AVR( 2, 0x04, D); _DEFPIN_AVR( 3, 0x08, D);\n_DEFPIN_AVR( 4, 0x10, D); _DEFPIN_AVR( 5, 0x20, D); _DEFPIN_AVR( 6, 0x40, D); _DEFPIN_AVR( 7, 0x80, D);\n_DEFPIN_AVR( 8, 0x01, B); _DEFPIN_AVR( 9, 0x02, B); _DEFPIN_AVR(10, 0x04, B); _DEFPIN_AVR(11, 0x08, B);\n_DEFPIN_AVR(12, 0x10, B); _DEFPIN_AVR(13, 0x20, B); _DEFPIN_AVR(14, 0x01, C); _DEFPIN_AVR(15, 0x02, C);\n_DEFPIN_AVR(16, 0x04, C); _DEFPIN_AVR(17, 0x08, C); _DEFPIN_AVR(18, 0x10, C); _DEFPIN_AVR(19, 0x20, C);\n\n#define SPI_DATA 11\n#define SPI_CLOCK 13\n#define SPI_SELECT 10\n#define AVR_HARDWARE_SPI\n\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n// megas\n\n_IO(A); _IO(B); _IO(C); _IO(D); _IO(E); _IO(F); _IO(G); _IO(H); _IO(J); _IO(K); _IO(L);\n\n_DEFPIN_AVR(0, 1, E); _DEFPIN_AVR(1, 2, E); _DEFPIN_AVR(2, 16, E); _DEFPIN_AVR(3, 32, E); \n_DEFPIN_AVR(4, 32, G); _DEFPIN_AVR(5, 8, E); _DEFPIN_AVR(6, 8, H); _DEFPIN_AVR(7, 16, H); \n_DEFPIN_AVR(8, 32, H); _DEFPIN_AVR(9, 64, H); _DEFPIN_AVR(10, 16, B); _DEFPIN_AVR(11, 32, B); \n_DEFPIN_AVR(12, 64, B); _DEFPIN_AVR(13, 128, B); _DEFPIN_AVR(14, 2, J); _DEFPIN_AVR(15, 1, J); \n_DEFPIN_AVR(16, 2, H); _DEFPIN_AVR(17, 1, H); _DEFPIN_AVR(18, 8, D); _DEFPIN_AVR(19, 4, D); \n_DEFPIN_AVR(20, 2, D); _DEFPIN_AVR(21, 1, D); _DEFPIN_AVR(22, 1, A); _DEFPIN_AVR(23, 2, A); \n_DEFPIN_AVR(24, 4, A); _DEFPIN_AVR(25, 8, A); _DEFPIN_AVR(26, 16, A); _DEFPIN_AVR(27, 32, A); \n_DEFPIN_AVR(28, 64, A); _DEFPIN_AVR(29, 128, A); _DEFPIN_AVR(30, 128, C); _DEFPIN_AVR(31, 64, C); \n_DEFPIN_AVR(32, 32, C); _DEFPIN_AVR(33, 16, C); _DEFPIN_AVR(34, 8, C); _DEFPIN_AVR(35, 4, C); \n_DEFPIN_AVR(36, 2, C); _DEFPIN_AVR(37, 1, C); _DEFPIN_AVR(38, 128, D); _DEFPIN_AVR(39, 4, G); \n_DEFPIN_AVR(40, 2, G); _DEFPIN_AVR(41, 1, G); _DEFPIN_AVR(42, 128, L); _DEFPIN_AVR(43, 64, L); \n_DEFPIN_AVR(44, 32, L); _DEFPIN_AVR(45, 16, L); _DEFPIN_AVR(46, 8, L); _DEFPIN_AVR(47, 4, L); \n_DEFPIN_AVR(48, 2, L); _DEFPIN_AVR(49, 1, L); _DEFPIN_AVR(50, 8, B); _DEFPIN_AVR(51, 4, B); \n_DEFPIN_AVR(52, 2, B); _DEFPIN_AVR(53, 1, B); _DEFPIN_AVR(54, 1, F); _DEFPIN_AVR(55, 2, F); \n_DEFPIN_AVR(56, 4, F); _DEFPIN_AVR(57, 8, F); _DEFPIN_AVR(58, 16, F); _DEFPIN_AVR(59, 32, F); \n_DEFPIN_AVR(60, 64, F); _DEFPIN_AVR(61, 128, F); _DEFPIN_AVR(62, 1, K); _DEFPIN_AVR(63, 2, K); \n_DEFPIN_AVR(64, 4, K); _DEFPIN_AVR(65, 8, K); _DEFPIN_AVR(66, 16, K); _DEFPIN_AVR(67, 32, K); \n_DEFPIN_AVR(68, 64, K); _DEFPIN_AVR(69, 128, K); \n\n#define SPI_DATA 51\n#define SPI_CLOCK 52\n#define SPI_SELECT 53\n#define AVR_HARDWARE_SPI\n\n// Leonardo, teensy, blinkm\n#elif defined(__AVR_ATmega32U4__) && defined(CORE_TEENSY)\n\n// teensy defs\n_IO(B); _IO(C); _IO(D); _IO(E); _IO(F); \n\n_DEFPIN_AVR(0, 1, B); _DEFPIN_AVR(1, 2, B); _DEFPIN_AVR(2, 4, B); _DEFPIN_AVR(3, 8, B); \n_DEFPIN_AVR(4, 128, B); _DEFPIN_AVR(5, 1, D); _DEFPIN_AVR(6, 2, D); _DEFPIN_AVR(7, 4, D); \n_DEFPIN_AVR(8, 8, D); _DEFPIN_AVR(9, 64, C); _DEFPIN_AVR(10, 128, C); _DEFPIN_AVR(11, 64, D); \n_DEFPIN_AVR(12, 128, D); _DEFPIN_AVR(13, 16, B); _DEFPIN_AVR(14, 32, B); _DEFPIN_AVR(15, 64, B); \n_DEFPIN_AVR(16, 128, F); _DEFPIN_AVR(17, 64, F); _DEFPIN_AVR(18, 32, F); _DEFPIN_AVR(19, 16, F); \n_DEFPIN_AVR(20, 2, F); _DEFPIN_AVR(21, 1, F); _DEFPIN_AVR(22, 16, D); _DEFPIN_AVR(23, 32, D); \n\n#define SPI_DATA 2\n#define SPI_CLOCK 1\n#define SPI_SELECT 3\n#define AVR_HARDWARE_SPI\n\n#elif defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB1286__)\n// teensy++ 2 defs\n\n_IO(A); _IO(B); _IO(C); _IO(D); _IO(E); _IO(F); \n\n_DEFPIN_AVR(0, 1, D); _DEFPIN_AVR(1, 2, D); _DEFPIN_AVR(2, 4, D); _DEFPIN_AVR(3, 8, D); \n_DEFPIN_AVR(4, 16, D); _DEFPIN_AVR(5, 32, D); _DEFPIN_AVR(6, 64, D); _DEFPIN_AVR(7, 128, D); \n_DEFPIN_AVR(8, 1, E); _DEFPIN_AVR(9, 2, E); _DEFPIN_AVR(10, 1, C); _DEFPIN_AVR(11, 2, C); \n_DEFPIN_AVR(12, 4, C); _DEFPIN_AVR(13, 8, C); _DEFPIN_AVR(14, 16, C); _DEFPIN_AVR(15, 32, C); \n_DEFPIN_AVR(16, 64, C); _DEFPIN_AVR(17, 128, C); _DEFPIN_AVR(18, 64, E); _DEFPIN_AVR(19, 128, E); \n_DEFPIN_AVR(20, 1, B); _DEFPIN_AVR(21, 2, B); _DEFPIN_AVR(22, 4, B); _DEFPIN_AVR(23, 8, B); \n_DEFPIN_AVR(24, 16, B); _DEFPIN_AVR(25, 32, B); _DEFPIN_AVR(26, 64, B); _DEFPIN_AVR(27, 128, B); \n_DEFPIN_AVR(28, 1, A); _DEFPIN_AVR(29, 2, A); _DEFPIN_AVR(30, 4, A); _DEFPIN_AVR(31, 8, A); \n_DEFPIN_AVR(32, 16, A); _DEFPIN_AVR(33, 32, A); _DEFPIN_AVR(34, 64, A); _DEFPIN_AVR(35, 128, A); \n_DEFPIN_AVR(36, 16, E); _DEFPIN_AVR(37, 32, E); _DEFPIN_AVR(38, 1, F); _DEFPIN_AVR(39, 2, F); \n_DEFPIN_AVR(40, 4, F); _DEFPIN_AVR(41, 8, F); _DEFPIN_AVR(42, 16, F); _DEFPIN_AVR(43, 32, F); \n_DEFPIN_AVR(44, 64, F); _DEFPIN_AVR(45, 128, F); \n\n#define SPI_DATA 22\n#define SPI_CLOCK 21\n#define SPI_SELECT 20\n#define AVR_HARDWARE_SPI\n\n#elif defined(__AVR_ATmega32U4__)\n\n// leonard defs\n_IO(B); _IO(C); _IO(D); _IO(E); _IO(F); \n\n_DEFPIN_AVR(0, 4, D); _DEFPIN_AVR(1, 8, D); _DEFPIN_AVR(2, 2, D); _DEFPIN_AVR(3, 1, D); \n_DEFPIN_AVR(4, 16, D); _DEFPIN_AVR(5, 64, C); _DEFPIN_AVR(6, 128, D); _DEFPIN_AVR(7, 64, E); \n_DEFPIN_AVR(8, 16, B); _DEFPIN_AVR(9, 32, B); _DEFPIN_AVR(10, 64, B); _DEFPIN_AVR(11, 128, B); \n_DEFPIN_AVR(12, 64, D); _DEFPIN_AVR(13, 128, C); _DEFPIN_AVR(14, 8, B); _DEFPIN_AVR(15, 2, B); \n_DEFPIN_AVR(16, 4, B); _DEFPIN_AVR(17, 1, B); _DEFPIN_AVR(18, 128, F); _DEFPIN_AVR(19, 64, F); \n_DEFPIN_AVR(20, 32, F); _DEFPIN_AVR(21, 16, F); _DEFPIN_AVR(22, 2, F); _DEFPIN_AVR(23, 0, F); \n\n#define SPI_DATA 16\n#define SPI_CLOCK 15\n#define AVR_HARDWARE_SPI\n\n#elif defined(__MK20DX128__) && defined(CORE_TEENSY)\n\n_IO32(A); _IO32(B); _IO32(C); _IO32(D); _IO32(E);\n\n_DEFPIN_ARM(0, 16, B); _DEFPIN_ARM(1, 17, B); _DEFPIN_ARM(2, 0, D); _DEFPIN_ARM(3, 12, A);\n_DEFPIN_ARM(4, 13, A); _DEFPIN_ARM(5, 7, D); _DEFPIN_ARM(6, 4, D); _DEFPIN_ARM(7, 2, D);\n_DEFPIN_ARM(8, 3, D); _DEFPIN_ARM(9, 3, C); _DEFPIN_ARM(10, 4, C); _DEFPIN_ARM(11, 6, C);\n_DEFPIN_ARM(12, 7, C); _DEFPIN_ARM(13, 5, C); _DEFPIN_ARM(14, 1, D); _DEFPIN_ARM(15, 0, C);\n_DEFPIN_ARM(16, 0, B); _DEFPIN_ARM(17, 1, B); _DEFPIN_ARM(18, 3, B); _DEFPIN_ARM(19, 2, B);\n_DEFPIN_ARM(20, 5, D); _DEFPIN_ARM(21, 6, D); _DEFPIN_ARM(22, 1, C); _DEFPIN_ARM(23, 2, C);\n_DEFPIN_ARM(24, 5, A); _DEFPIN_ARM(25, 19, B); _DEFPIN_ARM(26, 1, E); _DEFPIN_ARM(27, 9, C);\n_DEFPIN_ARM(28, 8, C); _DEFPIN_ARM(29, 10, C); _DEFPIN_ARM(30, 11, C); _DEFPIN_ARM(31, 0, E);\n_DEFPIN_ARM(32, 18, B); _DEFPIN_ARM(33, 4, A);\n\n#define SPI_DATA 11\n#define SPI_CLOCK 13\n#define ARM_HARDWARE_SPI\n\n#elif defined(__SAM3X8E__)\n\nDUE_IO32(A);\nDUE_IO32(B);\nDUE_IO32(C);\nDUE_IO32(D);\n\n_DEFPIN_DUE(0, 8, A); _DEFPIN_DUE(1, 9, A); _DEFPIN_DUE(2, 25, B); _DEFPIN_DUE(3, 28, C);\n_DEFPIN_DUE(4, 26, C); _DEFPIN_DUE(5, 25, C); _DEFPIN_DUE(6, 24, C); _DEFPIN_DUE(7, 23, C);\n_DEFPIN_DUE(8, 22, C); _DEFPIN_DUE(9, 21, C); _DEFPIN_DUE(10, 29, C); _DEFPIN_DUE(11, 7, D);\n_DEFPIN_DUE(12, 8, D); _DEFPIN_DUE(13, 27, B); _DEFPIN_DUE(14, 4, D); _DEFPIN_DUE(15, 5, D);\n_DEFPIN_DUE(16, 13, A); _DEFPIN_DUE(17, 12, A); _DEFPIN_DUE(18, 11, A); _DEFPIN_DUE(19, 10, A);\n_DEFPIN_DUE(20, 12, B); _DEFPIN_DUE(21, 13, B); _DEFPIN_DUE(22, 26, B); _DEFPIN_DUE(23, 14, A);\n_DEFPIN_DUE(24, 15, A); _DEFPIN_DUE(25, 0, D); _DEFPIN_DUE(26, 1, D); _DEFPIN_DUE(27, 2, D);\n_DEFPIN_DUE(28, 3, D); _DEFPIN_DUE(29, 6, D); _DEFPIN_DUE(30, 9, D); _DEFPIN_DUE(31, 7, A);\n_DEFPIN_DUE(32, 10, D); _DEFPIN_DUE(33, 1, C); _DEFPIN_DUE(34, 2, C); _DEFPIN_DUE(35, 3, C);\n_DEFPIN_DUE(36, 4, C); _DEFPIN_DUE(37, 5, C); _DEFPIN_DUE(38, 6, C); _DEFPIN_DUE(39, 7, C);\n_DEFPIN_DUE(40, 8, C); _DEFPIN_DUE(41, 9, C); _DEFPIN_DUE(42, 19, A); _DEFPIN_DUE(43, 20, A);\n_DEFPIN_DUE(44, 19, C); _DEFPIN_DUE(45, 18, C); _DEFPIN_DUE(46, 17, C); _DEFPIN_DUE(47, 16, C);\n_DEFPIN_DUE(48, 15, C); _DEFPIN_DUE(49, 14, C); _DEFPIN_DUE(50, 13, C); _DEFPIN_DUE(51, 12, C);\n_DEFPIN_DUE(52, 21, B); _DEFPIN_DUE(53, 14, B); _DEFPIN_DUE(54, 16, A); _DEFPIN_DUE(55, 24, A);\n_DEFPIN_DUE(56, 23, A); _DEFPIN_DUE(57, 22, A); _DEFPIN_DUE(58, 6, A); _DEFPIN_DUE(59, 4, A);\n_DEFPIN_DUE(60, 3, A); _DEFPIN_DUE(61, 2, A); _DEFPIN_DUE(62, 17, B); _DEFPIN_DUE(63, 18, B);\n_DEFPIN_DUE(64, 19, B); _DEFPIN_DUE(65, 20, B); _DEFPIN_DUE(66, 15, B); _DEFPIN_DUE(67, 16, B);\n_DEFPIN_DUE(68, 1, A); _DEFPIN_DUE(69, 0, A); _DEFPIN_DUE(70, 17, A); _DEFPIN_DUE(71, 18, A);\n_DEFPIN_DUE(72, 30, C); _DEFPIN_DUE(73, 21, A); _DEFPIN_DUE(74, 25, A); _DEFPIN_DUE(75, 26, A);\n_DEFPIN_DUE(76, 27, A); _DEFPIN_DUE(77, 28, A); _DEFPIN_DUE(78, 23, B);\n\n#else\n\n#warning \"No pin/port mappings found, pin access will be slightly slower.  See fastpin.h for info.\"\n#define NO_HARDWARE_PIN_SUPPORT\n\n#endif\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/fastspi.h",
      code: "#ifndef __INC_FASTSPI_H\n#define __INC_FASTSPI_H\n\n#include \"controller.h\"\n#include \"lib8tion.h\"\n#include \"delay.h\"\n\n// Some helper macros for getting at mis-ordered byte values\n#define SPI_B0 (RGB_BYTE0(RGB_ORDER) + (MASK_SKIP_BITS & SKIP))\n#define SPI_B1 (RGB_BYTE1(RGB_ORDER) + (MASK_SKIP_BITS & SKIP))\n#define SPI_B2 (RGB_BYTE2(RGB_ORDER) + (MASK_SKIP_BITS & SKIP))\n#define SPI_ADVANCE (3 + (MASK_SKIP_BITS & SKIP))\n\n/// Some of the SPI controllers will need to perform a transform on each byte before doing\n/// anyting with it.  Creating a class of this form and passing it in as a template parameter to\n/// writeBytes/writeBytes3 below will ensure that the body of this method will get called on every\n/// byte worked on.  Recommendation, make the adjust method aggressively inlined.\n///\n/// TODO: Convinience macro for building these\nclass DATA_NOP { \npublic:\n\tstatic __attribute__((always_inline)) inline uint8_t adjust(register uint8_t data) { return data; } \n\tstatic __attribute__((always_inline)) inline uint8_t adjust(register uint8_t data, register uint8_t scale) { return scale8(data, scale); } \n\tstatic __attribute__((always_inline)) inline void postBlock(int len) {}\n};\n\n#define FLAG_START_BIT 0x80\n#define MASK_SKIP_BITS 0x3F\n\n// Clock speed dividers \n#define SPEED_DIV_2 2\n#define SPEED_DIV_4 4\n#define SPEED_DIV_8 8\n#define SPEED_DIV_16 16\n#define SPEED_DIV_32 32\n#define SPEED_DIV_64 64\n#define SPEED_DIV_128 128\n\n#define MAX_DATA_RATE 0\n#define DATA_RATE_MHZ(X) ((F_CPU / 1000000L) / X)\n#define DATA_RATE_KHZ(X) ((F_CPU / 1000L) / X)\n\n// Include the various specific SPI implementations\n#include \"fastspi_bitbang.h\"\n#include \"fastspi_arm.h\"\n#include \"fastspi_avr.h\"\n#include \"fastspi_dma.h\"\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// External SPI template definition with partial instantiation(s) to map to hardware SPI ports on platforms/builds where the pin\n// mappings are known at compile time.\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate<uint8_t _DATA_PIN, uint8_t _CLOCK_PIN, uint8_t _SPI_CLOCK_DIVIDER>\nclass SPIOutput : public AVRSoftwareSPIOutput<_DATA_PIN, _CLOCK_PIN, _SPI_CLOCK_DIVIDER> {};\n\ntemplate<uint8_t _DATA_PIN, uint8_t _CLOCK_PIN, uint8_t _SPI_CLOCK_DIVIDER>\nclass SoftwareSPIOutput : public AVRSoftwareSPIOutput<_DATA_PIN, _CLOCK_PIN, _SPI_CLOCK_DIVIDER> {};\n\n#ifndef FORCE_SOFTWARE_SPI\n#if defined(SPI_DATA) && defined(SPI_CLOCK)\n\n#if defined(__MK20DX128__) && defined(CORE_TEENSY)\n\ntemplate<uint8_t SPI_SPEED>\nclass SPIOutput<SPI_DATA, SPI_CLOCK, SPI_SPEED> : public ARMHardwareSPIOutput<SPI_DATA, SPI_CLOCK, SPI_SPEED> {};\n\n#else\n\ntemplate<uint8_t SPI_SPEED>\nclass SPIOutput<SPI_DATA, SPI_CLOCK, SPI_SPEED> : public AVRHardwareSPIOutput<SPI_DATA, SPI_CLOCK, SPI_SPEED> {};\n\n#endif\n\n#else\n#warning \"No hardware SPI pins defined.  All SPI access will default to bitbanged output\"\n\n#endif\n\n// #if defined(USART_DATA) && defined(USART_CLOCK)\n// template<uint8_t SPI_SPEED>\n// class AVRSPIOutput<USART_DATA, USART_CLOCK, SPI_SPEED> : public AVRUSARTSPIOutput<USART_DATA, USART_CLOCK, SPI_SPEED> {};\n// #endif\n\n#else\n#warning \"Forcing software SPI - no hardware SPI for you!\"\n#endif \n\n#endif\n"
    }, {
      filename: "FastLED-2-final/fastspi_arm.h",
      code: "#ifndef __INC_FASTSPI_ARM_H\n#define __INC_FASTSPI_ARM_H\n\n\n#if defined(__MK20DX128__) && defined(CORE_TEENSY)\n\n#ifndef SPI_PUSHR_CONT\n#define SPI_PUSHR_CONT SPI0_PUSHR_CONT\n#define SPI_PUSHR_CTAS(X) SPI0_PUSHR_CTAS(X)\n#define SPI_PUSHR_EOQ SPI0_PUSHR_EOQ\n#define SPI_PUSHR_CTCNT SPI0_PUSHR_CTCNT\n#define SPI_PUSHR_PCS(X) SPI0_PUSHR_PCS(X)\n#endif\n\n// Template function that, on compilation, expands to a constant representing the highest bit set in a byte.  Right now, \n// if no bits are set (value is 0), it returns 0, which is also the value returned if the lowest bit is the only bit\n// set (the zero-th bit).  Unclear if I  will want this to change at some point.\ntemplate<int VAL, int BIT> class BitWork { \n\tpublic: \n\t\tstatic int highestBit() __attribute__((always_inline)) { return (VAL & 1 << BIT) ? BIT : BitWork<VAL, BIT-1>::highestBit(); } \n};\ntemplate<int VAL> class BitWork<VAL, 0> { \n\tpublic: \n\t\tstatic int highestBit() __attribute__((always_inline)) { return 0; } \n};\n\n#define MAX(A, B) (( (A) > (B) ) ? (A) : (B))\n\n#define USE_CONT 0\n\n// Templated function to translate a clock divider value into the prescalar, scalar, and clock doubling setting for the world.\ntemplate <int VAL> void getScalars(uint32_t & preScalar, uint32_t & scalar, uint32_t & dbl) {\n    switch(VAL) {\n    \t\t// Handle the dbl clock cases\n    \t\tcase 0: case 1:\n            case 2: preScalar = 0; scalar = 0; dbl = 1; break;\n            case 3: preScalar = 1; scalar = 0; dbl = 1; break;\n            case 5: preScalar = 2; scalar = 0; dbl = 1; break;\n            case 7: preScalar = 3; scalar = 0; dbl = 1; break;\n\n            // Handle the scalar value 6 cases (since it's not a power of two, it won't get caught\n            // below)\n            case 9: preScalar = 1; scalar = 2; dbl = 1; break;\n            case 18: case 19: preScalar = 1; scalar = 2; dbl = 0; break;\n\n            case 15: preScalar = 2; scalar = 2; dbl = 1; break;\n            case 30: case 31: preScalar = 2; scalar = 2; dbl = 0; break;\n\n            case 21: case 22: case 23: preScalar = 3; scalar = 2; dbl = 1; break;\n            case 42: case 43: case 44: case 45: case 46: case 47: preScalar = 3; scalar = 2; dbl = 0; break;\n            default: {\n                int p2 = BitWork<VAL/2, 15>::highestBit();\n                int p3 = BitWork<VAL/3, 15>::highestBit();\n                int p5 = BitWork<VAL/5, 15>::highestBit();\n                int p7 = BitWork<VAL/7, 15>::highestBit();\n\n                int w2 = 2 * (1 << p2);\n                int w3 = (VAL/3) > 0 ? 3 * (1 << p3) : 0;\n                int w5 = (VAL/5) > 0 ? 5 * (1 << p5) : 0;\n                int w7 = (VAL/7) > 0 ? 7 * (1 << p7) : 0;\n\n                int maxval = MAX(MAX(w2, w3), MAX(w5, w7));\n\n                if(w2 == maxval) { preScalar = 0; scalar = p2; }\n                else if(w3 == maxval) { preScalar = 1; scalar = p3; }\n                else if(w5 == maxval) { preScalar = 2; scalar = p5; }\n                else if(w7 == maxval) { preScalar = 3; scalar = p7; }\n\n                dbl = 0;\n                if(scalar == 0) { dbl = 1; }\n                else if(scalar < 3) { scalar--; }\n            }\n    }\n\treturn;\n}\n\n\ntemplate <uint8_t _DATA_PIN, uint8_t _CLOCK_PIN, uint8_t _SPI_CLOCK_DIVIDER>\nclass ARMHardwareSPIOutput { \n\tSelectable *m_pSelect;\n\n\t// Borrowed from the teensy3 SPSR emulation code\n\tstatic inline void enable_pins(void) __attribute__((always_inline)) {\n\t\t//serial_print(\"enable_pins\\n\");\n\t\tCORE_PIN11_CONFIG = PORT_PCR_DSE | PORT_PCR_MUX(2);\n\t\tCORE_PIN12_CONFIG = PORT_PCR_MUX(2);\n\t\tCORE_PIN13_CONFIG = PORT_PCR_DSE | PORT_PCR_MUX(2);\n\t}\n\n\t// Borrowed from the teensy3 SPSR emulation code\n\tstatic inline void disable_pins(void) __attribute__((always_inline)) {\n\t\t//serial_print(\"disable_pins\\n\");\n\t\tCORE_PIN11_CONFIG = PORT_PCR_SRE | PORT_PCR_DSE | PORT_PCR_MUX(1);\n\t\tCORE_PIN12_CONFIG = PORT_PCR_SRE | PORT_PCR_DSE | PORT_PCR_MUX(1);\n\t\tCORE_PIN13_CONFIG = PORT_PCR_SRE | PORT_PCR_DSE | PORT_PCR_MUX(1);\n\t}\n\npublic:\n\tARMHardwareSPIOutput() { m_pSelect = NULL; }\n\tARMHardwareSPIOutput(Selectable *pSelect) { m_pSelect = pSelect; }\n\tvoid setSelect(Selectable *pSelect) { m_pSelect = pSelect; }\n\n    static inline void update_ctar0(uint32_t ctar) __attribute__((always_inline)) {\n            if (SPI0_CTAR0 == ctar) return;\n            uint32_t mcr = SPI0_MCR;\n            if (mcr & SPI_MCR_MDIS) {\n                    SPI0_CTAR0 = ctar;\n            } else {\n                    SPI0_MCR = mcr | SPI_MCR_MDIS | SPI_MCR_HALT;\n                    SPI0_CTAR0 = ctar;\n\n                    SPI0_MCR = mcr;\n            }\n    }\t\n\n    static inline void update_ctar1(uint32_t ctar) __attribute__((always_inline)) {\n            if (SPI0_CTAR1 == ctar) return;\n            uint32_t mcr = SPI0_MCR;\n            if (mcr & SPI_MCR_MDIS) {\n                    SPI0_CTAR1 = ctar;\n            } else {\n                    SPI0_MCR = mcr | SPI_MCR_MDIS | SPI_MCR_HALT;\n                    SPI0_CTAR1 = ctar;\n                    SPI0_MCR = mcr;\n          \n            }\n    }\t\n\n    static inline void set_ctar1_bits(int bits) { \n\t    // Set ctar1 to 16 bits\n\t    int ctar = SPI0_CTAR1;\n\t    \n\t    // clear the FMSZ bits\n\t    ctar &= SPI_CTAR_FMSZ(0x0F);\n\t    ctar |= SPI_CTAR_FMSZ((bits-1) & 0x0F);\n\n\t    update_ctar1(ctar);\n    }\n\n    static inline void set_ctar0_bits(int bits) { \n\t    // Set ctar1 to 16 bits\n\t    int ctar = SPI0_CTAR1;\n\t    \n\t    // clear the FMSZ bits\n\t    ctar &= SPI_CTAR_FMSZ(0x0F);\n\t    ctar |= SPI_CTAR_FMSZ((bits-1) & 0x0F);\n\n\t    update_ctar1(ctar);\n    }\n\n\n    void setSPIRate() { \n\t\t// Configure CTAR0, defaulting to 8 bits and CTAR1, defaulting to 16 bits\n\t \tuint32_t _PBR = 0;\n\t \tuint32_t _BR = 0;\n\t \tuint32_t _CSSCK = 0;\n\t \tuint32_t _DBR = 0;\n\n\t \t// if(_SPI_CLOCK_DIVIDER >= 256) \t\t{ _PBR = 0; _BR = _CSSCK = 7; _DBR = 0; } // osc/256\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 128) \t{ _PBR = 0; _BR = _CSSCK = 6; _DBR = 0; } // osc/128\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 64) \t{ _PBR = 0; _BR = _CSSCK = 5; _DBR = 0; } // osc/64\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 32) \t{ _PBR = 0; _BR = _CSSCK = 4; _DBR = 0; } // osc/32\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 16) \t{ _PBR = 0; _BR = _CSSCK = 3; _DBR = 0; } // osc/16\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 8) \t{ _PBR = 0; _BR = _CSSCK = 1; _DBR = 0; } // osc/8\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 7) \t{ _PBR = 3; _BR = _CSSCK = 0; _DBR = 1; } // osc/7\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 5) \t{ _PBR = 2; _BR = _CSSCK = 0; _DBR = 1; } // osc/5\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 4) \t{ _PBR = 0; _BR = _CSSCK = 0; _DBR = 0; } // osc/4\n\t \t// else if(_SPI_CLOCK_DIVIDER >= 3) \t{ _PBR = 1; _BR = _CSSCK = 0; _DBR = 1; } // osc/3\n\t \t// else                                { _PBR = 0; _BR = _CSSCK = 0; _DBR = 1; } // osc/2\n\n\t \tgetScalars<_SPI_CLOCK_DIVIDER>(_PBR, _BR, _DBR);\n\t \t_CSSCK = _BR;\n\n\t \tuint32_t ctar0 = SPI_CTAR_FMSZ(7) | SPI_CTAR_PBR(_PBR) | SPI_CTAR_BR(_BR) | SPI_CTAR_CSSCK(_CSSCK);\n\t \tuint32_t ctar1 = SPI_CTAR_FMSZ(15) | SPI_CTAR_PBR(_PBR) | SPI_CTAR_BR(_BR) | SPI_CTAR_CSSCK(_CSSCK);\n\n#if USE_CONT == 1\n\t \tctar0 |= SPI_CTAR_CPHA | SPI_CTAR_CPOL;\n\t \tctar1 |= SPI_CTAR_CPHA | SPI_CTAR_CPOL;\n#endif\n\n\t \tif(_DBR) { \n\t \t\tctar0 |= SPI_CTAR_DBR;\n\t \t\tctar1 |= SPI_CTAR_DBR;\n\t \t}\n\n\t    update_ctar0(ctar0);\n\t    update_ctar1(ctar1);\n\n    }\n\t\n\tvoid init() {\n\t\t// set the pins to output\n\t\tFastPin<_DATA_PIN>::setOutput();\n\t\tFastPin<_CLOCK_PIN>::setOutput();\n\t\trelease();\n\n\t\t// Enable SPI0 clock\n\t\tuint32_t sim6 = SIM_SCGC6;\n\t\tif (!(sim6 & SIM_SCGC6_SPI0)) {\n\t\t\t//serial_print(\"init1\\n\");\n\t\t\tSIM_SCGC6 = sim6 | SIM_SCGC6_SPI0;\n\t\t\tSPI0_CTAR0 = SPI_CTAR_FMSZ(7) | SPI_CTAR_PBR(1) | SPI_CTAR_BR(1);\n\t\t}\n\n\t\tsetSPIRate();\n\n\t\t// Configure SPI as the master and enable \n\t\tSPI0_MCR |= SPI_MCR_MSTR; // | SPI_MCR_CONT_SCKE);\n\t\tSPI0_MCR &= ~(SPI_MCR_MDIS | SPI_MCR_HALT);\n\n\t\tenable_pins();\n\t}\n\n\tstatic void waitFully() __attribute__((always_inline)) { \n\t\twhile( (SPI0_SR & 0xF000) > 0); \n\t\twhile (!(SPI0_SR & SPI_SR_TCF)); \n\t\tSPI0_SR |= (SPI_SR_TCF | SPI_SR_EOQF); \n\t}\n\n\tstatic bool needwait() __attribute__((always_inline)) { return (SPI0_SR & 0x4000); }\n\tstatic void wait() __attribute__((always_inline)) { while( (SPI0_SR & 0x4000) );  }\n\tstatic void wait1() __attribute__((always_inline)) { while( (SPI0_SR & 0xF000) >= 0x2000);  }\n\t\n\tenum ECont { CONT, NOCONT };\n\tenum EWait { PRE, POST, NONE };\n\tenum ELast { NOTLAST, LAST };\n\n#if USE_CONT == 1\n\t#define CM CONT\n#else\n\t#define CM NOCONT\n#endif\n\t#define WM PRE\n\n\ttemplate<ECont CONT_STATE, EWait WAIT_STATE, ELast LAST_STATE> class Write { \n\tpublic:\n\t\tstatic void writeWord(uint16_t w) __attribute__((always_inline)) { \n\t\t\tif(WAIT_STATE == PRE) { wait(); }\n\t\t\tSPI0_PUSHR = ((LAST_STATE == LAST) ? SPI_PUSHR_EOQ : 0) |\n\t\t\t             ((CONT_STATE == CONT) ? SPI_PUSHR_CONT : 0) | \n\t\t\t             SPI_PUSHR_CTAS(1) | (w & 0xFFFF);\n\t\t\tif(WAIT_STATE == POST) { wait(); }\n\t\t}\n\n\t\tstatic void writeByte(uint8_t b) __attribute__((always_inline)) { \n\t\t\tif(WAIT_STATE == PRE) { wait(); }\n\t\t\tSPI0_PUSHR = ((LAST_STATE == LAST) ? SPI_PUSHR_EOQ : 0) |\n\t\t\t             ((CONT_STATE == CONT) ? SPI_PUSHR_CONT : 0) | \n\t\t\t             SPI_PUSHR_CTAS(0) | (b & 0xFF);\n\t\t\tif(WAIT_STATE == POST) { wait(); }\n\t\t}\n\t};\n\n\tstatic void writeWord(uint16_t w) __attribute__((always_inline)) { wait(); SPI0_PUSHR = SPI_PUSHR_CTAS(1) | (w & 0xFFFF); }\n\tstatic void writeWordNoWait(uint16_t w) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CTAS(1) | (w & 0xFFFF); }\n\n\tstatic void writeByte(uint8_t b) __attribute__((always_inline)) { wait(); SPI0_PUSHR = SPI_PUSHR_CTAS(0) | (b & 0xFF); }\n\tstatic void writeBytePostWait(uint8_t b) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CTAS(0) | (b & 0xFF); wait(); }\n\tstatic void writeByteNoWait(uint8_t b) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CTAS(0) | (b & 0xFF); }\n\n\tstatic void writeWordCont(uint16_t w) __attribute__((always_inline)) { wait(); SPI0_PUSHR = SPI_PUSHR_CONT | SPI_PUSHR_CTAS(1) | (w & 0xFFFF); }\n\tstatic void writeWordContNoWait(uint16_t w) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CONT | SPI_PUSHR_CTAS(1) | (w & 0xFFFF); }\n\n\tstatic void writeByteCont(uint8_t b) __attribute__((always_inline)) { wait(); SPI0_PUSHR = SPI_PUSHR_CONT | SPI_PUSHR_CTAS(0) | (b & 0xFF); }\n\tstatic void writeByteContPostWait(uint8_t b) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CONT | SPI_PUSHR_CTAS(0) | (b & 0xFF); wait(); }\n\tstatic void writeByteContNoWait(uint8_t b) __attribute__((always_inline)) { SPI0_PUSHR = SPI_PUSHR_CONT | SPI_PUSHR_CTAS(0) | (b & 0xFF); }\n\n\t// not the most efficient mechanism in the world - but should be enough for sm16716 and friends\n\ttemplate <uint8_t BIT> inline static void writeBit(uint8_t b) { \n\t\tuint32_t ctar1_save = SPI0_CTAR1;\n\n\t\t// Clear out the FMSZ bits, reset them for 9 bits transferd for the start bit\n\t\tuint32_t ctar1 = (ctar1_save & (~SPI_CTAR_FMSZ(15))) | SPI_CTAR_FMSZ(0);\n\t\tupdate_ctar1(ctar1);\n\n\t\twriteWord( (b & (1 << BIT)) != 0);\n\n\t\tupdate_ctar1(ctar1_save);\n\t}\n\n\tvoid inline select() __attribute__((always_inline)) { if(m_pSelect != NULL) { m_pSelect->select(); } } \n\tvoid inline release() __attribute__((always_inline)) { if(m_pSelect != NULL) { m_pSelect->release(); } } \n\n\tstatic void writeBytesValueRaw(uint8_t value, int len) {\n\t\twhile(len--) { Write<CM, WM, NOTLAST>::writeByte(value); }\n\t}\n\n\tvoid writeBytesValue(uint8_t value, int len) { \n\t\tsetSPIRate();\n\t\tselect();\n\t\twhile(len--) { \n\t\t\twriteByte(value);\n\t\t}\n\t\twaitFully();\n\t\trelease();\n\t}\n\t\n\t// Write a block of n uint8_ts out \n\ttemplate <class D> void writeBytes(register uint8_t *data, int len) { \n\t\tsetSPIRate();\n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\twhile(data != end) { \n\t\t\twriteByte(D::adjust(*data++));\n\t\t}\n\t\tD::postBlock(len);\n\t\twaitFully();\n\t\trelease();\t\n\t}\n\n\tvoid writeBytes(register uint8_t *data, int len) { writeBytes<DATA_NOP>(data, len); }\n\n\t// write a block of uint8_ts out in groups of three.  len is the total number of uint8_ts to write out.  The template\n\t// parameters indicate how many uint8_ts to skip at the beginning and/or end of each grouping\n\ttemplate <uint8_t SKIP, class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\t// setSPIRate();\n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\tif((SKIP & FLAG_START_BIT) == 0) {\n\t\t\t//If no start bit stupiditiy, write out as many 16-bit blocks as we can\n\t\t\tuint8_t *first_end = end - (len % (SPI_ADVANCE * 2));\n\t\t\t\n\t\t\twhile(data != first_end) {\n\t\t\t\tif(WM == NONE) { wait1(); }\n\t\t\t\tWrite<CM, WM, NOTLAST>::writeWord(D::adjust(data[SPI_B0], scale) << 8 | D::adjust(data[SPI_B1], scale));\n\t\t\t\tWrite<CM, WM, NOTLAST>::writeWord(D::adjust(data[SPI_B2], scale) << 8 | D::adjust(data[SPI_ADVANCE + SPI_B0], scale));\n\t\t\t\tWrite<CM, WM, NOTLAST>::writeWord(D::adjust(data[SPI_ADVANCE + SPI_B1], scale) << 8 | D::adjust(data[SPI_ADVANCE + SPI_B2], scale));\n\t\t\t\tdata += (SPI_ADVANCE + SPI_ADVANCE);\n\t\t\t}\n\n\t\t\tif(data != end) { \n\t\t\t\tif(WM == NONE) { wait1(); }\n\t\t\t\t// write out the rest as alternating 16/8-bit blocks (likely to be just one)\n\t\t\t\tWrite<CM, WM, NOTLAST>::writeWord(D::adjust(data[SPI_B0], scale) << 8 | D::adjust(data[SPI_B1], scale));\n\t\t\t\tWrite<CM, WM, NOTLAST>::writeByte(D::adjust(data[SPI_B2], scale));\n\t\t\t}\n\n\t\t\tD::postBlock(len);\n\t\t\twaitFully();\n\t\t} else if(SKIP & FLAG_START_BIT) {\n\t\t\tuint32_t ctar1_save = SPI0_CTAR1;\n\n\t\t\t// Clear out the FMSZ bits, reset them for 9 bits transferd for the start bit\n\t\t\tuint32_t ctar1 = (ctar1_save & (~SPI_CTAR_FMSZ(15))) | SPI_CTAR_FMSZ(8);\n\t\t\tupdate_ctar1(ctar1);\n\n\t\t\twhile(data != end) { \n\t\t\t\twriteWord( 0x100 | D::adjust(data[SPI_B0], scale));\n\t\t\t\twriteByte(D::adjust(data[SPI_B1], scale));\n\t\t\t\twriteByte(D::adjust(data[SPI_B2], scale));\n\t\t\t\tdata += SPI_ADVANCE;\n\t\t\t}\n\t\t\tD::postBlock(len);\n\t\t\twaitFully();\n\n\t\t\t// restore ctar1\n\t\t\tupdate_ctar1(ctar1_save);\n\t\t// } else {\n\t\t// \twhile(data != end) { \n\t\t// \t\twriteByte(D::adjust(data[SPI_B0], scale);\n\t\t// \t\twriteWord(D::adjust(data[SPI_B1], scale) << 8 | D::adjust(data[SPI_B2], scale));\n\t\t// \t\tdata += SPI_ADVANCE;\n\t\t// \t}\n\t\t// \twaitFully();\n\t\t}\n\t\trelease();\n\t}\n\n\n\ttemplate <uint8_t SKIP, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<SKIP, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, D, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\tvoid writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB>(data, len, scale); \n\t}\n};\n#endif\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/fastspi_avr.h",
      code: "#ifndef __INC_FASTSPI_AVR_H\n#define __INC_FASTSPI_AVR_H\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Hardware SPI support using USART registers and friends\n//\n// TODO: Complete/test implementation - right now this doesn't work\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\n// uno/mini/duemilanove\n#if defined(AVR_HARDWARE_SPI)\n#if defined(UBRR0)\ntemplate <uint8_t _DATA_PIN, uint8_t _CLOCK_PIN, uint8_t _SPI_CLOCK_DIVIDER>\nclass AVRUSARTSPIOutput { \n\tSelectable *m_pSelect;\n\npublic:\n\tAVRUSARTSPIOutput() { m_pSelect = NULL; }\n\tAVRUSARTSPIOutput(Selectable *pSelect) { m_pSelect = pSelect; }\n\tvoid setSelect(Selectable *pSelect) { m_pSelect = pSelect; }\n\n\tvoid init() { \n\t\tUBRR0 = 0;\n\t\tUCSR0A = 1<<TXC0;\n\n\t\tFastPin<_CLOCK_PIN>::setOutput();\n\t\tFastPin<_DATA_PIN>::setOutput();\n\n\t\tUCSR0C = _BV (UMSEL00) | _BV (UMSEL01);  // Master SPI mode\n\t\tUCSR0B = _BV (TXEN0) | _BV (RXEN0);  // transmit enable and receive enable\n\n\t\t// must be done last, see page 206\n\t\tUBRR0 = 3;  // 2 Mhz clock rate\n\t}\n\n\tstatic void stop() { \n\t\t// TODO: stop the uart spi output\n\t}\n\n\tstatic void wait() __attribute__((always_inline)) { while(!(UCSR0A & (1<<UDRE0))); }\n\tstatic void waitFully() __attribute__((always_inline)) { wait(); }\n\t\n\tstatic void writeByteNoWait(uint8_t b) __attribute__((always_inline)) { UDR0 = b;}\n\tstatic void writeBytePostWait(uint8_t b) __attribute__((always_inline)) { UDR0 = b; wait(); }\n\tstatic void writeByte(uint8_t b) __attribute__((always_inline)) { wait(); UDR0 = b; }\n\n\tstatic void writeWord(uint16_t w) __attribute__((always_inline)) { writeByte(w>>8); writeByte(w&0xFF); }\n\t\n\ttemplate <uint8_t BIT> inline static void writeBit(uint8_t b) { \n\t\tif(b && (1 << BIT)) { \n\t\t\tFastPin<_DATA_PIN>::hi();\n\t\t} else { \n\t\t\tFastPin<_DATA_PIN>::lo();\n\t\t}\n\n\t\tFastPin<_CLOCK_PIN>::hi();\n\t\tFastPin<_CLOCK_PIN>::lo();\n\t}\n\n\tvoid select() { if(m_pSelect != NULL) { m_pSelect->select(); } } // FastPin<_SELECT_PIN>::hi(); }\n\tvoid release() { \n\t\t// wait for all transmissions to finish\n  \t\twhile ((UCSR0A & (1 <<TXC0)) == 0) {}\n    \tif(m_pSelect != NULL) { m_pSelect->release(); } // FastPin<_SELECT_PIN>::hi(); \n\t}\n\n\tstatic void writeBytesValueRaw(uint8_t value, int len) {\n\t\twhile(len--) { writeByte(value); }\n\t}\n\t\n\tvoid writeBytesValue(uint8_t value, int len) { \n\t\tselect();\n\t\twhile(len--) { \n\t\t\twriteByte(value);\n\t\t}\n\t\trelease();\n\t}\n\t\n\t// Write a block of n uint8_ts out \n\ttemplate <class D> void writeBytes(register uint8_t *data, int len) { \n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\twhile(data != end) { \n#if defined(__MK20DX128__) \n\t\t\twriteByte(D::adjust(*data++));\n#else\n\t\t\t// a slight touch of delay here helps optimize the timing of the status register check loop (not used on ARM)\n\t\t\twriteByte(D::adjust(*data++)); delaycycles<3>();\n#endif\n\t\t}\n\t\tD::postBlock(len);\n\t\trelease();\t\n\t}\n\n\tvoid writeBytes(register uint8_t *data, int len) { writeBytes<DATA_NOP>(data, len); }\n\n\t// write a block of uint8_ts out in groups of three.  len is the total number of uint8_ts to write out.  The template\n\t// parameters indicate how many uint8_ts to skip at the beginning and/or end of each grouping\n\ttemplate <uint8_t SKIP, class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\twhile(data != end) { \n\t\t\twriteByte(D::adjust(data[SPI_B0], scale));\n\t\t\twriteByte(D::adjust(data[SPI_B1], scale));\n\t\t\twriteByte(D::adjust(data[SPI_B2], scale));\n\t\t\tdata += SPI_ADVANCE;\n\t\t}\n\t\tD::postBlock(len);\n\t\trelease();\n\t}\n\n\ttemplate <uint8_t SKIP, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<SKIP, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, D, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\tvoid writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB>(data, len, scale); \n\t}\n\n};\n\n#endif\n\n#if defined(SPSR)\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Hardware SPI support using SPDR registers and friends\n//\n// Technically speaking, this uses the AVR SPI registers.  This will work on the Teensy 3.0 because Paul made a set of compatability\n// classes that map the AVR SPI registers to ARM's, however this caps the performance of output.  \n//\n// TODO: implement ARMHardwareSPIOutput\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t _DATA_PIN, uint8_t _CLOCK_PIN, uint8_t _SPI_CLOCK_DIVIDER>\nclass AVRHardwareSPIOutput { \n\tSelectable *m_pSelect;\n\tbool mWait;\npublic:\n\tAVRHardwareSPIOutput() { m_pSelect = NULL; mWait = false;}\n\tAVRHardwareSPIOutput(Selectable *pSelect) { m_pSelect = pSelect; }\n\tvoid setSelect(Selectable *pSelect) { m_pSelect = pSelect; }\n\n\tvoid setSPIRate() { \n\t\tSPCR &= ~ ( (1<<SPR1) | (1<<SPR0) ); \t// clear out the prescalar bits\n\n\t    bool b2x = false;\n\n\t    if(_SPI_CLOCK_DIVIDER >= 128) { SPCR |= (1<<SPR1); SPCR |= (1<<SPR0); }\n\t    else if(_SPI_CLOCK_DIVIDER >= 64) { SPCR |= (1<<SPR1);}\n\t    else if(_SPI_CLOCK_DIVIDER >= 32) { SPCR |= (1<<SPR1); b2x = true;  }\n\t    else if(_SPI_CLOCK_DIVIDER >= 16) { SPCR |= (1<<SPR0); } \n\t    else if(_SPI_CLOCK_DIVIDER >= 8) { SPCR |= (1<<SPR0); b2x = true; }\n\t    else if(_SPI_CLOCK_DIVIDER >= 4) { /* do nothing - default rate */ }\n\t    else { b2x = true; }\n\n\t    if(b2x) { SPSR |= (1<<SPI2X); }\n\t    else { SPSR &= ~ (1<<SPI2X); }\n\t}\n\t\n\tvoid init() {\n\t\tvolatile uint8_t clr;\n\n\t\t// set the pins to output\n\t\tFastPin<_DATA_PIN>::setOutput();\n\t\tFastPin<_CLOCK_PIN>::setOutput();\n#ifdef SPI_SELECT\n\t\t// Make sure the slave select line is set to output, or arduino will block us\n\t\tFastPin<SPI_SELECT>::setOutput();\n\t\tFastPin<SPI_SELECT>::lo();\n#endif\n\t\trelease();\n\n\t\tSPCR |= ((1<<SPE) | (1<<MSTR) ); \t\t// enable SPI as master\n\t\tSPCR &= ~ ( (1<<SPR1) | (1<<SPR0) ); \t// clear out the prescalar bits\n\n\t\tclr = SPSR; // clear SPI status register \n\t\tclr = SPDR; // clear SPI data register\n\t\tclr; \n\n\t    bool b2x = false;\n\n\t    if(_SPI_CLOCK_DIVIDER >= 128) { SPCR |= (1<<SPR1); SPCR |= (1<<SPR0); }\n\t    else if(_SPI_CLOCK_DIVIDER >= 64) { SPCR |= (1<<SPR1);}\n\t    else if(_SPI_CLOCK_DIVIDER >= 32) { SPCR |= (1<<SPR1); b2x = true;  }\n\t    else if(_SPI_CLOCK_DIVIDER >= 16) { SPCR |= (1<<SPR0); } \n\t    else if(_SPI_CLOCK_DIVIDER >= 8) { SPCR |= (1<<SPR0); b2x = true; }\n\t    else if(_SPI_CLOCK_DIVIDER >= 4) { /* do nothing - default rate */ }\n\t    else { b2x = true; }\n\n\t    if(b2x) { SPSR |= (1<<SPI2X); }\n\t    else { SPSR &= ~ (1<<SPI2X); }\n\n\t    SPDR=0;\n\t    shouldWait(false);\n\t}\n\n\tstatic bool shouldWait(bool wait = false) __attribute__((always_inline)) { \n\t\tstatic bool sWait=false; \n\t\tif(sWait) { sWait = wait; return true; } else { sWait = wait; return false; } \n\t\t// return true;\n\t}\n\tstatic void wait() __attribute__((always_inline)) { if(shouldWait()) { while(!(SPSR & (1<<SPIF))); } }\n\tstatic void waitFully() __attribute__((always_inline)) { wait(); }\n\n\tstatic void writeByte(uint8_t b) __attribute__((always_inline)) { wait(); SPDR=b;  shouldWait(true); }\n\tstatic void writeBytePostWait(uint8_t b) __attribute__((always_inline)) { SPDR=b; shouldWait(true); wait(); }\n\tstatic void writeByteNoWait(uint8_t b) __attribute__((always_inline)) { SPDR=b; shouldWait(true); }\n\n\ttemplate <uint8_t BIT> inline static void writeBit(uint8_t b) { \n\t\tSPCR &= ~(1 << SPE);\n\t\tif(b & (1 << BIT)) { \n\t\t\tFastPin<_DATA_PIN>::hi();\n\t\t} else { \n\t\t\tFastPin<_DATA_PIN>::lo();\n\t\t}\n\n\t\tFastPin<_CLOCK_PIN>::hi();\n\t\tFastPin<_CLOCK_PIN>::lo();\n\t\tSPCR |= 1 << SPE;\n\t\tshouldWait(false);\n\t}\n\n\tvoid select() { if(m_pSelect != NULL) { m_pSelect->select(); } } // FastPin<_SELECT_PIN>::hi(); }\n\tvoid release() { if(m_pSelect != NULL) { m_pSelect->release(); } } // FastPin<_SELECT_PIN>::lo(); }\n\n\tstatic void writeBytesValueRaw(uint8_t value, int len) {\n\t\twhile(len--) { writeByte(value); }\n\t}\n\n\tvoid writeBytesValue(uint8_t value, int len) { \n\t\t//setSPIRate();\n\t\tselect();\n\t\twhile(len--) { \n\t\t\twriteByte(value);\n\t\t}\n\t\trelease();\n\t}\n\t\n\t// Write a block of n uint8_ts out \n\ttemplate <class D> void writeBytes(register uint8_t *data, int len) { \n\t\t//setSPIRate();\n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\twhile(data != end) { \n\t\t\t// a slight touch of delay here helps optimize the timing of the status register check loop (not used on ARM)\n\t\t\twriteByte(D::adjust(*data++)); delaycycles<3>();\n\t\t}\n\t\trelease();\t\n\t}\n\n\tvoid writeBytes(register uint8_t *data, int len) { writeBytes<DATA_NOP>(data, len); }\n\n\t// write a block of uint8_ts out in groups of three.  len is the total number of uint8_ts to write out.  The template\n\t// parameters indicate how many uint8_ts to skip at the beginning and/or end of each grouping\n\ttemplate <uint8_t SKIP, class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\t//setSPIRate();\n\t\tuint8_t *end = data + len;\n\t\tselect();\n\t\twhile(data != end) { \n\t\t\tif(SKIP & FLAG_START_BIT) { \n\t\t\t\twriteBit<0>(1);\n\t\t\t}\n\t\t\t// a slight touch of delay here helps optimize the timing of the status register check loop (not used on ARM)\n\t\t\tif(false && _SPI_CLOCK_DIVIDER == 0) { \n\t\t\t\twriteByteNoWait(D::adjust(data[SPI_B0], scale)); delaycycles<13>();\n\t\t\t\twriteByteNoWait(D::adjust(data[SPI_B1], scale)); delaycycles<13>();\n\t\t\t\twriteByteNoWait(D::adjust(data[SPI_B2], scale)); delaycycles<9>();\n\t\t\t} else if(SKIP & FLAG_START_BIT) { \n\t\t\t\twriteBytePostWait(D::adjust(data[SPI_B0], scale));\n\t\t\t\twriteBytePostWait(D::adjust(data[SPI_B1], scale));\n\t\t\t\twriteBytePostWait(D::adjust(data[SPI_B2], scale));\n\t\t\t} else { \n\t\t\t\twriteByte(D::adjust(data[SPI_B0], scale));\n\t\t\t\twriteByte(D::adjust(data[SPI_B1], scale));\n\t\t\t\twriteByte(D::adjust(data[SPI_B2], scale));\n\t\t\t}\n\n\t\t\tdata += SPI_ADVANCE;\n\t\t}\n\t\tD::postBlock(len);\n\t\trelease();\n\t}\n\n\ttemplate <uint8_t SKIP, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<SKIP, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, D, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\tvoid writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB>(data, len, scale); \n\t}\n\n};\n#endif\n\n#else\n// #define FORCE_SOFTWARE_SPI\n#endif\n\n#endif"
    }, {
      filename: "FastLED-2-final/fastspi_bitbang.h",
      code: "#ifndef __INC_FASTSPI_BITBANG_H\n#define __INC_FASTSPI_BITBANG_H\n\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n//\n// Software SPI (aka bit-banging) support - with aggressive optimizations for when the clock and data pin are on the same port\n//\n// TODO: Replace the select pin definition with a set of pins, to allow using mux hardware for routing in the future\n//\n//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////\n\ntemplate <uint8_t DATA_PIN, uint8_t CLOCK_PIN, uint8_t SPI_SPEED>\nclass AVRSoftwareSPIOutput { \n\t// The data types for pointers to the pin port - typedef'd here from the Pin definition because on avr these\n\t// are pointers to 8 bit values, while on arm they are 32 bit\n\ttypedef typename FastPin<DATA_PIN>::port_ptr_t data_ptr_t;\n\ttypedef typename FastPin<CLOCK_PIN>::port_ptr_t clock_ptr_t;\n\n\t// The data type for what's at a pin's port - typedef'd here from the Pin definition because on avr the ports\n\t// are 8 bits wide while on arm they are 32.\n\ttypedef typename FastPin<DATA_PIN>::port_t data_t;\n\ttypedef typename FastPin<CLOCK_PIN>::port_t clock_t;\n\tSelectable \t*m_pSelect;\n\npublic:\n\tAVRSoftwareSPIOutput() { m_pSelect = NULL; }\n\tAVRSoftwareSPIOutput(Selectable *pSelect) { m_pSelect = pSelect; }\n\tvoid setSelect(Selectable *pSelect) { m_pSelect = pSelect; }\n\n\tvoid init() {\n\t\t// set the pins to output and make sure the select is released (which apparently means hi?  This is a bit\n\t\t// confusing to me)\n\t\tFastPin<DATA_PIN>::setOutput();\n\t\tFastPin<CLOCK_PIN>::setOutput();\n\t\trelease();\n\t}\n\n\t// stop the SPI output.  Pretty much a NOP with software, as there's no registers to kick\n\tstatic void stop() { }\n\n\t// wait until the SPI subsystem is ready for more data to write.  A NOP when bitbanging\n\tstatic void wait() __attribute__((always_inline)) { }\n\tstatic void waitFully() __attribute__((always_inline)) { wait(); }\n\t\t\n\tstatic void writeByteNoWait(uint8_t b) __attribute__((always_inline)) { writeByte(b); }\n\tstatic void writeBytePostWait(uint8_t b) __attribute__((always_inline)) { writeByte(b); wait(); }\n\n\tstatic void writeWord(uint16_t w) __attribute__((always_inline)) { writeByte(w>>8); writeByte(w&0xFF); }\n\t\n\t// naive writeByte implelentation, simply calls writeBit on the 8 bits in the byte.\n\tstatic void writeByte(uint8_t b) __attribute__((always_inline)) { \n\t\twriteBit<7>(b);\n\t\twriteBit<6>(b);\n\t\twriteBit<5>(b);\n\t\twriteBit<4>(b);\n\t\twriteBit<3>(b);\n\t\twriteBit<2>(b);\n\t\twriteBit<1>(b);\n\t\twriteBit<0>(b);\n\t}\n\nprivate:\t\n\t// writeByte implementation with data/clock registers passed in.\n\tstatic void writeByte(uint8_t b, clock_ptr_t clockpin, data_ptr_t datapin) __attribute__((always_inline)) { \n\t\twriteBit<7>(b, clockpin, datapin);\n\t\twriteBit<6>(b, clockpin, datapin);\n\t\twriteBit<5>(b, clockpin, datapin);\n\t\twriteBit<4>(b, clockpin, datapin);\n\t\twriteBit<3>(b, clockpin, datapin);\n\t\twriteBit<2>(b, clockpin, datapin);\n\t\twriteBit<1>(b, clockpin, datapin);\n\t\twriteBit<0>(b, clockpin, datapin);\n\t}\n\n\t// writeByte implementation with the data register passed in and prebaked values for data hi w/clock hi and\n\t// low and data lo w/clock hi and lo.  This is to be used when clock and data are on the same GPIO register, \n\t// can get close to getting a bit out the door in 2 clock cycles!\n\tstatic void writeByte(uint8_t b, data_ptr_t datapin, \n\t\t\t\t\t\t  data_t hival, data_t loval, \n\t\t\t\t\t\t  clock_t hiclock, clock_t loclock) __attribute__((always_inline, hot)) { \n\t\twriteBit<7>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<6>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<5>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<4>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<3>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<2>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<1>(b, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<0>(b, datapin, hival, loval, hiclock, loclock);\n\t}\n\n\t// writeByte implementation with not just registers passed in, but pre-baked values for said registers for\n\t// data hi/lo and clock hi/lo values.  Note: weird things will happen if this method is called in cases where\n\t// the data and clock pins are on the same port!  Don't do that!\n\tstatic void writeByte(uint8_t b, clock_ptr_t clockpin, data_ptr_t datapin, \n\t\t\t\t\t\t  data_t hival, data_t loval, \n\t\t\t\t\t\t  clock_t hiclock, clock_t loclock) __attribute__((always_inline)) { \n\t\twriteBit<7>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<6>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<5>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<4>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<3>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<2>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<1>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t\twriteBit<0>(b, clockpin, datapin, hival, loval, hiclock, loclock);\n\t}\n\npublic:\n\t#define SPI_DELAY delaycycles< (SPI_SPEED-2) / 2>();\n\n\t// write the BIT'th bit out via spi, setting the data pin then strobing the clcok\n\ttemplate <uint8_t BIT> __attribute__((always_inline, hot)) inline static void writeBit(uint8_t b) { \n\t\tif(b & (1 << BIT)) { \n\t\t\tFastPin<DATA_PIN>::hi();\n\t\t\tif(SPI_SPEED < 3) { \n\t\t\t\tFastPin<CLOCK_PIN>::strobe();\n\t\t\t} else { \n\t\t\t\tFastPin<CLOCK_PIN>::hi(); SPI_DELAY;\n\t\t\t\tFastPin<CLOCK_PIN>::lo(); SPI_DELAY;\n\t\t\t}\n\t\t} else { \n\t\t\tFastPin<DATA_PIN>::lo();\n\t\t\tif(SPI_SPEED < 3) { \n\t\t\t\tFastPin<CLOCK_PIN>::strobe();\n\t\t\t} else { \n\t\t\t\tFastPin<CLOCK_PIN>::hi(); SPI_DELAY;\n\t\t\t\tFastPin<CLOCK_PIN>::lo(); SPI_DELAY;\n\t\t\t}\n\t\t}\n\t}\n\t\nprivate:\n\t// write the BIT'th bit out via spi, setting the data pin then strobing the clock, using the passed in pin registers to accelerate access if needed\n\ttemplate <uint8_t BIT> __attribute__((always_inline)) inline static void writeBit(uint8_t b, clock_ptr_t clockpin, data_ptr_t datapin) { \n\t\tif(b & (1 << BIT)) { \n\t\t\tFastPin<DATA_PIN>::hi(datapin);\n\t\t\tFastPin<CLOCK_PIN>::hi(clockpin); SPI_DELAY;\n\t\t\tFastPin<CLOCK_PIN>::lo(clockpin); SPI_DELAY;\n\t\t} else { \n\t\t\tFastPin<DATA_PIN>::lo(datapin);\n\t\t\tFastPin<CLOCK_PIN>::hi(clockpin); SPI_DELAY;\n\t\t\tFastPin<CLOCK_PIN>::lo(clockpin); SPI_DELAY;\n\t\t}\n\n\t}\n\n\t// the version of write to use when clock and data are on separate pins with precomputed values for setting\n\t// the clock and data pins\n\ttemplate <uint8_t BIT> __attribute__((always_inline)) inline static void writeBit(uint8_t b, clock_ptr_t clockpin, data_ptr_t datapin, \n\t\t\t\t\t\t\t\t\t\t\t\t\tdata_t hival, data_t loval, clock_t hiclock, clock_t loclock) { \n\t\t// // only need to explicitly set clock hi if clock and data are on different ports\n\t\tif(b & (1 << BIT)) { \n\t\t\tFastPin<DATA_PIN>::fastset(datapin, hival);\n\t\t\tFastPin<CLOCK_PIN>::fastset(clockpin, hiclock); SPI_DELAY;\n\t\t\tFastPin<CLOCK_PIN>::fastset(clockpin, loclock); SPI_DELAY;\n\t\t} else { \n\t\t\t// NOP;\n\t\t\tFastPin<DATA_PIN>::fastset(datapin, loval);\n\t\t\tFastPin<CLOCK_PIN>::fastset(clockpin, hiclock); SPI_DELAY;\n\t\t\tFastPin<CLOCK_PIN>::fastset(clockpin, loclock); SPI_DELAY;\n\t\t}\n\t}\n\n\t// the version of write to use when clock and data are on the same port with precomputed values for the various\n\t// combinations\n\ttemplate <uint8_t BIT> __attribute__((always_inline)) inline static void writeBit(uint8_t b, data_ptr_t clockdatapin, \n\t\t\t\t\t\t\t\t\t\t\t\t\tdata_t datahiclockhi, data_t dataloclockhi, \n\t\t\t\t\t\t\t\t\t\t\t\t\tdata_t datahiclocklo, data_t dataloclocklo) { \n#if 0\n\t\twriteBit<BIT>(b);\n#else\n\t\tif(b & (1 << BIT)) { \n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, datahiclocklo); SPI_DELAY;\n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, datahiclockhi); SPI_DELAY;\n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, datahiclocklo); SPI_DELAY;\n\t\t} else { \n\t\t\t// NOP;\n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, dataloclocklo); SPI_DELAY;\n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, dataloclockhi); SPI_DELAY;\n\t\t\tFastPin<DATA_PIN>::fastset(clockdatapin, dataloclocklo); SPI_DELAY;\n\t\t}\n#endif\n\t}\npublic:\n\n\t// select the SPI output (TODO: research whether this really means hi or lo.  Alt TODO: move select responsibility out of the SPI classes\n\t// entirely, make it up to the caller to remember to lock/select the line?)\n\tvoid select() { if(m_pSelect != NULL) { m_pSelect->select(); } } // FastPin<SELECT_PIN>::hi(); }\n\n\t// release the SPI line\n\tvoid release() { if(m_pSelect != NULL) { m_pSelect->release(); } } // FastPin<SELECT_PIN>::lo(); }\n\n\t// Write out len bytes of the given value out over SPI.  Useful for quickly flushing, say, a line of 0's down the line.\n\tvoid writeBytesValue(uint8_t value, int len) { \n\t\tselect();\n\t\twriteBytesValueRaw(value, len);\n\t\trelease();\n\t}\n\n\tstatic void writeBytesValueRaw(uint8_t value, int len) {\n#ifdef FAST_SPI_INTERRUPTS_WRITE_PINS\n\t\t// TODO: Weird things may happen if software bitbanging SPI output and other pins on the output reigsters are being twiddled.  Need\n\t\t// to allow specifying whether or not exclusive i/o access is allowed during this process, and if i/o access is not allowed fall\n\t\t// back to the degenerative code below\n\t\twhile(len--) { \n\t\t\twriteByte(value);\n\t\t}\n#else\n\t\tregister data_ptr_t datapin = FastPin<DATA_PIN>::port();\n\n\t\tif(FastPin<DATA_PIN>::port() != FastPin<CLOCK_PIN>::port()) {\n\t\t\t// If data and clock are on different ports, then writing a bit will consist of writing the value foor\n\t\t\t// the bit (hi or low) to the data pin port, and then two writes to the clock port to strobe the clock line\n\t\t\tregister clock_ptr_t clockpin = FastPin<CLOCK_PIN>::port();\n\t\t\tregister data_t datahi = FastPin<DATA_PIN>::hival();\n\t\t\tregister data_t datalo = FastPin<DATA_PIN>::loval();\n\t\t\tregister clock_t clockhi = FastPin<CLOCK_PIN>::hival();\n\t\t\tregister clock_t clocklo = FastPin<CLOCK_PIN>::loval();\n\t\t\twhile(len--) { \n\t\t\t\twriteByte(value, clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t}\n\n\t\t} else {\n\t\t\t// If data and clock are on the same port then we can combine setting the data and clock pins \n\t\t\tregister data_t datahi_clockhi = FastPin<DATA_PIN>::hival() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clockhi = FastPin<DATA_PIN>::loval() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datahi_clocklo = FastPin<DATA_PIN>::hival() & ~FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clocklo = FastPin<DATA_PIN>::loval() & ~FastPin<CLOCK_PIN>::mask();\n\n\t\t\twhile(len--) { \n\t\t\t\twriteByte(value, datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t}\n\t\t}\n#endif\n\t}\n\n\t// write a block of len uint8_ts out.  Need to type this better so that explicit casts into the call aren't required.\n\t// note that this template version takes a class parameter for a per-byte modifier to the data. \n\ttemplate <class D> void writeBytes(register uint8_t *data, int len) { \n\t\tselect();\n#ifdef FAST_SPI_INTERRUPTS_WRITE_PINS\n\t\tuint8_t *end = data + len;\n\t\twhile(data != end) { \n\t\t\twriteByte(D::adjust(*data++));\n\t\t}\n#else\n\t\tregister clock_ptr_t clockpin = FastPin<CLOCK_PIN>::port();\n\t\tregister data_ptr_t datapin = FastPin<DATA_PIN>::port();\n\n\t\tif(FastPin<DATA_PIN>::port() != FastPin<CLOCK_PIN>::port()) {\n\t\t\t// If data and clock are on different ports, then writing a bit will consist of writing the value foor\n\t\t\t// the bit (hi or low) to the data pin port, and then two writes to the clock port to strobe the clock line\n\t\t\tregister data_t datahi = FastPin<DATA_PIN>::hival();\n\t\t\tregister data_t datalo = FastPin<DATA_PIN>::loval();\n\t\t\tregister clock_t clockhi = FastPin<CLOCK_PIN>::hival();\n\t\t\tregister clock_t clocklo = FastPin<CLOCK_PIN>::loval();\n\t\t\tuint8_t *end = data + len;\n\n\t\t\twhile(data != end) { \n\t\t\t\twriteByte(D::adjust(*data++), clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t}\n\n\t\t} else {\n\t\t\t// FastPin<CLOCK_PIN>::hi();\n\t\t\t// If data and clock are on the same port then we can combine setting the data and clock pins \n\t\t\tregister data_t datahi_clockhi = FastPin<DATA_PIN>::hival() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clockhi = FastPin<DATA_PIN>::loval() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datahi_clocklo = FastPin<DATA_PIN>::hival() & ~FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clocklo = FastPin<DATA_PIN>::loval() & ~FastPin<CLOCK_PIN>::mask();\n\t\t\t\n\t\t\tuint8_t *end = data + len;\n\n\t\t\twhile(data != end) { \n\t\t\t\twriteByte(D::adjust(*data++), datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t}\n\t\t\t// FastPin<CLOCK_PIN>::lo();\n\t\t}\n#endif\n\t\tD::postBlock(len);\n\t\trelease();\t\n\t}\n\n\t// default version of writing a block of data out to the SPI port, with no data modifications being made\n\tvoid writeBytes(register uint8_t *data, int len) { writeBytes<DATA_NOP>(data, len); }\n\n\n\t// write a block of uint8_ts out in groups of three.  len is the total number of uint8_ts to write out.  The template\n\t// parameters indicate how many uint8_ts to skip at the beginning of each grouping, as well as a class specifying a per\n\t// byte of data modification to be made.  (See DATA_NOP above)\n\ttemplate <uint8_t SKIP, class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\tselect();\n\n#ifdef FAST_SPI_INTERRUPTS_WRITE_PINS\n\t\t// If interrupts or other things may be generating output while we're working on things, then we need\n\t\t// to use this block\n\t\tuint8_t *end = data + len;\n\t\twhile(data != end) { \n\t\t\tif(SKIP & FLAG_START_BIT) { \n\t\t\t\twriteBit<0>(1);\n\t\t\t}\n\t\t\twriteByte(D::adjust(data[SPI_B0], scale));\n\t\t\twriteByte(D::adjust(data[SPI_B1], scale));\n\t\t\twriteByte(D::adjust(data[SPI_B2], scale));\n\t\t\tdata += SPI_ADVANCE;\n\t\t}\n#else\n\t\t// If we can guaruntee that no one else will be writing data while we are running (namely, changing the values of the PORT/PDOR pins)\n\t\t// then we can use a bunch of optimizations in here\n\t\tregister data_ptr_t datapin = FastPin<DATA_PIN>::port();\n\n\t\tif(FastPin<DATA_PIN>::port() != FastPin<CLOCK_PIN>::port()) {\n\t\t\tregister clock_ptr_t clockpin = FastPin<CLOCK_PIN>::port();\n\t\t\t// If data and clock are on different ports, then writing a bit will consist of writing the value foor\n\t\t\t// the bit (hi or low) to the data pin port, and then two writes to the clock port to strobe the clock line\n\t\t\tregister data_t datahi = FastPin<DATA_PIN>::hival();\n\t\t\tregister data_t datalo = FastPin<DATA_PIN>::loval();\n\t\t\tregister clock_t clockhi = FastPin<CLOCK_PIN>::hival();\n\t\t\tregister clock_t clocklo = FastPin<CLOCK_PIN>::loval();\n\t\t\tuint8_t *end = data + len;\n\n\t\t\twhile(data != end) { \n\t\t\t\tif(SKIP & FLAG_START_BIT) { \n\t\t\t\t\twriteBit<0>(1, clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t\t}\n\t\t\t\twriteByte(D::adjust(data[SPI_B0], scale), clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t\twriteByte(D::adjust(data[SPI_B1], scale), clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t\twriteByte(D::adjust(data[SPI_B2], scale), clockpin, datapin, datahi, datalo, clockhi, clocklo);\n\t\t\t\tdata += SPI_ADVANCE;\n\t\t\t}\n\n\t\t} else {\n\t\t\t// If data and clock are on the same port then we can combine setting the data and clock pins \n\t\t\tregister data_t datahi_clockhi = FastPin<DATA_PIN>::hival() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clockhi = FastPin<DATA_PIN>::loval() | FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datahi_clocklo = FastPin<DATA_PIN>::hival() & ~FastPin<CLOCK_PIN>::mask();\n\t\t\tregister data_t datalo_clocklo = FastPin<DATA_PIN>::loval() & ~FastPin<CLOCK_PIN>::mask();\n\t\t\t\n\t\t\tuint8_t *end = data + len;\n\n\t\t\twhile(data != end) { \n\t\t\t\tif(SKIP & FLAG_START_BIT) { \n\t\t\t\t\twriteBit<0>(1, datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t\t}\n\t\t\t\twriteByte(D::adjust(data[SPI_B0], scale), datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t\twriteByte(D::adjust(data[SPI_B1], scale), datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t\twriteByte(D::adjust(data[SPI_B2], scale), datapin, datahi_clockhi, datalo_clockhi, datahi_clocklo, datalo_clocklo);\n\t\t\t\tdata += SPI_ADVANCE;\n\t\t\t}\n\t\t}\t\n#endif\n\t\tD::postBlock(len);\n\t\trelease();\n\t}\n\n\ttemplate <uint8_t SKIP, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<SKIP, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <class D, EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, D, RGB_ORDER>(data, len, scale); \n\t}\n\ttemplate <EOrder RGB_ORDER> void writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB_ORDER>(data, len, scale); \n\t}\n\tvoid writeBytes3(register uint8_t *data, int len, register uint8_t scale) { \n\t\twriteBytes3<0, DATA_NOP, RGB>(data, len, scale); \n\t}\n};\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/fastspi_dma.h",
      code: " "
    }, {
      filename: "FastLED-2-final/FastSPI_LED2.h",
      code: "#warning \"This file is going away, please us FastLED.h in the future!\"\n#include<FastLED.h>\n"
    }, {
      filename: "FastLED-2-final/hsv2rgb.cpp",
      code: "#include <stdint.h>\n\n#include \"lib8tion.h\"\n#include \"hsv2rgb.h\"\n\n// Functions to convert HSV colors to RGB colors.\n//\n//  The basically fall into two groups: spectra, and rainbows.\n//  Spectra and rainbows are not the same thing.  Wikipedia has a good\n//  illustration here\n//   http://upload.wikimedia.org/wikipedia/commons/f/f6/Prism_compare_rainbow_01.png\n//  from this article\n//   http://en.wikipedia.org/wiki/Rainbow#Number_of_colours_in_spectrum_or_rainbow\n//  that shows a 'spectrum' and a 'rainbow' side by side.  Among other\n//  differences, you'll see that a 'rainbow' has much more yellow than\n//  a plain spectrum.  \"Classic\" LED color washes are spectrum based, and\n//  usually show very little yellow.\n//\n//  Wikipedia's page on HSV color space, with pseudocode for conversion\n//  to RGB color space\n//   http://en.wikipedia.org/wiki/HSL_and_HSV\n//  Note that their conversion algorithm, which is (naturally) very popular\n//  is in the \"maximum brightness at any given hue\" style, vs the \"uniform\n//  brightness for all hues\" style.\n//\n//  You can't have both; either purple is the same brightness as red, e.g\n//    red = #FF0000 and purple = #800080 -> same \"total light\" output\n//  OR purple is 'as bright as it can be', e.g.\n//    red = #FF0000 and purple = #FF00FF -> purple is much brighter than red.\n//  The colorspace conversions here try to keep the apparent brightness\n//  constant even as the hue varies.\n//\n//  Adafruit's \"Wheel\" function, discussed here\n//   http://forums.adafruit.com/viewtopic.php?f=47&t=22483\n//  is also of the \"constant apparent brightness\" variety.\n//\n//  TODO: provide the 'maximum brightness no matter what' variation.\n//\n//  See also some good, clear Arduino C code from Kasper Kamperman\n//   http://www.kasperkamperman.com/blog/arduino/arduino-programming-hsb-to-rgb/\n//  which in turn was was based on Windows C code from \"nico80\"\n//   http://www.codeproject.com/Articles/9207/An-HSB-RGBA-colour-picker\n\n\n\n\n\nvoid hsv2rgb_raw_C (const struct CHSV & hsv, struct CRGB & rgb);\nvoid hsv2rgb_raw_avr(const struct CHSV & hsv, struct CRGB & rgb);\n\n#if defined(__AVR__) && !defined( LIB8_ATTINY )\nvoid hsv2rgb_raw(const struct CHSV & hsv, struct CRGB & rgb)\n{\n    hsv2rgb_raw_avr( hsv, rgb);\n}\n#else\nvoid hsv2rgb_raw(const struct CHSV & hsv, struct CRGB & rgb)\n{\n    hsv2rgb_raw_C( hsv, rgb);\n}\n#endif\n\n\n\n#define APPLY_DIMMING(X) (X)\n#define HSV_SECTION_6 (0x20)\n#define HSV_SECTION_3 (0x40)\n\nvoid hsv2rgb_raw_C (const struct CHSV & hsv, struct CRGB & rgb)\n{\n    // Convert hue, saturation and brightness ( HSV/HSB ) to RGB\n    // \"Dimming\" is used on saturation and brightness to make\n    // the output more visually linear.\n    \n    // Apply dimming curves\n    uint8_t value = APPLY_DIMMING( hsv.val);\n    uint8_t saturation = hsv.sat;\n    \n    // The brightness floor is minimum number that all of\n    // R, G, and B will be set to.\n    uint8_t invsat = APPLY_DIMMING( 255 - saturation);\n    uint8_t brightness_floor = (value * invsat) / 256;\n    \n    // The color amplitude is the maximum amount of R, G, and B\n    // that will be added on top of the brightness_floor to\n    // create the specific hue desired.\n    uint8_t color_amplitude = value - brightness_floor;\n    \n    // Figure out which section of the hue wheel we're in,\n    // and how far offset we are withing that section\n    uint8_t section = hsv.hue / HSV_SECTION_3; // 0..2\n    uint8_t offset = hsv.hue % HSV_SECTION_3;  // 0..63\n    \n    uint8_t rampup = offset; // 0..63\n    uint8_t rampdown = (HSV_SECTION_3 - 1) - offset; // 63..0\n    \n    // We now scale rampup and rampdown to a 0-255 range -- at least\n    // in theory, but here's where architecture-specific decsions\n    // come in to play:\n    // To scale them up to 0-255, we'd want to multiply by 4.\n    // But in the very next step, we multiply the ramps by other\n    // values and then divide the resulting product by 256.\n    // So which is faster?\n    //   ((ramp * 4) * othervalue) / 256\n    // or\n    //   ((ramp    ) * othervalue) /  64\n    // It depends on your processor architecture.\n    // On 8-bit AVR, the \"/ 256\" is just a one-cycle register move,\n    // but the \"/ 64\" might be a multicycle shift process. So on AVR\n    // it's faster do multiply the ramp values by four, and then\n    // divide by 256.\n    // On ARM, the \"/ 256\" and \"/ 64\" are one cycle each, so it's\n    // faster to NOT multiply the ramp values by four, and just to\n    // divide the resulting product by 64 (instead of 256).\n    // Moral of the story: trust your profiler, not your insticts.\n    \n    // Since there's an AVR assembly version elsewhere, we'll\n    // assume what we're on an architecture where any number of\n    // bit shifts has roughly the same cost, and we'll remove the\n    // redundant math at the source level:\n    \n    //  // scale up to 255 range\n    //  //rampup *= 4; // 0..252\n    //  //rampdown *= 4; // 0..252\n    \n    // compute color-amplitude-scaled-down versions of rampup and rampdown\n    uint8_t rampup_amp_adj   = (rampup   * color_amplitude) / (256 / 4);\n    uint8_t rampdown_amp_adj = (rampdown * color_amplitude) / (256 / 4);\n    \n    // add brightness_floor offset to everything\n    uint8_t rampup_adj_with_floor   = rampup_amp_adj   + brightness_floor;\n    uint8_t rampdown_adj_with_floor = rampdown_amp_adj + brightness_floor;\n    \n    \n    if( section ) {\n        if( section == 1) {\n            // section 1: 0x40..0x7F\n            rgb.r = brightness_floor;\n            rgb.g = rampdown_adj_with_floor;\n            rgb.b = rampup_adj_with_floor;\n        } else {\n            // section 2; 0x80..0xBF\n            rgb.r = rampup_adj_with_floor;\n            rgb.g = brightness_floor;\n            rgb.b = rampdown_adj_with_floor;\n        }\n    } else {\n        // section 0: 0x00..0x3F\n        rgb.r = rampdown_adj_with_floor;\n        rgb.g = rampup_adj_with_floor;\n        rgb.b = brightness_floor;\n    }\n}\n\n\n\n#if defined(__AVR__) && !defined( LIB8_ATTINY )\nvoid hsv2rgb_raw_avr(const struct CHSV & hsv, struct CRGB & rgb)\n{\n    uint8_t hue, saturation, value;\n    \n    hue =        hsv.hue;\n    saturation = hsv.sat;\n    value =      hsv.val;\n    \n    // Saturation more useful the other way around\n    saturation = 255 - saturation;\n    uint8_t invsat = APPLY_DIMMING( saturation );\n    \n    // Apply dimming curves\n    value = APPLY_DIMMING( value );\n    \n    // The brightness floor is minimum number that all of\n    // R, G, and B will be set to, which is value * invsat\n    uint8_t brightness_floor;\n    \n    asm volatile(\n                 \"mul %[value], %[invsat]            \\n\"\n                 \"mov %[brightness_floor], r1        \\n\"\n                 : [brightness_floor] \"=r\" (brightness_floor)\n                 : [value] \"r\" (value),\n                 [invsat] \"r\" (invsat)\n                 : \"r0\", \"r1\"\n                 );\n    \n    // The color amplitude is the maximum amount of R, G, and B\n    // that will be added on top of the brightness_floor to\n    // create the specific hue desired.\n    uint8_t color_amplitude = value - brightness_floor;\n    \n    // Figure how far we are offset into the section of the\n    // color wheel that we're in\n    uint8_t offset = hsv.hue & (HSV_SECTION_3 - 1);  // 0..63\n    uint8_t rampup = offset * 4; // 0..252\n    \n    \n    // compute color-amplitude-scaled-down versions of rampup and rampdown\n    uint8_t rampup_amp_adj;\n    uint8_t rampdown_amp_adj;\n    \n    asm volatile(\n                 \"mul %[rampup], %[color_amplitude]       \\n\"\n                 \"mov %[rampup_amp_adj], r1               \\n\"\n                 \"com %[rampup]                           \\n\"\n                 \"mul %[rampup], %[color_amplitude]       \\n\"\n                 \"mov %[rampdown_amp_adj], r1             \\n\"\n                 : [rampup_amp_adj] \"=&r\" (rampup_amp_adj),\n                 [rampdown_amp_adj] \"=&r\" (rampdown_amp_adj),\n                 [rampup] \"+r\" (rampup)\n                 : [color_amplitude] \"r\" (color_amplitude)\n                 : \"r0\", \"r1\"\n                 );\n    \n    \n    // add brightness_floor offset to everything\n    uint8_t rampup_adj_with_floor   = rampup_amp_adj   + brightness_floor;\n    uint8_t rampdown_adj_with_floor = rampdown_amp_adj + brightness_floor;\n    \n    \n    // keep gcc from using \"X\" as the index register for storing\n    // results back in the return structure.  AVR's X register can't\n    // do \"std X+q, rnn\", but the Y and Z registers can.\n    // if the pointer to 'rgb' is in X, gcc will add all kinds of crazy\n    // extra instructions.  Simply killing X here seems to help it\n    // try Y or Z first.\n    asm volatile(  \"\"  :  :  : \"r26\", \"r27\" );\n    \n    \n    if( hue & 0x80 ) {\n        // section 2: 0x80..0xBF\n        rgb.r = rampup_adj_with_floor;\n        rgb.g = brightness_floor;\n        rgb.b = rampdown_adj_with_floor;\n    } else {\n        if( hue & 0x40) {\n            // section 1: 0x40..0x7F\n            rgb.r = brightness_floor;\n            rgb.g = rampdown_adj_with_floor;\n            rgb.b = rampup_adj_with_floor;\n        } else {\n            // section 0: 0x00..0x3F\n            rgb.r = rampdown_adj_with_floor;\n            rgb.g = rampup_adj_with_floor;\n            rgb.b = brightness_floor;\n        }\n    }\n    \n    cleanup_R1();\n}\n// End of AVR asm implementation\n\n#endif\n\nvoid hsv2rgb_spectrum( const CHSV& hsv, CRGB& rgb)\n{\n    CHSV hsv2(hsv);\n    hsv2.hue = scale8( hsv2.hue, 192);\n    hsv2rgb_raw(hsv2, rgb);\n}\n\n\n// Sometimes the compiler will do clever things to reduce\n// code size that result in a net slowdown, if it thinks that\n// a variable is not used in a certain location.\n// This macro does its best to convince the compiler that\n// the variable is used in this location, to help control\n// code motion and de-duplication that would result in a slowdown.\n#define FORCE_REFERENCE(var)  asm volatile( \"\" : : \"r\" (var) )\n\n\n#define K255 255\n#define K171 171\n#define K85  85\n\nvoid hsv2rgb_rainbow( const CHSV& hsv, CRGB& rgb)\n{\n    // Yellow has a higher inherent brightness than\n    // any other color; 'pure' yellow is perceived to\n    // be 93% as bright as white.  In order to make\n    // yellow appear the correct relative brightness,\n    // it has to be rendered brighter than all other\n    // colors.\n    // Level Y1 is a moderate boost, the default.\n    // Level Y2 is a strong boost.\n    const uint8_t Y1 = 1;\n    const uint8_t Y2 = 0;\n\n    // G2: Whether to divide all greens by two.\n    // Depends GREATLY on your particular LEDs\n    const uint8_t G2 = 0;\n    \n    // Gscale: what to scale green down by.\n    // Depends GREATLY on your particular LEDs\n    const uint8_t Gscale = 0;\n\n    \n    uint8_t hue = hsv.hue;\n    uint8_t sat = hsv.sat;\n    uint8_t val = hsv.val;\n        \n    uint8_t offset = hue & 0x1F; // 0..31\n    \n    // offset8 = offset * 8\n    uint8_t offset8 = offset;\n    {\n        offset8 <<= 1;\n        asm volatile(\"\");\n        offset8 <<= 1;\n        asm volatile(\"\");\n        offset8 <<= 1;\n    }\n    \n    uint8_t third = scale8( offset8, (256 / 3));\n        \n    uint8_t r, g, b;\n    \n    if( ! (hue & 0x80) ) {\n        // 0XX\n        if( ! (hue & 0x40) ) {\n            // 00X\n            //section 0-1\n            if( ! (hue & 0x20) ) {\n                // 000\n                //case 0: // R -> O\n                r = K255 - third;\n                g = third;\n                b = 0;\n                FORCE_REFERENCE(b);\n            } else {\n                // 001\n                //case 1: // O -> Y\n                if( Y1 ) {\n                    r = K171;\n                    g = K85 + third ;\n                    b = 0;\n                    FORCE_REFERENCE(b);\n                }\n                if( Y2 ) {\n                    r = K171 + third;\n                    uint8_t twothirds = (third << 1);\n                    g = K85 + twothirds;\n                    b = 0;\n                    FORCE_REFERENCE(b);\n                }\n            }\n        } else {\n            //01X\n            // section 2-3\n            if( !  (hue & 0x20) ) {\n                // 010\n                //case 2: // Y -> G\n                if( Y1 ) {\n                    uint8_t twothirds = (third << 1);\n                    r = K171 - twothirds;\n                    g = K171 + third;\n                    b = 0;\n                    FORCE_REFERENCE(b);\n                }\n                if( Y2 ) {\n                    r = K255 - offset8;\n                    g = K255;\n                    b = 0;\n                    FORCE_REFERENCE(b);\n                }\n            } else {\n                // 011\n                // case 3: // G -> A\n                r = 0;\n                FORCE_REFERENCE(r);\n                g = K255 - third;\n                b = third;\n            }\n        }\n    } else {\n        // section 4-7\n        // 1XX\n        if( ! (hue & 0x40) ) {\n            // 10X\n            if( ! ( hue & 0x20) ) {\n                // 100\n                //case 4: // A -> B\n                r = 0;\n                FORCE_REFERENCE(r);\n                uint8_t twothirds = (third << 1);\n                g = K171 - twothirds;\n                b = K85  + twothirds;\n\n            } else {\n                // 101\n                //case 5: // B -> P\n                r = third;\n                g = 0;\n                FORCE_REFERENCE(g);\n                b = K255 - third;\n\n            }\n        } else {\n            if( !  (hue & 0x20)  ) {\n                // 110\n                //case 6: // P -- K\n                r = K85 + third;\n                g = 0;\n                FORCE_REFERENCE(g);\n                b = K171 - third;\n\n            } else {\n                // 111\n                //case 7: // K -> R\n                r = K171 + third;\n                g = 0;\n                FORCE_REFERENCE(g);\n                b = K85 - third;\n\n            }\n        }\n    }\n    \n    // This is one of the good places to scale the green down,\n    // although the client can scale green down as well.\n    if( G2 ) g = g >> 1;\n    if( Gscale ) g = scale8_video_LEAVING_R1_DIRTY( g, Gscale);\n    \n    // Scale down colors if we're desaturated at all\n    // and add the brightness_floor to r, g, and b.\n    if( sat != 255 ) {\n\n        nscale8x3_video( r, g, b, sat);\n\n        uint8_t desat = 255 - sat;\n        desat = scale8( desat, desat);\n        \n        uint8_t brightness_floor = desat;\n        r += brightness_floor;\n        g += brightness_floor;\n        b += brightness_floor;\n    }\n\n    // Now scale everything down if we're at value < 255.\n    if( val != 255 ) {\n        \n        val = scale8_video_LEAVING_R1_DIRTY( val, val);\n        nscale8x3_video( r, g, b, val);\n    }\n    \n    // Here we have the old AVR \"missing std X+n\" problem again\n    // It turns out that fixing it winds up costing more than\n    // not fixing it.\n    // To paraphrase Dr Bronner, profile! profile! profile!\n    //asm volatile(  \"\"  :  :  : \"r26\", \"r27\" );\n    //asm volatile (\" movw r30, r26 \\n\" : : : \"r30\", \"r31\");\n    rgb.r = r;\n    rgb.g = g;\n    rgb.b = b;\n}\n\n\nvoid hsv2rgb_raw(const struct CHSV * phsv, struct CRGB * prgb, int numLeds) {\n    for(int i = 0; i < numLeds; i++) {\n        hsv2rgb_raw(phsv[i], prgb[i]);\n    }\n}\n\nvoid hsv2rgb_rainbow( const struct CHSV* phsv, struct CRGB * prgb, int numLeds) {\n    for(int i = 0; i < numLeds; i++) {\n        hsv2rgb_rainbow(phsv[i], prgb[i]);\n    }\n}\n\nvoid hsv2rgb_spectrum( const struct CHSV* phsv, struct CRGB * prgb, int numLeds) {\n    for(int i = 0; i < numLeds; i++) {\n        hsv2rgb_spectrum(phsv[i], prgb[i]);\n    }\n}\n\nvoid fill_solid( struct CRGB * pFirstLED, int numToFill,\n                const struct CRGB& color)\n{\n    for( int i = 0; i < numToFill; i++) {\n        pFirstLED[i] = color;\n    }\n}\n\nvoid fill_rainbow( struct CRGB * pFirstLED, int numToFill,\n                  uint8_t initialhue,\n                  uint8_t deltahue )\n{\n    CHSV hsv;\n    hsv.hue = initialhue;\n    hsv.val = 255;\n    hsv.sat = 255;\n    for( int i = 0; i < numToFill; i++) {\n        hsv2rgb_rainbow( hsv, pFirstLED[i]);\n        hsv.hue += deltahue;\n    }\n}\n"
    }, {
      filename: "FastLED-2-final/hsv2rgb.h",
      code: "#ifndef __INC_HSV2RGB_H\n#define __INC_HSV2RGB_H\n\n#include \"pixeltypes.h\"\n\n\n// hsv2rgb_rainbow - convert a hue, saturation, and value to RGB\n//                   using a visually balanced rainbow (vs a straight\n//                   mathematical spectrum).\n//                   This 'rainbow' yields better yellow and orange\n//                   than a straight 'spectrum'.\n//\n//                   NOTE: here hue is 0-255, not just 0-191\n\nvoid hsv2rgb_rainbow( const struct CHSV& hsv, struct CRGB& rgb);\nvoid hsv2rgb_rainbow( const struct CHSV* phsv, struct CRGB * prgb, int numLeds);\n#define HUE_MAX_RAINBOW 255\n\n\n// hsv2rgb_spectrum - convert a hue, saturation, and value to RGB\n//                    using a mathematically straight spectrum (vs\n//                    a visually balanced rainbow).\n//                    This 'spectrum' will have more green & blue\n//                    than a 'rainbow', and less yellow and orange.\n//\n//                    NOTE: here hue is 0-255, not just 0-191\n\nvoid hsv2rgb_spectrum( const struct CHSV& hsv, struct CRGB& rgb);\nvoid hsv2rgb_spectrum( const struct CHSV* phsv, struct CRGB * prgb, int numLeds);\n#define HUE_MAX_SPECTRUM 255\n\n\n// hsv2rgb_raw - convert hue, saturation, and value to RGB.\n//               This 'spectrum' conversion will be more green & blue\n//               than a real 'rainbow', and the hue is specified just\n//               in the range 0-191.  Together, these result in a\n//               slightly faster conversion speed, at the expense of\n//               color balance.\n//\n//               NOTE: Hue is 0-191 only!\n//               Saturation & value are 0-255 each.\n//\n\nvoid hsv2rgb_raw(const struct CHSV& hsv, struct CRGB & rgb);\nvoid hsv2rgb_raw(const struct CHSV* phsv, struct CRGB * prgb, int numLeds);\n#define HUE_MAX 191\n\n\n// fill_solid -   fill a range of LEDs with a solid color\nvoid fill_solid( struct CRGB * pFirstLED, int numToFill,\n                 const struct CRGB& color);\n\n// fill_rainbow - fill a range of LEDs with a rainbow of colors, at\n//                full saturation and full value (brightness)\nvoid fill_rainbow( struct CRGB * pFirstLED, int numToFill,\n                   uint8_t initialhue,\n                   uint8_t deltahue = 5);\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/lib8tion.cpp",
      code: "#include <stdint.h>\n\n#define RAND16_SEED  1337\nuint16_t rand16seed = RAND16_SEED;\n\n\n// memset8, memcpy8, memmove8:\n//  optimized avr replacements for the standard \"C\" library\n//  routines memset, memcpy, and memmove.\n//\n//  There are two techniques that make these routines\n//  faster than the standard avr-libc routines.\n//  First, the loops are unrolled 2X, meaning that\n//  the average loop overhead is cut in half.\n//  And second, the compare-and-branch at the bottom\n//  of each loop decrements the low byte of the\n//  counter, and if the carry is clear, it branches\n//  back up immediately.  Only if the low byte math\n//  causes carry do we bother to decrement the high\n//  byte and check that result for carry as well.\n//  Results for a 100-byte buffer are 20-40% faster\n//  than standard avr-libc, at a cost of a few extra\n//  bytes of code.\n\n#if defined(__AVR__)\nextern \"C\" {\n//__attribute__ ((noinline))\nvoid * memset8 ( void * ptr, uint8_t val, uint16_t num )\n{\n    asm volatile(\n         \"  movw r26, %[ptr]        \\n\\t\"\n         \"  sbrs %A[num], 0         \\n\\t\"\n         \"  rjmp Lseteven_%=        \\n\\t\"\n         \"  rjmp Lsetodd_%=         \\n\\t\"\n         \"Lsetloop_%=:              \\n\\t\"\n         \"  st X+, %[val]           \\n\\t\"\n         \"Lsetodd_%=:               \\n\\t\"\n         \"  st X+, %[val]           \\n\\t\"\n         \"Lseteven_%=:              \\n\\t\"\n         \"  subi %A[num], 2         \\n\\t\"\n         \"  brcc Lsetloop_%=        \\n\\t\"\n         \"  sbci %B[num], 0         \\n\\t\"\n         \"  brcc Lsetloop_%=        \\n\\t\"\n         : [num] \"+r\" (num)\n         : [ptr]  \"r\" (ptr),\n           [val]  \"r\" (val)\n         : \"memory\"\n         );\n    return ptr;\n}\n\n\n\n//__attribute__ ((noinline))\nvoid * memcpy8 ( void * dst, void* src, uint16_t num )\n{\n    asm volatile(\n         \"  movw r30, %[src]        \\n\\t\"\n         \"  movw r26, %[dst]        \\n\\t\"\n         \"  sbrs %A[num], 0         \\n\\t\"\n         \"  rjmp Lcpyeven_%=        \\n\\t\"\n         \"  rjmp Lcpyodd_%=         \\n\\t\"\n         \"Lcpyloop_%=:              \\n\\t\"\n         \"  ld __tmp_reg__, Z+      \\n\\t\"\n         \"  st X+, __tmp_reg__      \\n\\t\"\n         \"Lcpyodd_%=:               \\n\\t\"\n         \"  ld __tmp_reg__, Z+      \\n\\t\"\n         \"  st X+, __tmp_reg__      \\n\\t\"\n         \"Lcpyeven_%=:              \\n\\t\"\n         \"  subi %A[num], 2         \\n\\t\"\n         \"  brcc Lcpyloop_%=        \\n\\t\"\n         \"  sbci %B[num], 0         \\n\\t\"\n         \"  brcc Lcpyloop_%=        \\n\\t\"\n         : [num] \"+r\" (num)\n         : [src] \"r\" (src),\n           [dst] \"r\" (dst)\n         : \"memory\"\n         );\n    return dst;\n}\n\n//__attribute__ ((noinline))\nvoid * memmove8 ( void * dst, void* src, uint16_t num )\n{\n    if( src > dst) {\n        // if src > dst then we can use the forward-stepping memcpy8\n        return memcpy8( dst, src, num);\n    } else {\n        // if src < dst then we have to step backward:\n        dst = (char*)dst + num;\n        src = (char*)src + num;\n        asm volatile(\n             \"  movw r30, %[src]        \\n\\t\"\n             \"  movw r26, %[dst]        \\n\\t\"\n             \"  sbrs %A[num], 0         \\n\\t\"\n             \"  rjmp Lmoveven_%=        \\n\\t\"\n             \"  rjmp Lmovodd_%=         \\n\\t\"\n             \"Lmovloop_%=:              \\n\\t\"\n             \"  ld __tmp_reg__, -Z      \\n\\t\"\n             \"  st -X, __tmp_reg__      \\n\\t\"\n             \"Lmovodd_%=:               \\n\\t\"\n             \"  ld __tmp_reg__, -Z      \\n\\t\"\n             \"  st -X, __tmp_reg__      \\n\\t\"\n             \"Lmoveven_%=:              \\n\\t\"\n             \"  subi %A[num], 2         \\n\\t\"\n             \"  brcc Lmovloop_%=        \\n\\t\"\n             \"  sbci %B[num], 0         \\n\\t\"\n             \"  brcc Lmovloop_%=        \\n\\t\"\n             : [num] \"+r\" (num)\n             : [src] \"r\" (src),\n               [dst] \"r\" (dst)\n             : \"memory\"\n             );\n        return dst;\n    }\n}\n\n\n} /* end extern \"C\" */\n\n#endif /* AVR */\n\n#if 0\n// TEST / VERIFICATION CODE ONLY BELOW THIS POINT\n#include <Arduino.h>\n#include \"lib8tion.h\"\n\nvoid test1abs( int8_t i)\n{\n    Serial.print(\"abs(\"); Serial.print(i); Serial.print(\") = \");\n    int8_t j = abs8(i);\n    Serial.print(j); Serial.println(\" \");\n}\n\nvoid testabs()\n{\n    delay(5000);\n    for( int8_t q = -128; q != 127; q++) {\n        test1abs(q);\n    }\n    for(;;){};\n}\n\n\nvoid testmul8()\n{\n    delay(5000);\n    byte r, c;\n    \n    Serial.println(\"mul8:\");\n    for( r = 0; r <= 20; r += 1) {\n        Serial.print(r); Serial.print(\" : \");\n        for( c = 0; c <= 20; c += 1) {\n            byte t;\n            t = mul8( r, c);\n            Serial.print(t); Serial.print(' ');\n        }\n        Serial.println(' ');\n    }\n    Serial.println(\"done.\");\n    for(;;){};\n}\n\n\nvoid testscale8()\n{\n    delay(5000);\n    byte r, c;\n\n    Serial.println(\"scale8:\");\n    for( r = 0; r <= 240; r += 10) {\n        Serial.print(r); Serial.print(\" : \");\n        for( c = 0; c <= 240; c += 10) {\n            byte t;\n            t = scale8( r, c);\n            Serial.print(t); Serial.print(' ');\n        }\n        Serial.println(' ');\n    }\n\n    Serial.println(' ');\n    Serial.println(\"scale8_video:\");\n\n    for( r = 0; r <= 100; r += 4) {\n        Serial.print(r); Serial.print(\" : \");\n        for( c = 0; c <= 100; c += 4) {\n            byte t;\n            t = scale8_video( r, c);\n            Serial.print(t); Serial.print(' ');\n        }\n        Serial.println(' ');\n    }\n\n    Serial.println(\"done.\");\n    for(;;){};\n}\n\n\n\nvoid testqadd8()\n{\n    delay(5000);\n    byte r, c;\n    for( r = 0; r <= 240; r += 10) {\n        Serial.print(r); Serial.print(\" : \");\n        for( c = 0; c <= 240; c += 10) {\n            byte t;\n            t = qadd8( r, c);\n            Serial.print(t); Serial.print(' ');\n        }\n        Serial.println(' ');\n    }\n    Serial.println(\"done.\");\n    for(;;){};\n}\n\nvoid testnscale8x3()\n{\n    delay(5000);\n    byte r, g, b, sc;\n    for( byte z = 0; z < 10; z++) {\n        r = random8(); g = random8(); b = random8(); sc = random8();\n        \n        Serial.print(\"nscale8x3_video( \");\n        Serial.print(r); Serial.print(\", \");\n        Serial.print(g); Serial.print(\", \");\n        Serial.print(b); Serial.print(\", \");\n        Serial.print(sc); Serial.print(\") = [ \");\n        \n        nscale8x3_video( r, g, b, sc);\n        \n        Serial.print(r); Serial.print(\", \");\n        Serial.print(g); Serial.print(\", \");\n        Serial.print(b); Serial.print(\"]\");\n        \n        Serial.println(' ');\n    }\n    Serial.println(\"done.\");\n    for(;;){};\n}\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/lib8tion.h",
      code: "#ifndef __INC_LIB8TION_H\n#define __INC_LIB8TION_H\n\n/*\n \n Fast, efficient 8-bit math functions specifically\n designed for high-performance LED programming.\n \n Because of the AVR(Arduino) and ARM assembly language\n implementations provided, using these functions often\n results in smaller and faster code than the equivalent\n program using plain \"C\" arithmetic and logic.\n \n \n Included are:\n \n \n - Saturating unsigned 8-bit add and subtract.\n   Instead of wrapping around if an overflow occurs,\n   these routines just 'clamp' the output at a maxumum\n   of 255, or a minimum of 0.  Useful for adding pixel \n   values.  E.g., qadd8( 200, 100) = 255.\n \n     qadd8( i, j) == MIN( (i + j), 0xFF )\n     qsub8( i, j) == MAX( (i - j), 0 )\n \n - Saturating signed 8-bit (\"7-bit\") add.\n     qadd7( i, j) == MIN( (i + j), 0x7F)\n \n \n - Scaling (down) of unsigned 8- and 16- bit values.\n   Scaledown value is specified in 1/256ths.\n     scale8( i, sc) == (i * sc) / 256\n     scale16by8( i, sc) == (i * sc) / 256\n \n   Example: scaling a 0-255 value down into a\n   range from 0-99:\n     downscaled = scale8( originalnumber, 100);\n\n   A special version of scale8 is provided for scaling\n   LED brightness values, to make sure that they don't\n   accidentally scale down to total black at low\n   dimming levels, since that would look wrong:\n     scale8_video( i, sc) = ((i * sc) / 256) +? 1\n \n   Example: reducing an LED brightness by a\n   dimming factor:\n     new_bright = scale8_video( orig_bright, dimming);\n \n \n - Fast 8- and 16- bit unsigned random numbers.\n   Significantly faster than Arduino random(), but \n   also somewhat less random.  You can add entropy.\n     random8()       == random from 0..255\n     random8( n)     == random from 0..(N-1)\n     random8( n, m)  == random from N..(M-1)\n \n     random16()      == random from 0..65535\n     random16( n)    == random from 0..(N-1)\n     random16( n, m) == random from N..(M-1)\n   \n     random16_set_seed( k)    ==  seed = k\n     random16_add_entropy( k) ==  seed += k\n\n \n - Absolute value of a signed 8-bit value.\n     abs8( i)     == abs( i)\n\n\n - 8-bit math operations which return 8-bit values.\n   These are provided mostly for completeness,\n   not particularly for performance.\n     mul8( i, j)  == (i * j) & 0xFF\n     add8( i, j)  == (i + j) & 0xFF\n     sub8( i, j)  == (i - j) & 0xFF\n\n \n - Fast 16-bit approximations of sin and cos.\n   Input angle is a uint16_t from 0-65535.\n   Output is a signed int16_t from -32767 to 32767.\n      sin16( x)  == sin( (x/32768.0) * pi) * 32767\n      cos16( x)  == cos( (x/32768.0) * pi) * 32767\n   Accurate to more than 99% in all cases.\n \n \n - Dimming and brightening functions for 8-bit\n   light values.\n      dim8_video( x)  == scale8_video( x, x)\n      dim8_raw( x)    == scale8( x, x)\n      brighten8_video( x) == 255 - dim8_video( 255 - x)\n      brighten8_raw( x) == 255 - dim8_raw( 255 - x)\n   The dimming functions in particular are suitable\n   for making LED light output appear more 'linear'.\n\n\n - Fast 8-bit \"easing in/out\" function.\n     ease8InOutCubic(x) == 3(x^i) - 2(x^3)\n     ease8InOutApprox(x) == \n       faster, rougher, approximation of cubic easing\n     \n\n - Linear interpolation between two values, with the\n   fraction between them expressed as an 8- or 16-bit\n   fixed point fraction (fract8 or fract16).\n     lerp8by8(   fromU8, toU8, fract8 )\n     lerp16by8(  fromU16, toU16, fract8 )\n     lerp15by8(  fromS16, toS16, fract8 )\n       == from + (( to - from ) * fract8) / 256)\n     lerp16by16( fromU16, toU16, fract16 )\n       == from + (( to - from ) * fract16) / 65536)\n \n - Optimized memmove, memcpy, and memset, that are\n   faster than standard avr-libc 1.8.\n      memmove8( dest, src,  bytecount)\n      memcpy8(  dest, src,  bytecount)\n      memset8(  buf, value, bytecount)\n \n\nLib8tion is pronounced like 'libation': lie-BAY-shun\n\n*/\n \n \n\n#include <stdint.h>\n\n#define LIB8STATIC __attribute__ ((unused)) static\n\n\n#if defined(__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__) || defined(__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)\n#define LIB8_ATTINY 1\n#endif\n\n\n#if defined(__arm__)\n\n#if defined(__MK20DX128__)\n// Can use Cortex M4 DSP instructions\n#define QADD8_C 0\n#define QADD7_C 0\n#define QADD8_ARM_DSP_ASM 1\n#define QADD7_ARM_DSP_ASM 1\n#else\n// Generic ARM\n#define QADD8_C 1\n#define QADD7_C 1\n#endif\n\n#define QSUB8_C 1\n#define SCALE8_C 1\n#define SCALE16BY8_C 1\n#define SCALE16_C 1\n#define ABS8_C 1\n#define MUL8_C 1\n#define QMUL8_C 1\n#define ADD8_C 1\n#define SUB8_C 1\n#define EASE8_C 1\n\n\n#elif defined(__AVR__)\n\n// AVR ATmega and friends Arduino\n\n#define QADD8_C 0\n#define QADD7_C 0\n#define QSUB8_C 0\n#define ABS8_C 0\n#define ADD8_C 0\n#define SUB8_C 0\n\n#define QADD8_AVRASM 1\n#define QADD7_AVRASM 1\n#define QSUB8_AVRASM 1\n#define ABS8_AVRASM 1\n#define ADD8_AVRASM 1\n#define SUB8_AVRASM 1\n\n// Note: these require hardware MUL instruction\n//       -- sorry, ATtiny!\n#if !defined(LIB8_ATTINY)\n#define SCALE8_C 0\n#define SCALE16BY8_C 0\n#define SCALE16_C 0\n#define MUL8_C 0\n#define QMUL8_C 0\n#define EASE8_C 0\n#define SCALE8_AVRASM 1\n#define SCALE16BY8_AVRASM 1\n#define SCALE16_AVRASM 1\n#define MUL8_AVRASM 1\n#define QMUL8_AVRASM 1\n#define EASE8_AVRASM 1\n#define CLEANUP_R1_AVRASM 1\n#else\n// On ATtiny, we just use C implementations\n#define SCALE8_C 1\n#define SCALE16BY8_C 1\n#define SCALE16_C 1\n#define MUL8_C 1\n#define QMUL8_C 1\n#define EASE8_C 1\n#define SCALE8_AVRASM 0\n#define SCALE16BY8_AVRASM 0\n#define SCALE16_AVRASM 0\n#define MUL8_AVRASM 0\n#define QMUL8_AVRASM 0\n#define EASE8_AVRASM 0\n#endif\n\n#else\n\n// unspecified architecture, so\n// no ASM, everything in C\n#define QADD8_C 1\n#define QADD7_C 1\n#define QSUB8_C 1\n#define SCALE8_C 1\n#define SCALE16BY8_C 1\n#define SCALE16_C 1\n#define ABS8_C 1\n#define MUL8_C 1\n#define ADD8_C 1\n#define SUB8_C 1\n#define EASE8_C 1\n\n#endif\n\n\n///////////////////////////////////////////////////////////////////////\n//\n// typdefs for fixed-point fractional types.\n//\n// sfract7 should be interpreted as signed 128ths.\n// fract8 should be interpreted as unsigned 256ths.\n// sfract15 should be interpreted as signed 32768ths.\n// fract16 should be interpreted as unsigned 65536ths.\n//\n// Example: if a fract8 has the value \"64\", that should be interpreted\n//          as 64/256ths, or one-quarter.\n//\n//\n//  fract8   range is 0 to 0.99609375\n//                 in steps of 0.00390625\n//\n//  sfract7  range is -0.9921875 to 0.9921875\n//                 in steps of 0.0078125\n//\n//  fract16  range is 0 to 0.99998474121\n//                 in steps of 0.00001525878\n//\n//  sfract15 range is -0.99996948242 to 0.99996948242\n//                 in steps of 0.00003051757\n//\n\ntypedef uint8_t   fract8;   // ANSI: unsigned short _Fract\ntypedef int8_t    sfract7;  // ANSI: signed   short _Fract\ntypedef uint16_t  fract16;  // ANSI: unsigned       _Fract\ntypedef int16_t   sfract15; // ANSI: signed         _Fract\n\n\n// accumXY types should be interpreted as X bits of integer,\n//         and Y bits of fraction.\n//         E.g., accum88 has 8 bits of int, 8 bits of fraction\n\ntypedef uint16_t  accum88;  // ANSI: unsigned short _Accum\ntypedef int16_t   saccum78; // ANSI: signed   short _Accum\ntypedef uint32_t  accum1616;// ANSI: signed         _Accum\ntypedef int32_t   saccum1516;//ANSI: signed         _Accum\ntypedef uint16_t  accum124; // no direct ANSI counterpart\ntypedef int32_t   saccum114;// no direct ANSI counterpart\n\n\n// typedef for IEEE754 \"binary32\" float type internals\n\ntypedef union {\n    uint32_t i;\n    float    f;\n    struct {\n        uint32_t mantissa: 23;\n        uint32_t exponent:  8;\n        uint32_t signbit:   1;\n    };\n    struct {\n        uint32_t mant7 :  7;\n        uint32_t mant16: 16;\n        uint32_t exp_  :  8;\n        uint32_t sb_   :  1;\n    };\n    struct {\n        uint32_t mant_lo8 : 8;\n        uint32_t mant_hi16_exp_lo1 : 16;\n        uint32_t sb_exphi7 : 8;\n    };\n} IEEE754binary32_t;\n\n\n\n///////////////////////////////////////////////////////////////////////\n\n// qadd8: add one byte to another, saturating at 0xFF\nLIB8STATIC uint8_t qadd8( uint8_t i, uint8_t j)\n{\n#if QADD8_C == 1\n    int t = i + j;\n    if( t > 255) t = 255;\n    return t;\n#elif QADD8_AVRASM == 1\n    asm volatile(\n         /* First, add j to i, conditioning the C flag */\n         \"add %0, %1    \\n\\t\"\n\n         /* Now test the C flag.\n           If C is clear, we branch around a load of 0xFF into i.\n           If C is set, we go ahead and load 0xFF into i.\n         */\n         \"brcc L_%=     \\n\\t\"\n         \"ldi %0, 0xFF  \\n\\t\"\n         \"L_%=: \"\n         : \"+a\" (i)\n         : \"a\"  (j) );\n    return i;\n#elif QADD8_ARM_DSP_ASM == 1\n    asm volatile( \"uqadd8 %0, %0, %1\" : \"+r\" (i) : \"r\" (j));\n    return i;\n#else\n#error \"No implementation for qadd8 available.\"\n#endif\n}\n\n\n// qadd7: add one signed byte to another,\n//        saturating at 0x7F.\nLIB8STATIC int8_t qadd7( int8_t i, int8_t j)\n{\n#if QADD7_C == 1\n    int16_t t = i + j;\n    if( t > 127) t = 127;\n    return t;\n#elif QADD7_AVRASM == 1\n    asm volatile(\n         /* First, add j to i, conditioning the V flag */\n         \"add %0, %1    \\n\\t\"\n         \n         /* Now test the V flag.\n          If V is clear, we branch around a load of 0x7F into i.\n          If V is set, we go ahead and load 0x7F into i.\n          */\n         \"brvc L_%=     \\n\\t\"\n         \"ldi %0, 0x7F  \\n\\t\"\n         \"L_%=: \"\n         : \"+a\" (i)\n         : \"a\"  (j) );\n\n    return i;\n#elif QADD7_ARM_DSP_ASM == 1\n    asm volatile( \"qadd8 %0, %0, %1\" : \"+r\" (i) : \"r\" (j));\n    return i;\n#else\n#error \"No implementation for qadd7 available.\"\n#endif\n}\n\n// qsub8: subtract one byte from another, saturating at 0x00\nLIB8STATIC uint8_t qsub8( uint8_t i, uint8_t j)\n{\n#if QSUB8_C == 1\n    int t = i - j;\n    if( t < 0) t = 0;\n    return t;\n#elif QSUB8_AVRASM == 1\n\n    asm volatile(\n         /* First, subtract j from i, conditioning the C flag */\n         \"sub %0, %1    \\n\\t\"\n         \n         /* Now test the C flag.\n          If C is clear, we branch around a load of 0x00 into i.\n          If C is set, we go ahead and load 0x00 into i.\n          */\n         \"brcc L_%=     \\n\\t\"\n         \"ldi %0, 0x00  \\n\\t\"\n         \"L_%=: \"\n         : \"+a\" (i)\n         : \"a\"  (j) );\n    \n    return i;\n#else\n#error \"No implementation for qsub8 available.\"\n#endif\n}\n\n// add8: add one byte to another, with one byte result\nLIB8STATIC uint8_t add8( uint8_t i, uint8_t j)\n{\n#if ADD8_C == 1\n    int t = i + j;\n    return t;\n#elif ADD8_AVRASM == 1\n    // Add j to i, period.\n    asm volatile( \"add %0, %1\" : \"+a\" (i) : \"a\" (j));\n    return i;\n#else\n#error \"No implementation for add8 available.\"\n#endif\n}\n\n\n// sub8: subtract one byte from another, 8-bit result\nLIB8STATIC uint8_t sub8( uint8_t i, uint8_t j)\n{\n#if SUB8_C == 1\n    int t = i - j;\n    return t;\n#elif SUB8_AVRASM == 1\n    // Subtract j from i, period.\n    asm volatile( \"sub %0, %1\" : \"+a\" (i) : \"a\" (j));\n    return i;\n#else\n#error \"No implementation for sub8 available.\"\n#endif\n}\n\n\n// scale8: scale one byte by a second one, which is treated as\n//         the numerator of a fraction whose denominator is 256\n//         In other words, it computes i * (scale / 256)\n//         4 clocks AVR, 2 clocks ARM\nLIB8STATIC uint8_t scale8( uint8_t i, fract8 scale)\n{\n#if SCALE8_C == 1\n    return ((int)i * (int)(scale) ) >> 8;\n#elif SCALE8_AVRASM == 1\n    asm volatile(\n         /* Multiply 8-bit i * 8-bit scale, giving 16-bit r1,r0 */\n         \"mul %0, %1          \\n\\t\"\n         /* Move the high 8-bits of the product (r1) back to i */\n         \"mov %0, r1          \\n\\t\"\n         /* Restore r1 to \"0\"; it's expected to always be that */\n         \"clr __zero_reg__    \\n\\t\"\n         \n         : \"+a\" (i)      /* writes to i */\n         : \"a\"  (scale)  /* uses scale */\n         : \"r0\", \"r1\"    /* clobbers r0, r1 */ );\n\n    /* Return the result */\n    return i;\n#else\n#error \"No implementation for scale8 available.\"\n#endif\n}\n\n\n//  The \"video\" version of scale8 guarantees that the output will\n//  be only be zero if one or both of the inputs are zero.  If both\n//  inputs are non-zero, the output is guaranteed to be non-zero.\n//  This makes for better 'video'/LED dimming, at the cost of\n//  several additional cycles.\nLIB8STATIC uint8_t scale8_video( uint8_t i, fract8 scale)\n{\n#if SCALE8_C == 1\n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    uint8_t j = (i == 0) ? 0 : (((int)i * (int)(scale) ) >> 8) + nonzeroscale;\n    return j;\n#elif SCALE8_AVRASM == 1\n    \n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    asm volatile(\n         \"      tst %0           \\n\"\n         \"      breq L_%=        \\n\"\n         \"      mul %0, %1       \\n\"\n         \"      mov %0, r1       \\n\"\n         \"      add %0, %2       \\n\"\n         \"      clr __zero_reg__ \\n\"\n         \"L_%=:                  \\n\"\n         \n         : \"+a\" (i)\n         : \"a\" (scale), \"a\" (nonzeroscale)\n         : \"r0\", \"r1\");\n    \n    // Return the result\n    return i;\n#else\n#error \"No implementation for scale8_video available.\"\n#endif\n}\n\n\n// This version of scale8 does not clean up the R1 register on AVR\n// If you are doing several 'scale8's in a row, use this, and\n// then explicitly call cleanup_R1.\nLIB8STATIC uint8_t scale8_LEAVING_R1_DIRTY( uint8_t i, fract8 scale)\n{\n#if SCALE8_C == 1\n    return ((int)i * (int)(scale) ) >> 8;\n#elif SCALE8_AVRASM == 1\n    asm volatile(\n         /* Multiply 8-bit i * 8-bit scale, giving 16-bit r1,r0 */\n         \"mul %0, %1    \\n\\t\"\n         /* Move the high 8-bits of the product (r1) back to i */\n         \"mov %0, r1    \\n\\t\"\n         /* R1 IS LEFT DIRTY HERE; YOU MUST ZERO IT OUT YOURSELF  */\n         /* \"clr __zero_reg__    \\n\\t\" */\n         \n         : \"+a\" (i)      /* writes to i */\n         : \"a\"  (scale)  /* uses scale */\n         : \"r0\", \"r1\"    /* clobbers r0, r1 */ );\n    \n    // Return the result\n    return i;\n#else\n#error \"No implementation for scale8_LEAVING_R1_DIRTY available.\"\n#endif\n}\n\n//   THIS FUNCTION ALWAYS MODIFIES ITS ARGUMENT DIRECTLY IN PLACE\n\nLIB8STATIC void nscale8_LEAVING_R1_DIRTY( uint8_t& i, fract8 scale)\n{\n#if SCALE8_C == 1\n    i = ((int)i * (int)(scale) ) >> 8;\n#elif SCALE8_AVRASM == 1\n    asm volatile(\n         /* Multiply 8-bit i * 8-bit scale, giving 16-bit r1,r0 */\n         \"mul %0, %1    \\n\\t\"\n         /* Move the high 8-bits of the product (r1) back to i */\n         \"mov %0, r1    \\n\\t\"\n         /* R1 IS LEFT DIRTY HERE; YOU MUST ZERO IT OUT YOURSELF */\n         /* \"clr __zero_reg__    \\n\\t\" */\n         \n         : \"+a\" (i)      /* writes to i */\n         : \"a\"  (scale)  /* uses scale */\n         : \"r0\", \"r1\"    /* clobbers r0, r1 */ );\n#else\n#error \"No implementation for nscale8_LEAVING_R1_DIRTY available.\"\n#endif\n}\n\n\n\nLIB8STATIC uint8_t scale8_video_LEAVING_R1_DIRTY( uint8_t i, fract8 scale)\n{\n#if SCALE8_C == 1\n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    uint8_t j = (i == 0) ? 0 : (((int)i * (int)(scale) ) >> 8) + nonzeroscale;\n    return j;\n#elif SCALE8_AVRASM == 1\n    \n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    asm volatile(\n         \"      tst %0          \\n\"\n         \"      breq L_%=       \\n\"\n         \"      mul %0, %1      \\n\"\n         \"      mov %0, r1      \\n\"\n         \"      add %0, %2      \\n\"\n         /* R1 IS LEFT DIRTY, YOU MUST ZERO IT OUT YOURSELF */\n         \"L_%=:                 \\n\"\n         \n         : \"+a\" (i)\n         : \"a\" (scale), \"a\" (nonzeroscale)\n         : \"r0\", \"r1\");\n    \n    // Return the result\n    return i;\n#else\n#error \"No implementation for scale8_video available.\"\n#endif\n}\n\n\n\nLIB8STATIC void cleanup_R1()\n{\n#if CLEANUP_R1_AVRASM == 1\n    // Restore r1 to \"0\"; it's expected to always be that\n    asm volatile( \"clr __zero_reg__  \\n\\t\" : : : \"r1\" );\n#endif\n}\n\n\n// nscale8x3: scale three one byte values by a fourth one, which is treated as\n//         the numerator of a fraction whose demominator is 256\n//         In other words, it computes r,g,b * (scale / 256)\n//\n//         THIS FUNCTION ALWAYS MODIFIES ITS ARGUMENTS IN PLACE\n\nLIB8STATIC void nscale8x3( uint8_t& r, uint8_t& g, uint8_t& b, fract8 scale)\n{\n#if SCALE8_C == 1\n    r = ((int)r * (int)(scale) ) >> 8;\n    g = ((int)g * (int)(scale) ) >> 8;\n    b = ((int)b * (int)(scale) ) >> 8;\n#elif SCALE8_AVRASM == 1\n    r = scale8_LEAVING_R1_DIRTY(r, scale);\n    g = scale8_LEAVING_R1_DIRTY(g, scale);\n    b = scale8_LEAVING_R1_DIRTY(b, scale);\n    cleanup_R1();\n#else\n#error \"No implementation for nscale8x3 available.\"\n#endif\n}\n\n\nLIB8STATIC void nscale8x3_video( uint8_t& r, uint8_t& g, uint8_t& b, fract8 scale)\n{\n#if SCALE8_C == 1\n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    r = (r == 0) ? 0 : (((int)r * (int)(scale) ) >> 8) + nonzeroscale;\n    g = (g == 0) ? 0 : (((int)g * (int)(scale) ) >> 8) + nonzeroscale;\n    b = (b == 0) ? 0 : (((int)b * (int)(scale) ) >> 8) + nonzeroscale;\n#elif SCALE8_AVRASM == 1\n    r = scale8_video_LEAVING_R1_DIRTY( r, scale);\n    g = scale8_video_LEAVING_R1_DIRTY( g, scale);\n    b = scale8_video_LEAVING_R1_DIRTY( b, scale);\n    cleanup_R1();\n#else\n#error \"No implementation for nscale8x3 available.\"\n#endif\n}\n\n// nscale8x2: scale two one byte values by a third one, which is treated as\n//         the numerator of a fraction whose demominator is 256\n//         In other words, it computes i,j * (scale / 256)\n//\n//         THIS FUNCTION ALWAYS MODIFIES ITS ARGUMENTS IN PLACE\n\nLIB8STATIC void nscale8x2( uint8_t& i, uint8_t& j, fract8 scale)\n{\n#if SCALE8_C == 1\n    i = ((int)i * (int)(scale) ) >> 8;\n    j = ((int)j * (int)(scale) ) >> 8;\n#elif SCALE8_AVRASM == 1\n    i = scale8_LEAVING_R1_DIRTY(i, scale);\n    j = scale8_LEAVING_R1_DIRTY(j, scale);\n    cleanup_R1();\n#else\n#error \"No implementation for nscale8x2 available.\"\n#endif\n}\n\n\nLIB8STATIC void nscale8x2_video( uint8_t& i, uint8_t& j, fract8 scale)\n{\n#if SCALE8_C == 1\n    uint8_t nonzeroscale = (scale != 0) ? 1 : 0;\n    i = (i == 0) ? 0 : (((int)i * (int)(scale) ) >> 8) + nonzeroscale;\n    j = (j == 0) ? 0 : (((int)j * (int)(scale) ) >> 8) + nonzeroscale;\n#elif SCALE8_AVRASM == 1\n    i = scale8_video_LEAVING_R1_DIRTY( i, scale);\n    j = scale8_video_LEAVING_R1_DIRTY( j, scale);\n    cleanup_R1();\n#else\n#error \"No implementation for nscale8x2 available.\"\n#endif\n}\n\n\n// scale16by8: scale a 16-bit unsigned value by an 8-bit value,\n//         considered as numerator of a fraction whose denominator\n//         is 256. In other words, it computes i * (scale / 256)\n\n#if SCALE16BY8_C == 1\nLIB8STATIC uint16_t scale16by8( uint16_t i, fract8 scale )\n{\n    uint16_t result;\n    result = (i * scale) / 256;\n    return result;\n}\n#elif SCALE16BY8_AVRASM == 1\nLIB8STATIC uint16_t scale16by8( uint16_t i, fract8 scale )\n{\n    uint16_t result;\n    asm volatile(\n         // result.A = HighByte(i.A x j )\n         \"  mul %A[i], %[scale]                 \\n\\t\"\n         \"  mov %A[result], r1                  \\n\\t\"\n         \"  clr %B[result]                      \\n\\t\"\n         \n         // result.A-B += i.B x j\n         \"  mul %B[i], %[scale]                 \\n\\t\"\n         \"  add %A[result], r0                  \\n\\t\"\n         \"  adc %B[result], r1                  \\n\\t\"\n         \n         // cleanup r1\n         \"  clr __zero_reg__                    \\n\\t\"\n         \n         : [result] \"=r\" (result)\n         : [i] \"r\" (i), [scale] \"r\" (scale)\n         : \"r0\", \"r1\"\n         );\n    return result;\n}\n#else\n#error \"No implementation for scale16by8 available.\"\n#endif\n\n// scale16: scale a 16-bit unsigned value by a 16-bit value,\n//         considered as numerator of a fraction whose denominator\n//         is 65536. In other words, it computes i * (scale / 65536)\n\n#if SCALE16_C == 1\nLIB8STATIC uint16_t scale16( uint16_t i, fract16 scale )\n{\n    uint16_t result;\n    result = ((uint32_t)(i) * (uint32_t)(scale)) / 65536;\n    return result;\n}\n#elif SCALE16_AVRASM == 1\nLIB8STATIC\nuint16_t scale16( uint16_t i, fract16 scale )\n{\n    uint32_t result = 0;\n    const uint8_t  zero = 0;\n    asm volatile(\n                 // result.A-B  = i.A x scale.A\n                 \"  mul %A[i], %A[scale]                 \\n\\t\"\n                 //  save results...\n                 // basic idea:\n                 //\"  mov %A[result], r0                 \\n\\t\"\n                 //\"  mov %B[result], r1                 \\n\\t\"\n                 // which can be written as...\n                 \"  movw %A[result], r0                   \\n\\t\"\n                 // We actually need to do anything with r0,\n                 // as result.A is never used again here, so we\n                 // could just move the high byte, but movw is\n                 // one clock cycle, just like mov, so might as\n                 // well, in case we want to use this code for\n                 // a generic 16x16 multiply somewhere.\n                 \n                 // result.C-D  = i.B x scale.B\n                 \"  mul %B[i], %B[scale]                 \\n\\t\"\n                 //\"  mov %C[result], r0                 \\n\\t\"\n                 //\"  mov %D[result], r1                 \\n\\t\"\n                 \"  movw %C[result], r0                   \\n\\t\"\n\n                 // result.B-D += i.B x scale.A\n                 \"  mul %B[i], %A[scale]                 \\n\\t\"\n                 \n                 \"  add %B[result], r0                   \\n\\t\"\n                 \"  adc %C[result], r1                   \\n\\t\"\n                 \"  adc %D[result], %[zero]              \\n\\t\"\n                 \n                 // result.B-D += i.A x scale.B\n                 \"  mul %A[i], %B[scale]                 \\n\\t\"\n                 \n                 \"  add %B[result], r0                   \\n\\t\"\n                 \"  adc %C[result], r1                   \\n\\t\"\n                 \"  adc %D[result], %[zero]              \\n\\t\"\n                                  \n                 // cleanup r1\n                 \"  clr r1                               \\n\\t\"\n                 \n                 : [result] \"+r\" (result)\n                 : [i] \"r\" (i),\n                   [scale] \"r\" (scale),\n                   [zero] \"r\" (zero)\n                 : \"r0\", \"r1\"\n                 );\n    result = result >> 16;\n    return result;\n}\n#else\n#error \"No implementation for scale16 available.\"\n#endif\n\n\n\n// mul8: 8x8 bit multiplication, with 8 bit result\nLIB8STATIC uint8_t mul8( uint8_t i, uint8_t j)\n{\n#if MUL8_C == 1\n    return ((int)i * (int)(j) ) & 0xFF;\n#elif MUL8_AVRASM == 1\n    asm volatile(\n         /* Multiply 8-bit i * 8-bit j, giving 16-bit r1,r0 */\n         \"mul %0, %1          \\n\\t\"\n         /* Extract the LOW 8-bits (r0) */\n         \"mov %0, r0          \\n\\t\"\n         /* Restore r1 to \"0\"; it's expected to always be that */\n         \"clr __zero_reg__    \\n\\t\"\n         : \"+a\" (i)\n         : \"a\"  (j)\n         : \"r0\", \"r1\");\n    \n    return i;\n#else\n#error \"No implementation for mul8 available.\"\n#endif\n}\n\n\n// mul8: saturating 8x8 bit multiplication, with 8 bit result\nLIB8STATIC uint8_t qmul8( uint8_t i, uint8_t j)\n{\n#if QMUL8_C == 1\n    int p = ((int)i * (int)(j) );\n    if( p > 255) p = 255;\n    return p;\n#elif QMUL8_AVRASM == 1\n    asm volatile(\n                 /* Multiply 8-bit i * 8-bit j, giving 16-bit r1,r0 */\n                 \"  mul %0, %1          \\n\\t\"\n                 /* If high byte of result is zero, all is well. */\n                 \"  tst r1              \\n\\t\"\n                 \"  breq Lnospill_%=    \\n\\t\"\n                 /* If high byte of result > 0, saturate low byte to 0xFF */\n                 \"  ldi %0,0xFF         \\n\\t\"\n                 \"  rjmp Ldone_%=       \\n\\t\"\n                 \"Lnospill_%=:          \\n\\t\"\n                 /* Extract the LOW 8-bits (r0) */\n                 \"  mov %0, r0          \\n\\t\"\n                 \"Ldone_%=:             \\n\\t\"\n                 /* Restore r1 to \"0\"; it's expected to always be that */\n                 \"  clr __zero_reg__    \\n\\t\"\n                 : \"+a\" (i)\n                 : \"a\"  (j)\n                 : \"r0\", \"r1\");\n    \n    return i;\n#else\n#error \"No implementation for qmul8 available.\"\n#endif\n}\n\n\n// abs8: take abs() of a signed 8-bit uint8_t\nLIB8STATIC int8_t abs8( int8_t i)\n{\n#if ABS8_C == 1\n    if( i < 0) i = -i;\n    return i;\n#elif ABS8_AVRASM == 1\n    \n    \n    asm volatile(\n         /* First, check the high bit, and prepare to skip if it's clear */\n         \"sbrc %0, 7 \\n\"\n         \n         /* Negate the value */\n         \"neg %0     \\n\"\n         \n         : \"+r\" (i) : \"r\" (i) );\n    return i;\n#else\n#error \"No implementation for abs8 available.\"\n#endif\n}\n\n\n///////////////////////////////////////////////////////////////////////\n//\n// float-to-fixed and fixed-to-float conversions\n//\n// Note that anything involving a 'float' on AVR will be slower.\n\n// floatToSfract15: conversion from IEEE754 float in the range (-1,1)\n//                  to 16-bit fixed point.  Note that the extremes of\n//                  one and negative one are NOT representable.  The\n//                  representable range is basically\n//\n// sfract15ToFloat: conversion from sfract15 fixed point to\n//                  IEEE754 32-bit float.\n\nLIB8STATIC\nfloat sfract15ToFloat( sfract15 y)\n{\n    return y / 32768.0;\n}\n\nLIB8STATIC\nsfract15 floatToSfract15( float f)\n{\n    return f * 32768.0;\n}\n\n\n\n///////////////////////////////////////////////////////////////////////\n\n// Dimming and brightening functions\n//\n// The eye does not respond in a linear way to light.\n// High speed PWM'd LEDs at 50% duty cycle appear far\n// brighter then the 'half as bright' you might expect.\n//\n// If you want your midpoint brightness leve (128) to\n// appear half as bright as 'full' brightness (255), you\n// have to apply a 'dimming function'.\n//\n// \n\nLIB8STATIC uint8_t dim8_raw( uint8_t x)\n{\n    return scale8( x, x);\n}\n\nLIB8STATIC uint8_t dim8_video( uint8_t x)\n{\n    return scale8_video( x, x);\n}\n\nLIB8STATIC uint8_t brighten8_raw( uint8_t x)\n{\n    uint8_t ix = 255 - x;\n    return 255 - scale8( ix, ix);\n}\n\nLIB8STATIC uint8_t brighten8_video( uint8_t x)\n{\n    uint8_t ix = 255 - x;\n    return 255 - scale8_video( ix, ix);\n}\n\n///////////////////////////////////////////////////////////////////////\n\n// A 16-bit PNRG good enough for LED animations\n\n// X(n+1) = (2053 * X(n)) + 13849)\n#define RAND16_2053  2053\n#define RAND16_13849 13849\n\nextern uint16_t rand16seed;// = RAND16_SEED;\n\n\nLIB8STATIC uint8_t random8()\n{\n    rand16seed = (rand16seed * RAND16_2053) + RAND16_13849;\n    return rand16seed;\n}\n\nLIB8STATIC uint16_t random16()\n{\n    rand16seed = (rand16seed * RAND16_2053) + RAND16_13849;\n    return rand16seed;\n}\n\n\nLIB8STATIC uint8_t random8(uint8_t lim)\n{\n    uint8_t r = random8();\n    r = scale8( r, lim);\n    return r;\n}\n\nLIB8STATIC uint8_t random8(uint8_t min, uint8_t lim)\n{\n    uint8_t delta = lim - min;\n    uint8_t r = random8(delta) + min;\n    return r;\n}\n\nLIB8STATIC uint16_t random16( uint16_t lim)\n{\n    uint16_t r = random16();\n    uint32_t p = (uint32_t)lim * (uint32_t)r;\n    r = p >> 16;\n    return r;\n}\n\nLIB8STATIC uint16_t random16( uint16_t min, uint16_t lim)\n{\n    uint16_t delta = lim - min;\n    uint16_t r = random16( delta) + min;\n    return r;\n}\n\nLIB8STATIC void random16_set_seed( uint16_t seed)\n{\n    rand16seed = seed;\n}\n\nLIB8STATIC uint16_t random16_get_seed()\n{\n    return rand16seed;\n}\n\nLIB8STATIC void random16_add_entropy( uint16_t entropy)\n{\n    rand16seed += entropy;\n}\n\n\n///////////////////////////////////////////////////////////////////////\n\n// sin16 & cos16:\n//        Fast 16-bit approximations of sin(x) & cos(x).\n//        Input angle is an unsigned int from 0-65535.\n//        Output is signed int from -32767 to 32767.\n//\n//        This approximation never varies more than 0.69%\n//        from the floating point value you'd get by doing\n//          float s = sin( x ) * 32767.0;\n//\n//        Don't use this approximation for calculating the\n//        trajectory of a rocket to Mars, but it's great\n//        for art projects and LED displays.\n//\n//        On Arduino/AVR, this approximation is more than\n//        10X faster than floating point sin(x) and cos(x)\n\n#if defined(__AVR__)\n#define sin16 sin16_avr\n#else\n#define sin16 sin16_C\n#endif\n\nLIB8STATIC int16_t sin16_avr( uint16_t theta )\n{\n    static const uint8_t data[] =\n    { 0,         0,         49, 0, 6393%256,   6393/256, 48, 0,\n      12539%256, 12539/256, 44, 0, 18204%256, 18204/256, 38, 0,\n      23170%256, 23170/256, 31, 0, 27245%256, 27245/256, 23, 0,\n      30273%256, 30273/256, 14, 0, 32137%256, 32137/256,  4 /*,0*/ };\n    \n    uint16_t offset = (theta & 0x3FFF);\n    \n    // AVR doesn't have a multi-bit shift instruction,\n    // so if we say \"offset >>= 3\", gcc makes a tiny loop.\n    // Inserting empty volatile statements between each\n    // bit shift forces gcc to unroll the loop.\n    offset >>= 1; // 0..8191\n    asm volatile(\"\");\n    offset >>= 1; // 0..4095\n    asm volatile(\"\");\n    offset >>= 1; // 0..2047\n\n    if( theta & 0x4000 ) offset = 2047 - offset;\n    \n    uint8_t sectionX4;\n    sectionX4 = offset / 256;\n    sectionX4 *= 4;\n    \n    uint8_t m;\n    \n    union {\n        uint16_t b;\n        struct {\n            uint8_t blo;\n            uint8_t bhi;\n        };\n    } u;\n    \n    //in effect u.b = blo + (256 * bhi);\n    u.blo = data[ sectionX4 ];\n    u.bhi = data[ sectionX4 + 1];\n    m     = data[ sectionX4 + 2];\n    \n    uint8_t secoffset8 = (uint8_t)(offset) / 2;\n    \n    uint16_t mx = m * secoffset8;\n    \n    int16_t  y  = mx + u.b;\n    if( theta & 0x8000 ) y = -y;\n    \n    return y;\n}\n\nLIB8STATIC int16_t sin16_C( uint16_t theta )\n{\n    static const uint16_t base[] =\n    { 0, 6393, 12539, 18204, 23170, 27245, 30273, 32137 };\n    static const uint8_t slope[] =\n    { 49, 48, 44, 38, 31, 23, 14, 4 };\n    \n    uint16_t offset = (theta & 0x3FFF) >> 3; // 0..2047\n    if( theta & 0x4000 ) offset = 2047 - offset;\n    \n    uint8_t section = offset / 256; // 0..7\n    uint16_t b   = base[section];\n    uint8_t  m   = slope[section];\n    \n    uint8_t secoffset8 = (uint8_t)(offset) / 2;\n    \n    uint16_t mx = m * secoffset8;\n    int16_t  y  = mx + b;\n    \n    if( theta & 0x8000 ) y = -y;\n    \n    return y;\n}\n\nLIB8STATIC int16_t cos16( uint16_t theta)\n{\n    return sin16( theta + 16384);\n}\n\n\n///////////////////////////////////////////////////////////////////////\n//\n// memmove8, memcpy8, and memset8:\n//   alternatives to memmove, memcpy, and memset that are\n//   faster on AVR than standard avr-libc 1.8\n\n#if defined(__AVR__)\nextern \"C\" {\nvoid * memmove8( void * dst, const void * src, uint16_t num );\nvoid * memcpy8 ( void * dst, const void * src, uint16_t num )  __attribute__ ((noinline));\nvoid * memset8 ( void * ptr, uint8_t value, uint16_t num ) __attribute__ ((noinline)) ;\n}\n#else\n// on non-AVR platforms, these names just call standard libc.\n#define memmove8 memmove\n#define memcpy8 memcpy\n#define memset8 memset\n#endif\n\n\n///////////////////////////////////////////////////////////////////////\n//\n// linear interpolation, such as could be used for Perlin noise, etc.\n//\n\n// linear interpolation between two unsigned 8-bit values,\n// with 8-bit fraction\nLIB8STATIC uint8_t lerp8by8( uint8_t a, uint8_t b, fract8 frac)\n{\n    uint8_t delta = b - a;\n    uint8_t scaled = scale8( delta, frac);\n    uint8_t result = a + scaled;\n    return result;\n}\n\n// linear interpolation between two unsigned 16-bit values,\n// with 16-bit fraction\nLIB8STATIC uint16_t lerp16by16( uint16_t a, uint16_t b, fract16 frac)\n{\n    uint16_t delta = b - a;\n    uint32_t prod = (uint32_t)delta * (uint32_t)frac;\n    uint16_t scaled = prod >> 16;\n    uint16_t result = a + scaled;\n    return result;\n}\n\n\n// A note on the structure of lerp16by8 (and lerp15by8) :\n// The cases for b>a and b<=a are handled separately for\n// speed: without knowing the relative order of a and b,\n// the value (a-b) might be a signed 17-bit value, which\n// would have to be stored in a 32-bit signed int and\n// processed as such.  To avoid that, we separate the\n// two cases, and are able to do all the math with 16-bit\n// unsigned values, which is much faster and smaller on AVR.\n\n// linear interpolation between two unsigned 16-bit values,\n// with 8-bit fraction\nLIB8STATIC uint16_t lerp16by8( uint16_t a, uint16_t b, fract8 frac)\n{\n    uint16_t result;\n    if( b > a) {\n        uint16_t delta = b - a;\n        uint16_t scaled = scale16by8( delta, frac);\n        result = a + scaled;\n    } else {\n        uint16_t delta = a - b;\n        uint16_t scaled = scale16by8( delta, frac);\n        result = a - scaled;\n    }\n    return result;\n}\n\n// linear interpolation between two signed 15-bit values,\n// with 8-bit fraction\nLIB8STATIC int16_t lerp15by8( int16_t a, int16_t b, fract8 frac)\n{\n    int16_t result;\n    if( b > a) {\n        uint16_t delta = b - a;\n        uint16_t scaled = scale16by8( delta, frac);\n        result = a + scaled;\n    } else {\n        uint16_t delta = a - b;\n        uint16_t scaled = scale16by8( delta, frac);\n        result = a - scaled;\n    }\n    return result;\n}\n\n\n///////////////////////////////////////////////////////////////////////\n//\n// easing functions; see http://easings.net\n//\n\n// ease8InOuCubic: 8-bit cubic ease-in / ease-out function\n//                 Takes around 18 cycles on AVR\nLIB8STATIC fract8 ease8InOutCubic( fract8 i)\n{\n    uint8_t ii  = scale8_LEAVING_R1_DIRTY(  i, i);\n    uint8_t iii = scale8_LEAVING_R1_DIRTY( ii, i);\n    \n    uint16_t r1 = (3 * (uint16_t)(ii)) - ( 2 * (uint16_t)(iii));\n\n    /* the code generated for the above *'s automatically\n       cleans up R1, so there's no need to explicitily call\n       cleanup_R1(); */\n    \n    uint8_t result = r1;\n    \n    // if we got \"256\", return 255:\n    if( r1 & 0x100 ) {\n        result = 255;\n    }\n    return result;\n}\n\n// ease8InOutApprox: fast, rough 8-bit ease-in/ease-out function\n//                   shaped approximately like 'ease8InOutCubic',\n//                   it's never off by more than a couple of percent\n//                   from the actual cubic S-curve, and it executes\n//                   more than twice as fast.  Use when the cycles\n//                   are more important than visual smoothness.\n//                   Asm version takes around 7 cycles on AVR.\n\n#if EASE8_C == 1\nLIB8STATIC fract8 ease8InOutApprox( fract8 i)\n{\n    if( i < 64) {\n        // start with slope 0.5\n        i /= 2;\n    } else if( i > (255 - 64)) {\n        // end with slope 0.5\n        i = 255 - i;\n        i /= 2;\n        i = 255 - i;\n    } else {\n        // in the middle, use slope 192/128 = 1.5\n        i -= 64;\n        i += (i / 2);\n        i += 32;\n    }\n    \n    return i;\n}\n\n#elif EASE8_AVRASM == 1\nLIB8STATIC uint8_t ease8InOutApprox( fract8 i)\n{\n    // takes around 7 cycles on AVR\n    asm volatile (\n        \"  subi %[i], 64         \\n\\t\"\n        \"  cpi  %[i], 128        \\n\\t\"\n        \"  brcc Lshift_%=        \\n\\t\"\n\n        // middle case\n        \"  mov __tmp_reg__, %[i] \\n\\t\"\n        \"  lsr __tmp_reg__       \\n\\t\"\n        \"  add %[i], __tmp_reg__ \\n\\t\"\n        \"  subi %[i], 224        \\n\\t\"\n        \"  rjmp Ldone_%=         \\n\\t\"\n\n        // start or end case\n        \"Lshift_%=:              \\n\\t\"\n        \"  lsr %[i]              \\n\\t\"\n        \"  subi %[i], 96         \\n\\t\"\n\n        \"Ldone_%=:               \\n\\t\"\n                  \n        : [i] \"+a\" (i)\n        : \n        : \"r0\", \"r1\"\n        );\n    return i;\n}\n#else\n#error \"No implementation for ease8 available.\"\n#endif\n\n\n\n\n\n#endif\n"
    }, {
      filename: "FastLED-2-final/pixeltypes.h",
      code: "#ifndef __INC_PIXELS_H\n#define __INC_PIXELS_H\n\n#include <stdint.h>\n#include \"lib8tion.h\"\n\nstruct CRGB;\nstruct CHSV;\n\n// Forward declaration of hsv2rgb_rainbow here,\n// to avoid circular dependencies.\nextern void hsv2rgb_rainbow( const CHSV& hsv, CRGB& rgb);\n\n\nstruct CHSV {\n    union {\n\t\tstruct {\n\t\t    union {\n\t\t        uint8_t hue;\n\t\t        uint8_t h; };\n\t\t    union {\n\t\t        uint8_t saturation;\n\t\t        uint8_t sat;\n\t\t        uint8_t s; };\n\t\t    union {\n\t\t        uint8_t value;\n\t\t        uint8_t val;\n\t\t        uint8_t v; };\n\t\t};\n\t\tuint8_t raw[3];\n\t};\n\n    // default values are UNITIALIZED\n    inline CHSV() __attribute__((always_inline))\n    {\n    }\n\n    // allow construction from H, S, V\n    inline CHSV( uint8_t ih, uint8_t is, uint8_t iv) __attribute__((always_inline))\n        : h(ih), s(is), v(iv)\n    {\n    }\n\n    // allow copy construction\n    inline CHSV(const CHSV& rhs) __attribute__((always_inline))\n    {\n        h = rhs.h;\n        s = rhs.s;\n        v = rhs.v;\n    }\n\n    inline CHSV& operator= (const CHSV& rhs) __attribute__((always_inline))\n    {\n        h = rhs.h;\n        s = rhs.s;\n        v = rhs.v;\n        return *this;\n    }\n\n    inline CHSV& setHSV(uint8_t ih, uint8_t is, uint8_t iv) __attribute__((always_inline))\n    {\n        h = ih;\n        s = is;\n        v = iv;\n        return *this;\n    }\n};\n\n\nstruct CRGB {\n\tunion {\n\t\tstruct {\n            union {\n                uint8_t r;\n                uint8_t red;\n            };\n            union {\n                uint8_t g;\n                uint8_t green;\n            };\n            union {\n                uint8_t b;\n                uint8_t blue;\n            };\n        };\n\t\tuint8_t raw[3];\n\t};\n\n\tinline uint8_t& operator[] (uint8_t x) __attribute__((always_inline))\n    {\n        return raw[x];\n    }\n\n    inline const uint8_t& operator[] (uint8_t x) const __attribute__((always_inline))\n    {\n        return raw[x];\n    }\n\n    // default values are UNINITIALIZED\n\tinline CRGB() __attribute__((always_inline))\n    {\n    }\n    \n    // allow construction from R, G, B\n    inline CRGB( uint8_t ir, uint8_t ig, uint8_t ib)  __attribute__((always_inline))\n        : r(ir), g(ig), b(ib)\n    {\n    }\n    \n    // allow construction from 32-bit (really 24-bit) bit 0xRRGGBB color code\n    inline CRGB( uint32_t colorcode)  __attribute__((always_inline))\n    : r((colorcode >> 16) & 0xFF), g((colorcode >> 8) & 0xFF), b((colorcode >> 0) & 0xFF)\n    {\n    }\n    \n    // allow copy construction\n\tinline CRGB(const CRGB& rhs) __attribute__((always_inline))\n    {\n        r = rhs.r;\n        g = rhs.g;\n        b = rhs.b;\n    }\n    \n    // allow construction from HSV color\n\tinline CRGB(const CHSV& rhs) __attribute__((always_inline))\n    {\n        hsv2rgb_rainbow( rhs, *this);\n    }\n\n    // allow assignment from one RGB struct to another\n\tinline CRGB& operator= (const CRGB& rhs) __attribute__((always_inline))\n    {\n        r = rhs.r;\n        g = rhs.g;\n        b = rhs.b;\n        return *this;\n    }    \n\n    // allow assignment from 32-bit (really 24-bit) 0xRRGGBB color code\n\tinline CRGB& operator= (const uint32_t colorcode) __attribute__((always_inline))\n    {\n        r = (colorcode >> 16) & 0xFF;\n        g = (colorcode >>  8) & 0xFF;\n        b = (colorcode >>  0) & 0xFF;\n        return *this;\n    }\n    \n    // allow assignment from R, G, and B\n\tinline CRGB& setRGB (uint8_t nr, uint8_t ng, uint8_t nb) __attribute__((always_inline))\n    {\n        r = nr;\n        g = ng;\n        b = nb;\n        return *this;\n    }\n    \n    // allow assignment from H, S, and V\n\tinline CRGB& setHSV (uint8_t hue, uint8_t sat, uint8_t val) __attribute__((always_inline))\n    {\n        hsv2rgb_rainbow( CHSV(hue, sat, val), *this);\n        return *this;\n    }\n    \n    // allow assignment from just a Hue, saturation and value automatically at max.\n\tinline CRGB& setHue (uint8_t hue) __attribute__((always_inline))\n    {\n        hsv2rgb_rainbow( CHSV(hue, 255, 255), *this);\n        return *this;\n    }\n    \n    // allow assignment from HSV color\n\tinline CRGB& operator= (const CHSV& rhs) __attribute__((always_inline))\n    {\n        hsv2rgb_rainbow( rhs, *this);\n        return *this;\n    }\n    \n    // allow assignment from 32-bit (really 24-bit) 0xRRGGBB color code\n\tinline CRGB& setColorCode (uint32_t colorcode) __attribute__((always_inline))\n    {\n        r = (colorcode >> 16) & 0xFF;\n        g = (colorcode >>  8) & 0xFF;\n        b = (colorcode >>  0) & 0xFF;\n        return *this;\n    }\n    \n\n    // add one RGB to another, saturating at 0xFF for each channel\n    inline CRGB& operator+= (const CRGB& rhs )\n    {\n        r = qadd8( r, rhs.r);\n        g = qadd8( g, rhs.g);\n        b = qadd8( b, rhs.b);\n        return *this;\n    }\n    \n    // add a contstant to each channel, saturating at 0xFF\n    // this is NOT an operator+= overload because the compiler\n    // can't usefully decide when it's being passed a 32-bit\n    // constant (e.g. CRGB::Red) and an 8-bit one (CRGB::Blue)\n    inline CRGB& addToRGB (uint8_t d )\n    {\n        r = qadd8( r, d);\n        g = qadd8( g, d);\n        b = qadd8( b, d);\n        return *this;\n    }\n    \n    // subtract one RGB from another, saturating at 0x00 for each channel\n    inline CRGB& operator-= (const CRGB& rhs )\n    {\n        r = qsub8( r, rhs.r);\n        g = qsub8( g, rhs.g);\n        b = qsub8( b, rhs.b);\n        return *this;\n    }\n    \n    // subtract a constant from each channel, saturating at 0x00\n    // this is NOT an operator+= overload because the compiler\n    // can't usefully decide when it's being passed a 32-bit\n    // constant (e.g. CRGB::Red) and an 8-bit one (CRGB::Blue)\n    inline CRGB& subtractFromRGB(uint8_t d )\n    {\n        r = qsub8( r, d);\n        g = qsub8( g, d);\n        b = qsub8( b, d);\n        return *this;\n    }\n    \n    // subtract a constant of '1' from each channel, saturating at 0x00\n    inline CRGB& operator-- ()  __attribute__((always_inline))\n    {\n        subtractFromRGB(1);\n        return *this;\n    }\n    \n    // subtract a constant of '1' from each channel, saturating at 0x00\n    inline CRGB operator-- (int DUMMY_ARG)  __attribute__((always_inline))\n    {\n        CRGB retval(*this);\n        --(*this);\n        return retval;\n    }\n\n    // add a constant of '1' from each channel, saturating at 0xFF\n    inline CRGB& operator++ ()  __attribute__((always_inline))\n    {\n        addToRGB(1);\n        return *this;\n    }\n    \n    // add a constant of '1' from each channel, saturating at 0xFF\n    inline CRGB operator++ (int DUMMY_ARG)  __attribute__((always_inline))\n    {\n        CRGB retval(*this);\n        ++(*this);\n        return retval;\n    }\n\n    // divide each of the channels by a constant\n    inline CRGB& operator/= (uint8_t d )\n    {\n        r /= d;\n        g /= d;\n        b /= d;\n        return *this;\n    }\n        \n    // multiply each of the channels by a constant,\n    // saturating each channel at 0xFF\n    inline CRGB& operator*= (uint8_t d )\n    {\n        r = qmul8( r, d);\n        g = qmul8( g, d);\n        b = qmul8( b, d);\n        return *this;\n    }\n\n    // scale down a RGB to N 256ths of it's current brightness, using\n    // 'video' dimming rules, which means that unless the scale factor is ZERO\n    // each channel is guaranteed NOT to dim down to zero.  If it's already\n    // nonzero, it'll stay nonzero, even if that means the hue shifts a little\n    // at low brightness levels.\n    inline CRGB& nscale8_video (uint8_t scaledown )\n    {\n        nscale8x3_video( r, g, b, scaledown);\n        return *this;\n    }\n    \n    // %= is a synonym for nscale8_video.  Think of it is scaling down\n    // by \"a percentage\"\n    inline CRGB& operator%= (uint8_t scaledown )\n    {\n        nscale8x3_video( r, g, b, scaledown);\n        return *this;\n    }\n\n    // fadeLightBy is a synonym for nscale8_video( ..., 255-fadefactor)\n    inline CRGB& fadeLightBy (uint8_t fadefactor )\n    {\n        nscale8x3_video( r, g, b, 255 - fadefactor);\n        return *this;\n    }\n    \n    // scale down a RGB to N 256ths of it's current brightness, using\n    // 'plain math' dimming rules, which means that if the low light levels\n    // may dim all the way to 100% black.\n    inline CRGB& nscale8 (uint8_t scaledown )\n    {\n        nscale8x3( r, g, b, scaledown);\n        return *this;\n    }\n\n    // fadeToBlackBy is a synonym for nscale8( ..., 255-fadefactor)\n    inline CRGB& fadeToBlackBy (uint8_t fadefactor )\n    {\n        nscale8x3( r, g, b, 255 - fadefactor);\n        return *this;\n    }\n    \n    // \"or\" operator brings each channel up to the higher of the two values\n    inline CRGB& operator|= (const CRGB& rhs )\n    {\n        if( rhs.r > r) r = rhs.r;\n        if( rhs.g > g) g = rhs.g;\n        if( rhs.b > b) b = rhs.b;\n        return *this;\n    }\n    inline CRGB& operator|= (uint8_t d )\n    {\n        if( d > r) r = d;\n        if( d > g) g = d;\n        if( d > b) b = d;\n        return *this;\n    }\n    \n    // \"and\" operator brings each channel down to the lower of the two values\n    inline CRGB& operator&= (const CRGB& rhs )\n    {\n        if( rhs.r < r) r = rhs.r;\n        if( rhs.g < g) g = rhs.g;\n        if( rhs.b < b) b = rhs.b;\n        return *this;\n    }\n    inline CRGB& operator&= (uint8_t d )\n    {\n        if( d < r) r = d;\n        if( d < g) g = d;\n        if( d < b) b = d;\n        return *this;\n    }\n    \n    // this allows testing a CRGB for zero-ness\n    inline operator bool() const __attribute__((always_inline))\n    {\n        return r || g || b;\n    }\n    \n    // invert each channel\n    inline CRGB operator- ()\n    {\n        CRGB retval;\n        retval.r = 255 - r;\n        retval.g = 255 - g;\n        retval.b = 255 - b;\n        return retval;\n    }\n    \n    \n    inline uint8_t getLuma ( )  {\n        //Y' = 0.2126 R' + 0.7152 G' + 0.0722 B'\n        //     54            183       18 (!)\n        \n        uint8_t luma = scale8_LEAVING_R1_DIRTY( r, 54) + \\\n        scale8_LEAVING_R1_DIRTY( g, 183) + \\\n        scale8_LEAVING_R1_DIRTY( b, 18);\n        cleanup_R1();\n        return luma;\n    }\n    \n    inline uint8_t getAverageLight( )  {\n        const uint8_t eightysix = 86;\n        uint8_t avg = scale8_LEAVING_R1_DIRTY( r, eightysix) + \\\n        scale8_LEAVING_R1_DIRTY( g, eightysix) + \\\n        scale8_LEAVING_R1_DIRTY( b, eightysix);\n        cleanup_R1();\n        return avg;\n    }\n\n    inline void maximizeBrightness( uint8_t limit = 255 )  {\n        uint8_t max = red;\n        if( green > max) max = green;\n        if( blue > max) max = blue;\n        uint16_t factor = ((uint16_t)(limit) * 256) / max;\n        red =   (red   * factor) / 256;\n        green = (green * factor) / 256;\n        blue =  (blue  * factor) / 256;\n    }\n    \n    typedef enum {\n        AliceBlue=0xF0F8FF,\n        Amethyst=0x9966CC,\n        AntiqueWhite=0xFAEBD7,\n        Aqua=0x00FFFF,\n        Aquamarine=0x7FFFD4,\n        Azure=0xF0FFFF,\n        Beige=0xF5F5DC,\n        Bisque=0xFFE4C4,\n        Black=0x000000,\n        BlanchedAlmond=0xFFEBCD,\n        Blue=0x0000FF,\n        BlueViolet=0x8A2BE2,\n        Brown=0xA52A2A,\n        BurlyWood=0xDEB887,\n        CadetBlue=0x5F9EA0,\n        Chartreuse=0x7FFF00,\n        Chocolate=0xD2691E,\n        Coral=0xFF7F50,\n        CornflowerBlue=0x6495ED,\n        Cornsilk=0xFFF8DC,\n        Crimson=0xDC143C,\n        Cyan=0x00FFFF,\n        DarkBlue=0x00008B,\n        DarkCyan=0x008B8B,\n        DarkGoldenrod=0xB8860B,\n        DarkGray=0xA9A9A9,\n        DarkGreen=0x006400,\n        DarkKhaki=0xBDB76B,\n        DarkMagenta=0x8B008B,\n        DarkOliveGreen=0x556B2F,\n        DarkOrange=0xFF8C00,\n        DarkOrchid=0x9932CC,\n        DarkRed=0x8B0000,\n        DarkSalmon=0xE9967A,\n        DarkSeaGreen=0x8FBC8F,\n        DarkSlateBlue=0x483D8B,\n        DarkSlateGray=0x2F4F4F,\n        DarkTurquoise=0x00CED1,\n        DarkViolet=0x9400D3,\n        DeepPink=0xFF1493,\n        DeepSkyBlue=0x00BFFF,\n        DimGray=0x696969,\n        DodgerBlue=0x1E90FF,\n        FireBrick=0xB22222,\n        FloralWhite=0xFFFAF0,\n        ForestGreen=0x228B22,\n        Fuchsia=0xFF00FF,\n        Gainsboro=0xDCDCDC,\n        GhostWhite=0xF8F8FF,\n        Gold=0xFFD700,\n        Goldenrod=0xDAA520,\n        Gray=0x808080,\n        Green=0x008000,\n        GreenYellow=0xADFF2F,\n        Honeydew=0xF0FFF0,\n        HotPink=0xFF69B4,\n        IndianRed=0xCD5C5C,\n        Indigo=0x4B0082,\n        Ivory=0xFFFFF0,\n        Khaki=0xF0E68C,\n        Lavender=0xE6E6FA,\n        LavenderBlush=0xFFF0F5,\n        LawnGreen=0x7CFC00,\n        LemonChiffon=0xFFFACD,\n        LightBlue=0xADD8E6,\n        LightCoral=0xF08080,\n        LightCyan=0xE0FFFF,\n        LightGoldenrodYellow=0xFAFAD2,\n        LightGreen=0x90EE90,\n        LightGrey=0xD3D3D3,\n        LightPink=0xFFB6C1,\n        LightSalmon=0xFFA07A,\n        LightSeaGreen=0x20B2AA,\n        LightSkyBlue=0x87CEFA,\n        LightSlateGray=0x778899,\n        LightSteelBlue=0xB0C4DE,\n        LightYellow=0xFFFFE0,\n        Lime=0x00FF00,\n        LimeGreen=0x32CD32,\n        Linen=0xFAF0E6,\n        Magenta=0xFF00FF,\n        Maroon=0x800000,\n        MediumAquamarine=0x66CDAA,\n        MediumBlue=0x0000CD,\n        MediumOrchid=0xBA55D3,\n        MediumPurple=0x9370DB,\n        MediumSeaGreen=0x3CB371,\n        MediumSlateBlue=0x7B68EE,\n        MediumSpringGreen=0x00FA9A,\n        MediumTurquoise=0x48D1CC,\n        MediumVioletRed=0xC71585,\n        MidnightBlue=0x191970,\n        MintCream=0xF5FFFA,\n        MistyRose=0xFFE4E1,\n        Moccasin=0xFFE4B5,\n        NavajoWhite=0xFFDEAD,\n        Navy=0x000080,\n        OldLace=0xFDF5E6,\n        Olive=0x808000,\n        OliveDrab=0x6B8E23,\n        Orange=0xFFA500,\n        OrangeRed=0xFF4500,\n        Orchid=0xDA70D6,\n        PaleGoldenrod=0xEEE8AA,\n        PaleGreen=0x98FB98,\n        PaleTurquoise=0xAFEEEE,\n        PaleVioletRed=0xDB7093,\n        PapayaWhip=0xFFEFD5,\n        PeachPuff=0xFFDAB9,\n        Peru=0xCD853F,\n        Pink=0xFFC0CB,\n        Plaid=0xCC5533,\n        Plum=0xDDA0DD,\n        PowderBlue=0xB0E0E6,\n        Purple=0x800080,\n        Red=0xFF0000,\n        RosyBrown=0xBC8F8F,\n        RoyalBlue=0x4169E1,\n        SaddleBrown=0x8B4513,\n        Salmon=0xFA8072,\n        SandyBrown=0xF4A460,\n        SeaGreen=0x2E8B57,\n        Seashell=0xFFF5EE,\n        Sienna=0xA0522D,\n        Silver=0xC0C0C0,\n        SkyBlue=0x87CEEB,\n        SlateBlue=0x6A5ACD,\n        SlateGray=0x708090,\n        Snow=0xFFFAFA,\n        SpringGreen=0x00FF7F,\n        SteelBlue=0x4682B4,\n        Tan=0xD2B48C,\n        Teal=0x008080,\n        Thistle=0xD8BFD8,\n        Tomato=0xFF6347,\n        Turquoise=0x40E0D0,\n        Violet=0xEE82EE,\n        Wheat=0xF5DEB3,\n        White=0xFFFFFF,\n        WhiteSmoke=0xF5F5F5,\n        Yellow=0xFFFF00,\n        YellowGreen=0x9ACD32\n    } HTMLColorCode;\n    static uint32_t Squant;\n};\n\n\ninline __attribute__((always_inline)) bool operator== (const CRGB& lhs, const CRGB& rhs)\n{\n    return (lhs.r == rhs.r) && (lhs.g == rhs.g) && (lhs.b == rhs.b);\n}\n\ninline __attribute__((always_inline)) bool operator!= (const CRGB& lhs, const CRGB& rhs)\n{\n    return !(lhs == rhs);\n}\n\ninline __attribute__((always_inline)) bool operator< (const CRGB& lhs, const CRGB& rhs)\n{\n    uint16_t sl, sr;\n    sl = lhs.r + lhs.g + lhs.b;\n    sr = rhs.r + rhs.g + rhs.b;\n    return sl < sr;\n}\n\ninline __attribute__((always_inline)) bool operator> (const CRGB& lhs, const CRGB& rhs)\n{\n    uint16_t sl, sr;\n    sl = lhs.r + lhs.g + lhs.b;\n    sr = rhs.r + rhs.g + rhs.b;\n    return sl > sr;\n}\n\ninline __attribute__((always_inline)) bool operator>= (const CRGB& lhs, const CRGB& rhs)\n{\n    uint16_t sl, sr;\n    sl = lhs.r + lhs.g + lhs.b;\n    sr = rhs.r + rhs.g + rhs.b;\n    return sl >= sr;\n}\n\ninline __attribute__((always_inline)) bool operator<= (const CRGB& lhs, const CRGB& rhs)\n{\n    uint16_t sl, sr;\n    sl = lhs.r + lhs.g + lhs.b;\n    sr = rhs.r + rhs.g + rhs.b;\n    return sl <= sr;\n}\n\n\n__attribute__((always_inline))\ninline CRGB operator+( const CRGB& p1, const CRGB& p2)\n{\n    return CRGB( qadd8( p1.r, p2.r),\n                 qadd8( p1.g, p2.g),\n                 qadd8( p1.b, p2.b));\n}\n\n__attribute__((always_inline))\ninline CRGB operator-( const CRGB& p1, const CRGB& p2)\n{\n    return CRGB( qsub8( p1.r, p2.r),\n                 qsub8( p1.g, p2.g),\n                 qsub8( p1.b, p2.b));\n}\n\n__attribute__((always_inline))\ninline CRGB operator*( const CRGB& p1, uint8_t d)\n{\n    return CRGB( qmul8( p1.r, d),\n                 qmul8( p1.g, d),\n                 qmul8( p1.b, d));\n}\n\n__attribute__((always_inline))\ninline CRGB operator/( const CRGB& p1, uint8_t d)\n{\n    return CRGB( p1.r/d, p1.g/d, p1.b/d);\n}\n\n    \n__attribute__((always_inline))\ninline CRGB operator&( const CRGB& p1, const CRGB& p2)\n{\n    return CRGB( p1.r < p2.r ? p1.r : p2.r,\n                 p1.g < p2.g ? p1.g : p2.g,\n                 p1.b < p2.b ? p1.b : p2.b);\n}\n    \n__attribute__((always_inline))\ninline CRGB operator|( const CRGB& p1, const CRGB& p2)\n{\n    return CRGB( p1.r > p2.r ? p1.r : p2.r,\n                 p1.g > p2.g ? p1.g : p2.g,\n                 p1.b > p2.b ? p1.b : p2.b);\n}\n\n__attribute__((always_inline))\ninline CRGB operator%( const CRGB& p1, uint8_t d)\n{\n    CRGB retval( p1);\n    retval.nscale8_video( d);\n    return retval;\n}\n\n\n\n// Define RGB orderings\nenum EOrder {\n\tRGB=0012,\n\tRBG=0021,\n\tGRB=0102,\n\tGBR=0120,\n\tBRG=0201,\n\tBGR=0210\n};\n\n\n#endif\n"
    }, {
      filename: "RenicsWire/RenicsWire.h",
      code: "#include <SPI.h>\n#include <avr/io.h>\n\n#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))\n#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))\n\n// Global defines\n#define PORTS_COUNT 12\n\n#define PORT_1 1\n#define PORT_2 2\n#define PORT_3 3\n#define PORT_4 4\n#define PORT_5 5\n#define PORT_6 6\n#define PORT_7 7\n#define PORT_8 8\n#define PORT_9 9\n#define PORT_10 10\n#define PORT_11 11\n#define PORT_12 12\n\n// Chip Select pins for rj45 ports\nuint8_t port_to_cs_pin[] = {\n  PK0, // PORT_1\n  PK2, // PORT_2\n  PK4, // PORT_3\n  PK6, // PORT_4\n  PG2, // PORT_5\n  PJ5, // PORT_6\n  PJ3, // PORT_7\n  PJ1, // PORT_8\n  PL2, // PORT_9\n  PL1, // PORT_10\n  PB0, // PORT_11\n  PE7, // PORT_12\n};\nvolatile uint8_t*  port_to_cs_ddr_reg[] = {\n  &DDRK, // PORT_1\n  &DDRK, // PORT_2\n  &DDRK, // PORT_3\n  &DDRK, // PORT_4\n  &DDRG, // PORT_5\n  &DDRJ, // PORT_6\n  &DDRJ, // PORT_7\n  &DDRJ, // PORT_8\n  &DDRL, // PORT_9\n  &DDRL, // PORT_10\n  &DDRB, // PORT_11\n  &DDRE, // PORT_12\n};\nvolatile uint8_t* port_to_cs_out_reg[] = {\n  &PORTK, // PORT_1\n  &PORTK, // PORT_2\n  &PORTK, // PORT_3\n  &PORTK, // PORT_4\n  &PORTG, // PORT_5\n  &PORTJ, // PORT_6\n  &PORTJ, // PORT_7\n  &PORTJ, // PORT_8\n  &PORTL, // PORT_9\n  &PORTL, // PORT_10\n  &PORTB, // PORT_11\n  &PORTE, // PORT_12\n};\n\n\nclass RenicsWire {\n  public:\n    static boolean isInited;\n    static void pullUpPortsToHigh() {\n      for(int i = 0; i < PORTS_COUNT; i++) {\n        sbi(*(port_to_cs_ddr_reg[i]), port_to_cs_pin[i]);\n        sbi(*(port_to_cs_out_reg[i]), port_to_cs_pin[i]);\n      }\n    }\n    static void init() {\n      if(RenicsWire::isInited) {\n        return;  \n      }\n      SPI.begin();\n      RenicsWire::pullUpPortsToHigh();\n      RenicsWire::isInited = true;\n    }\n    static void beginTransmit(uint8_t portNumber = 1) {\n      RenicsWire::pullUpPortsToHigh();\n      cbi(*(port_to_cs_out_reg[portNumber - 1]), port_to_cs_pin[portNumber - 1]);\n    }\n    static void endTransmit() {\n      RenicsWire::pullUpPortsToHigh();\n    }\n    static uint8_t getByte(uint8_t byteNumber) {\n      delay(10);\n      SPI.transfer(byteNumber);\n      delay(10);\n      return SPI.transfer(0xFF);\n    }\n};\n\nboolean RenicsWire::isInited = false;\n\nclass RenicsIR {\n  private:\n    uint8_t port = 1;\n  public:\n    RenicsIR(uint8_t port) {\n      this->port = port;\n      RenicsWire::init();\n    }\n    uint16_t getDistance() {\n        RenicsWire::beginTransmit(this->port);\n        \n        uint8_t b1 = RenicsWire::getByte(0x01);\n        uint8_t b2 = RenicsWire::getByte(0x02);\n        \n        uint16_t distance = (b2 << 8) | b1;\n      \n        RenicsWire::endTransmit();\n\n        return distance;\n    }\n};\n"
    }, {
      filename: "RenicsWire/SPI.cpp",
      code: "/*\n * Copyright (c) 2010 by Cristian Maglie <c.maglie@arduino.cc>\n * Copyright (c) 2014 by Paul Stoffregen <paul@pjrc.com> (Transaction API)\n * Copyright (c) 2014 by Matthijs Kooijman <matthijs@stdin.nl> (SPISettings AVR)\n * Copyright (c) 2014 by Andrew J. Kroll <xxxajk@gmail.com> (atomicity fixes)\n * SPI Master library for arduino.\n *\n * This file is free software; you can redistribute it and/or modify\n * it under the terms of either the GNU General Public License version 2\n * or the GNU Lesser General Public License version 2.1, both as\n * published by the Free Software Foundation.\n */\n\n#include \"SPI.h\"\n\nSPIClass SPI;\n\nuint8_t SPIClass::initialized = 0;\nuint8_t SPIClass::interruptMode = 0;\nuint8_t SPIClass::interruptMask = 0;\nuint8_t SPIClass::interruptSave = 0;\n#ifdef SPI_TRANSACTION_MISMATCH_LED\nuint8_t SPIClass::inTransactionFlag = 0;\n#endif\n\nvoid SPIClass::begin()\n{\n  uint8_t sreg = SREG;\n  noInterrupts(); // Protect from a scheduler and prevent transactionBegin\n  if (!initialized) {\n    // Set SS to high so a connected chip will be \"deselected\" by default\n    uint8_t port = digitalPinToPort(SS);\n    uint8_t bit = digitalPinToBitMask(SS);\n    volatile uint8_t *reg = portModeRegister(port);\n\n    // if the SS pin is not already configured as an output\n    // then set it high (to enable the internal pull-up resistor)\n    if(!(*reg & bit)){\n      digitalWrite(SS, HIGH);\n    }\n\n    // When the SS pin is set as OUTPUT, it can be used as\n    // a general purpose output port (it doesn't influence\n    // SPI operations).\n    pinMode(SS, OUTPUT);\n\n    // Warning: if the SS pin ever becomes a LOW INPUT then SPI\n    // automatically switches to Slave, so the data direction of\n    // the SS pin MUST be kept as OUTPUT.\n    SPCR |= _BV(MSTR);\n    SPCR |= _BV(SPE);\n\n    // Set direction register for SCK and MOSI pin.\n    // MISO pin automatically overrides to INPUT.\n    // By doing this AFTER enabling SPI, we avoid accidentally\n    // clocking in a single bit since the lines go directly\n    // from \"input\" to SPI control.\n    // http://code.google.com/p/arduino/issues/detail?id=888\n    pinMode(SCK, OUTPUT);\n    pinMode(MOSI, OUTPUT);\n  }\n  initialized++; // reference count\n  SREG = sreg;\n}\n\nvoid SPIClass::end() {\n  uint8_t sreg = SREG;\n  noInterrupts(); // Protect from a scheduler and prevent transactionBegin\n  // Decrease the reference counter\n  if (initialized)\n    initialized--;\n  // If there are no more references disable SPI\n  if (!initialized) {\n    SPCR &= ~_BV(SPE);\n    interruptMode = 0;\n    #ifdef SPI_TRANSACTION_MISMATCH_LED\n    inTransactionFlag = 0;\n    #endif\n  }\n  SREG = sreg;\n}\n\n// mapping of interrupt numbers to bits within SPI_AVR_EIMSK\n#if defined(__AVR_ATmega32U4__)\n  #define SPI_INT0_MASK  (1<<INT0)\n  #define SPI_INT1_MASK  (1<<INT1)\n  #define SPI_INT2_MASK  (1<<INT2)\n  #define SPI_INT3_MASK  (1<<INT3)\n  #define SPI_INT4_MASK  (1<<INT6)\n#elif defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB1286__)\n  #define SPI_INT0_MASK  (1<<INT0)\n  #define SPI_INT1_MASK  (1<<INT1)\n  #define SPI_INT2_MASK  (1<<INT2)\n  #define SPI_INT3_MASK  (1<<INT3)\n  #define SPI_INT4_MASK  (1<<INT4)\n  #define SPI_INT5_MASK  (1<<INT5)\n  #define SPI_INT6_MASK  (1<<INT6)\n  #define SPI_INT7_MASK  (1<<INT7)\n#elif defined(EICRA) && defined(EICRB) && defined(EIMSK)\n  #define SPI_INT0_MASK  (1<<INT4)\n  #define SPI_INT1_MASK  (1<<INT5)\n  #define SPI_INT2_MASK  (1<<INT0)\n  #define SPI_INT3_MASK  (1<<INT1)\n  #define SPI_INT4_MASK  (1<<INT2)\n  #define SPI_INT5_MASK  (1<<INT3)\n  #define SPI_INT6_MASK  (1<<INT6)\n  #define SPI_INT7_MASK  (1<<INT7)\n#else\n  #ifdef INT0\n  #define SPI_INT0_MASK  (1<<INT0)\n  #endif\n  #ifdef INT1\n  #define SPI_INT1_MASK  (1<<INT1)\n  #endif\n  #ifdef INT2\n  #define SPI_INT2_MASK  (1<<INT2)\n  #endif\n#endif\n\nvoid SPIClass::usingInterrupt(uint8_t interruptNumber)\n{\n  uint8_t mask = 0;\n  uint8_t sreg = SREG;\n  noInterrupts(); // Protect from a scheduler and prevent transactionBegin\n  switch (interruptNumber) {\n  #ifdef SPI_INT0_MASK\n  case 0: mask = SPI_INT0_MASK; break;\n  #endif\n  #ifdef SPI_INT1_MASK\n  case 1: mask = SPI_INT1_MASK; break;\n  #endif\n  #ifdef SPI_INT2_MASK\n  case 2: mask = SPI_INT2_MASK; break;\n  #endif\n  #ifdef SPI_INT3_MASK\n  case 3: mask = SPI_INT3_MASK; break;\n  #endif\n  #ifdef SPI_INT4_MASK\n  case 4: mask = SPI_INT4_MASK; break;\n  #endif\n  #ifdef SPI_INT5_MASK\n  case 5: mask = SPI_INT5_MASK; break;\n  #endif\n  #ifdef SPI_INT6_MASK\n  case 6: mask = SPI_INT6_MASK; break;\n  #endif\n  #ifdef SPI_INT7_MASK\n  case 7: mask = SPI_INT7_MASK; break;\n  #endif\n  default:\n    interruptMode = 2;\n    break;\n  }\n  interruptMask |= mask;\n  if (!interruptMode)\n    interruptMode = 1;\n  SREG = sreg;\n}\n\nvoid SPIClass::notUsingInterrupt(uint8_t interruptNumber)\n{\n  // Once in mode 2 we can't go back to 0 without a proper reference count\n  if (interruptMode == 2)\n    return;\n  uint8_t mask = 0;\n  uint8_t sreg = SREG;\n  noInterrupts(); // Protect from a scheduler and prevent transactionBegin\n  switch (interruptNumber) {\n  #ifdef SPI_INT0_MASK\n  case 0: mask = SPI_INT0_MASK; break;\n  #endif\n  #ifdef SPI_INT1_MASK\n  case 1: mask = SPI_INT1_MASK; break;\n  #endif\n  #ifdef SPI_INT2_MASK\n  case 2: mask = SPI_INT2_MASK; break;\n  #endif\n  #ifdef SPI_INT3_MASK\n  case 3: mask = SPI_INT3_MASK; break;\n  #endif\n  #ifdef SPI_INT4_MASK\n  case 4: mask = SPI_INT4_MASK; break;\n  #endif\n  #ifdef SPI_INT5_MASK\n  case 5: mask = SPI_INT5_MASK; break;\n  #endif\n  #ifdef SPI_INT6_MASK\n  case 6: mask = SPI_INT6_MASK; break;\n  #endif\n  #ifdef SPI_INT7_MASK\n  case 7: mask = SPI_INT7_MASK; break;\n  #endif\n  default:\n    break;\n    // this case can't be reached\n  }\n  interruptMask &= ~mask;\n  if (!interruptMask)\n    interruptMode = 0;\n  SREG = sreg;\n}\n"
    }, {
      filename: "RenicsWire/SPI.h",
      code: "/*\n * Copyright (c) 2010 by Cristian Maglie <c.maglie@arduino.cc>\n * Copyright (c) 2014 by Paul Stoffregen <paul@pjrc.com> (Transaction API)\n * Copyright (c) 2014 by Matthijs Kooijman <matthijs@stdin.nl> (SPISettings AVR)\n * Copyright (c) 2014 by Andrew J. Kroll <xxxajk@gmail.com> (atomicity fixes)\n * SPI Master library for arduino.\n *\n * This file is free software; you can redistribute it and/or modify\n * it under the terms of either the GNU General Public License version 2\n * or the GNU Lesser General Public License version 2.1, both as\n * published by the Free Software Foundation.\n */\n\n#ifndef _SPI_H_INCLUDED\n#define _SPI_H_INCLUDED\n\n#include <Arduino.h>\n\n// SPI_HAS_TRANSACTION means SPI has beginTransaction(), endTransaction(),\n// usingInterrupt(), and SPISetting(clock, bitOrder, dataMode)\n#define SPI_HAS_TRANSACTION 1\n\n// SPI_HAS_NOTUSINGINTERRUPT means that SPI has notUsingInterrupt() method\n#define SPI_HAS_NOTUSINGINTERRUPT 1\n\n// SPI_ATOMIC_VERSION means that SPI has atomicity fixes and what version.\n// This way when there is a bug fix you can check this define to alert users\n// of your code if it uses better version of this library.\n// This also implies everything that SPI_HAS_TRANSACTION as documented above is\n// available too.\n#define SPI_ATOMIC_VERSION 1\n\n// Uncomment this line to add detection of mismatched begin/end transactions.\n// A mismatch occurs if other libraries fail to use SPI.endTransaction() for\n// each SPI.beginTransaction().  Connect an LED to this pin.  The LED will turn\n// on if any mismatch is ever detected.\n//#define SPI_TRANSACTION_MISMATCH_LED 5\n\n#ifndef LSBFIRST\n#define LSBFIRST 0\n#endif\n#ifndef MSBFIRST\n#define MSBFIRST 1\n#endif\n\n#define SPI_CLOCK_DIV4 0x00\n#define SPI_CLOCK_DIV16 0x01\n#define SPI_CLOCK_DIV64 0x02\n#define SPI_CLOCK_DIV128 0x03\n#define SPI_CLOCK_DIV2 0x04\n#define SPI_CLOCK_DIV8 0x05\n#define SPI_CLOCK_DIV32 0x06\n\n#define SPI_MODE0 0x00\n#define SPI_MODE1 0x04\n#define SPI_MODE2 0x08\n#define SPI_MODE3 0x0C\n\n#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR\n#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR\n#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR\n\n// define SPI_AVR_EIMSK for AVR boards with external interrupt pins\n#if defined(EIMSK)\n  #define SPI_AVR_EIMSK  EIMSK\n#elif defined(GICR)\n  #define SPI_AVR_EIMSK  GICR\n#elif defined(GIMSK)\n  #define SPI_AVR_EIMSK  GIMSK\n#endif\n\nclass SPISettings {\npublic:\n  SPISettings(uint32_t clock, uint8_t bitOrder, uint8_t dataMode) {\n    if (__builtin_constant_p(clock)) {\n      init_AlwaysInline(clock, bitOrder, dataMode);\n    } else {\n      init_MightInline(clock, bitOrder, dataMode);\n    }\n  }\n  SPISettings() {\n    init_AlwaysInline(4000000, MSBFIRST, SPI_MODE0);\n  }\nprivate:\n  void init_MightInline(uint32_t clock, uint8_t bitOrder, uint8_t dataMode) {\n    init_AlwaysInline(clock, bitOrder, dataMode);\n  }\n  void init_AlwaysInline(uint32_t clock, uint8_t bitOrder, uint8_t dataMode)\n    __attribute__((__always_inline__)) {\n    // Clock settings are defined as follows. Note that this shows SPI2X\n    // inverted, so the bits form increasing numbers. Also note that\n    // fosc/64 appears twice\n    // SPR1 SPR0 ~SPI2X Freq\n    //   0    0     0   fosc/2\n    //   0    0     1   fosc/4\n    //   0    1     0   fosc/8\n    //   0    1     1   fosc/16\n    //   1    0     0   fosc/32\n    //   1    0     1   fosc/64\n    //   1    1     0   fosc/64\n    //   1    1     1   fosc/128\n\n    // We find the fastest clock that is less than or equal to the\n    // given clock rate. The clock divider that results in clock_setting\n    // is 2 ^^ (clock_div + 1). If nothing is slow enough, we'll use the\n    // slowest (128 == 2 ^^ 7, so clock_div = 6).\n    uint8_t clockDiv;\n\n    // When the clock is known at compile time, use this if-then-else\n    // cascade, which the compiler knows how to completely optimize\n    // away. When clock is not known, use a loop instead, which generates\n    // shorter code.\n    if (__builtin_constant_p(clock)) {\n      if (clock >= F_CPU / 2) {\n        clockDiv = 0;\n      } else if (clock >= F_CPU / 4) {\n        clockDiv = 1;\n      } else if (clock >= F_CPU / 8) {\n        clockDiv = 2;\n      } else if (clock >= F_CPU / 16) {\n        clockDiv = 3;\n      } else if (clock >= F_CPU / 32) {\n        clockDiv = 4;\n      } else if (clock >= F_CPU / 64) {\n        clockDiv = 5;\n      } else {\n        clockDiv = 6;\n      }\n    } else {\n      uint32_t clockSetting = F_CPU / 2;\n      clockDiv = 0;\n      while (clockDiv < 6 && clock < clockSetting) {\n        clockSetting /= 2;\n        clockDiv++;\n      }\n    }\n\n    // Compensate for the duplicate fosc/64\n    if (clockDiv == 6)\n    clockDiv = 7;\n\n    // Invert the SPI2X bit\n    clockDiv ^= 0x1;\n\n    // Pack into the SPISettings class\n    spcr = _BV(SPE) | _BV(MSTR) | ((bitOrder == LSBFIRST) ? _BV(DORD) : 0) |\n      (dataMode & SPI_MODE_MASK) | ((clockDiv >> 1) & SPI_CLOCK_MASK);\n    spsr = clockDiv & SPI_2XCLOCK_MASK;\n  }\n  uint8_t spcr;\n  uint8_t spsr;\n  friend class SPIClass;\n};\n\n\nclass SPIClass {\npublic:\n  // Initialize the SPI library\n  static void begin();\n\n  // If SPI is used from within an interrupt, this function registers\n  // that interrupt with the SPI library, so beginTransaction() can\n  // prevent conflicts.  The input interruptNumber is the number used\n  // with attachInterrupt.  If SPI is used from a different interrupt\n  // (eg, a timer), interruptNumber should be 255.\n  static void usingInterrupt(uint8_t interruptNumber);\n  // And this does the opposite.\n  static void notUsingInterrupt(uint8_t interruptNumber);\n  // Note: the usingInterrupt and notUsingInterrupt functions should\n  // not to be called from ISR context or inside a transaction.\n  // For details see:\n  // https://github.com/arduino/Arduino/pull/2381\n  // https://github.com/arduino/Arduino/pull/2449\n\n  // Before using SPI.transfer() or asserting chip select pins,\n  // this function is used to gain exclusive access to the SPI bus\n  // and configure the correct settings.\n  inline static void beginTransaction(SPISettings settings) {\n    if (interruptMode > 0) {\n      uint8_t sreg = SREG;\n      noInterrupts();\n\n      #ifdef SPI_AVR_EIMSK\n      if (interruptMode == 1) {\n        interruptSave = SPI_AVR_EIMSK;\n        SPI_AVR_EIMSK &= ~interruptMask;\n        SREG = sreg;\n      } else\n      #endif\n      {\n        interruptSave = sreg;\n      }\n    }\n\n    #ifdef SPI_TRANSACTION_MISMATCH_LED\n    if (inTransactionFlag) {\n      pinMode(SPI_TRANSACTION_MISMATCH_LED, OUTPUT);\n      digitalWrite(SPI_TRANSACTION_MISMATCH_LED, HIGH);\n    }\n    inTransactionFlag = 1;\n    #endif\n\n    SPCR = settings.spcr;\n    SPSR = settings.spsr;\n  }\n\n  // Write to the SPI bus (MOSI pin) and also receive (MISO pin)\n  inline static uint8_t transfer(uint8_t data) {\n    SPDR = data;\n    /*\n     * The following NOP introduces a small delay that can prevent the wait\n     * loop form iterating when running at the maximum speed. This gives\n     * about 10% more speed, even if it seems counter-intuitive. At lower\n     * speeds it is unnoticed.\n     */\n    asm volatile(\"nop\");\n    while (!(SPSR & _BV(SPIF))) ; // wait\n    return SPDR;\n  }\n  inline static uint16_t transfer16(uint16_t data) {\n    union { uint16_t val; struct { uint8_t lsb; uint8_t msb; }; } in, out;\n    in.val = data;\n    if (!(SPCR & _BV(DORD))) {\n      SPDR = in.msb;\n      asm volatile(\"nop\"); // See transfer(uint8_t) function\n      while (!(SPSR & _BV(SPIF))) ;\n      out.msb = SPDR;\n      SPDR = in.lsb;\n      asm volatile(\"nop\");\n      while (!(SPSR & _BV(SPIF))) ;\n      out.lsb = SPDR;\n    } else {\n      SPDR = in.lsb;\n      asm volatile(\"nop\");\n      while (!(SPSR & _BV(SPIF))) ;\n      out.lsb = SPDR;\n      SPDR = in.msb;\n      asm volatile(\"nop\");\n      while (!(SPSR & _BV(SPIF))) ;\n      out.msb = SPDR;\n    }\n    return out.val;\n  }\n  inline static void transfer(void *buf, size_t count) {\n    if (count == 0) return;\n    uint8_t *p = (uint8_t *)buf;\n    SPDR = *p;\n    while (--count > 0) {\n      uint8_t out = *(p + 1);\n      while (!(SPSR & _BV(SPIF))) ;\n      uint8_t in = SPDR;\n      SPDR = out;\n      *p++ = in;\n    }\n    while (!(SPSR & _BV(SPIF))) ;\n    *p = SPDR;\n  }\n  // After performing a group of transfers and releasing the chip select\n  // signal, this function allows others to access the SPI bus\n  inline static void endTransaction(void) {\n    #ifdef SPI_TRANSACTION_MISMATCH_LED\n    if (!inTransactionFlag) {\n      pinMode(SPI_TRANSACTION_MISMATCH_LED, OUTPUT);\n      digitalWrite(SPI_TRANSACTION_MISMATCH_LED, HIGH);\n    }\n    inTransactionFlag = 0;\n    #endif\n\n    if (interruptMode > 0) {\n      #ifdef SPI_AVR_EIMSK\n      uint8_t sreg = SREG;\n      #endif\n      noInterrupts();\n      #ifdef SPI_AVR_EIMSK\n      if (interruptMode == 1) {\n        SPI_AVR_EIMSK = interruptSave;\n        SREG = sreg;\n      } else\n      #endif\n      {\n        SREG = interruptSave;\n      }\n    }\n  }\n\n  // Disable the SPI bus\n  static void end();\n\n  // This function is deprecated.  New applications should use\n  // beginTransaction() to configure SPI settings.\n  inline static void setBitOrder(uint8_t bitOrder) {\n    if (bitOrder == LSBFIRST) SPCR |= _BV(DORD);\n    else SPCR &= ~(_BV(DORD));\n  }\n  // This function is deprecated.  New applications should use\n  // beginTransaction() to configure SPI settings.\n  inline static void setDataMode(uint8_t dataMode) {\n    SPCR = (SPCR & ~SPI_MODE_MASK) | dataMode;\n  }\n  // This function is deprecated.  New applications should use\n  // beginTransaction() to configure SPI settings.\n  inline static void setClockDivider(uint8_t clockDiv) {\n    SPCR = (SPCR & ~SPI_CLOCK_MASK) | (clockDiv & SPI_CLOCK_MASK);\n    SPSR = (SPSR & ~SPI_2XCLOCK_MASK) | ((clockDiv >> 2) & SPI_2XCLOCK_MASK);\n  }\n  // These undocumented functions should not be used.  SPI.transfer()\n  // polls the hardware flag which is automatically cleared as the\n  // AVR responds to SPI's interrupt\n  inline static void attachInterrupt() { SPCR |= _BV(SPIE); }\n  inline static void detachInterrupt() { SPCR &= ~_BV(SPIE); }\n\nprivate:\n  static uint8_t initialized;\n  static uint8_t interruptMode; // 0=none, 1=mask, 2=global\n  static uint8_t interruptMask; // which interrupts to mask\n  static uint8_t interruptSave; // temp storage, to restore state\n  #ifdef SPI_TRANSACTION_MISMATCH_LED\n  static uint8_t inTransactionFlag;\n  #endif\n};\n\nextern SPIClass SPI;\n\n#endif\n"
    }, {
      filename: "LSM6DS3/LSM6DS3.h",
      code: "/*\n  This file is part of the Arduino_LSM6DS3 library.\n  Copyright (c) 2019 Arduino SA. All rights reserved.\n\n  This library is free software; you can redistribute it and/or\n  modify it under the terms of the GNU Lesser General Public\n  License as published by the Free Software Foundation; either\n  version 2.1 of the License, or (at your option) any later version.\n\n  This library is distributed in the hope that it will be useful,\n  but WITHOUT ANY WARRANTY; without even the implied warranty of\n  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n  Lesser General Public License for more details.\n\n  You should have received a copy of the GNU Lesser General Public\n  License along with this library; if not, write to the Free Software\n  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA\n*/\n\n#include <Arduino.h>\n#include <Wire.h>\n#include <SPI.h>\n\n#define LSM6DS3_ADDRESS            0x6B\n\n#define LSM6DS3_WHO_AM_I_REG       0X0F\n#define LSM6DS3_CTRL1_XL           0X10\n#define LSM6DS3_CTRL2_G            0X11\n\n#define LSM6DS3_STATUS_REG         0X1E\n\n#define LSM6DS3_CTRL6_C            0X15\n#define LSM6DS3_CTRL7_G            0X16\n#define LSM6DS3_CTRL8_XL           0X17\n\n#define LSM6DS3_OUTX_L_G           0X22\n#define LSM6DS3_OUTX_H_G           0X23\n#define LSM6DS3_OUTY_L_G           0X24\n#define LSM6DS3_OUTY_H_G           0X25\n#define LSM6DS3_OUTZ_L_G           0X26\n#define LSM6DS3_OUTZ_H_G           0X27\n\n#define LSM6DS3_OUTX_L_XL          0X28\n#define LSM6DS3_OUTX_H_XL          0X29\n#define LSM6DS3_OUTY_L_XL          0X2A\n#define LSM6DS3_OUTY_H_XL          0X2B\n#define LSM6DS3_OUTZ_L_XL          0X2C\n#define LSM6DS3_OUTZ_H_XL          0X2D\n\n\n\nclass LSM6DS3Class {\n  public:\n    LSM6DS3Class(TwoWire& wire, uint8_t slaveAddress);\n    LSM6DS3Class(SPIClass& spi, int csPin, int irqPin);\n    virtual ~LSM6DS3Class();\n\n    int begin();\n    void end();\n\n    // Accelerometer\n    virtual int readAcceleration(float& x, float& y, float& z); // Results are in g (earth gravity).\n    virtual float accelerationSampleRate(); // Sampling rate of the sensor.\n    virtual int accelerationAvailable(); // Check for available data from accelerometer\n\n    // Gyroscope\n    virtual int readGyroscope(float& x, float& y, float& z); // Results are in degrees/second.\n    virtual float gyroscopeSampleRate(); // Sampling rate of the sensor.\n    virtual int gyroscopeAvailable(); // Check for available data from gyroscope\n\n\n  protected:\n    int readRegister(uint8_t address);\n    int readRegisters(uint8_t address, uint8_t* data, size_t length);\n    int writeRegister(uint8_t address, uint8_t value);\n\n\n  private:\n    TwoWire* _wire;\n    SPIClass* _spi;\n    uint8_t _slaveAddress;\n    int _csPin;\n    int _irqPin;\n\n    SPISettings _spiSettings;\n};\n\nextern LSM6DS3Class IMU_LSM6DS3;\n#undef IMU\n#define IMU IMU_LSM6DS3"
    }, {
      filename: "LSM6DS3/LSM6DS3.cpp",
      code: "/*\n  This file is part of the Arduino_LSM6DS3 library.\n  Copyright (c) 2019 Arduino SA. All rights reserved.\n\n  This library is free software; you can redistribute it and/or\n  modify it under the terms of the GNU Lesser General Public\n  License as published by the Free Software Foundation; either\n  version 2.1 of the License, or (at your option) any later version.\n\n  This library is distributed in the hope that it will be useful,\n  but WITHOUT ANY WARRANTY; without even the implied warranty of\n  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n  Lesser General Public License for more details.\n\n  You should have received a copy of the GNU Lesser General Public\n  License along with this library; if not, write to the Free Software\n  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA\n*/\n\n#include \"LSM6DS3.h\"\n\nLSM6DS3Class::LSM6DS3Class(TwoWire& wire, uint8_t slaveAddress) :\n  _wire(&wire),\n  _spi(NULL),\n  _slaveAddress(slaveAddress)\n{\n}\n\nLSM6DS3Class::LSM6DS3Class(SPIClass& spi, int csPin, int irqPin) :\n  _wire(NULL),\n  _spi(&spi),\n  _csPin(csPin),\n  _irqPin(irqPin),\n  _spiSettings(10E6, MSBFIRST, SPI_MODE0)\n{\n}\n\nLSM6DS3Class::~LSM6DS3Class()\n{\n}\n\nint LSM6DS3Class::begin()\n{\n  if (_spi != NULL) {\n    pinMode(_csPin, OUTPUT);\n    digitalWrite(_csPin, HIGH);\n    _spi->begin();\n  } else {\n    _wire->begin();\n  }\n\n\n  if (!(readRegister(LSM6DS3_WHO_AM_I_REG) == 0x6C || readRegister(LSM6DS3_WHO_AM_I_REG) == 0x69)) {\n    end();\n    // return 0;  разобраться почему не работает\n  }\n  //set the gyroscope control register to work at 104 Hz, 2000 dps and in bypass mode\n  writeRegister(LSM6DS3_CTRL2_G, 0x4C);\n\n  // Set the Accelerometer control register to work at 104 Hz, 4 g,and in bypass mode and enable ODR/4\n  // low pass filter (check figure9 of LSM6DS3's datasheet)\n  writeRegister(LSM6DS3_CTRL1_XL, 0x4A);\n\n  // set gyroscope power mode to high performance and bandwidth to 16 MHz\n  writeRegister(LSM6DS3_CTRL7_G, 0x00);\n\n  // Set the ODR config register to ODR/4\n  writeRegister(LSM6DS3_CTRL8_XL, 0x09);\n\n  return 1;\n}\n\nvoid LSM6DS3Class::end()\n{\n  if (_spi != NULL) {\n    _spi->end();\n    digitalWrite(_csPin, LOW);\n    pinMode(_csPin, INPUT);\n  } else {\n    writeRegister(LSM6DS3_CTRL2_G, 0x00);\n    writeRegister(LSM6DS3_CTRL1_XL, 0x00);\n    _wire->end();\n  }\n}\n\nint LSM6DS3Class::readAcceleration(float& x, float& y, float& z)\n{\n  int16_t data[3];\n\n  if (!readRegisters(LSM6DS3_OUTX_L_XL, (uint8_t*)data, sizeof(data))) {\n    x = NAN;\n    y = NAN;\n    z = NAN;\n\n    return 0;\n  }\n\n  x = data[0] * 4.0 / 32768.0;\n  y = data[1] * 4.0 / 32768.0;\n  z = data[2] * 4.0 / 32768.0;\n\n  return 1;\n}\n\nint LSM6DS3Class::accelerationAvailable()\n{\n  if (readRegister(LSM6DS3_STATUS_REG) & 0x01) {\n    return 1;\n  }\n\n  return 0;\n}\n\nfloat LSM6DS3Class::accelerationSampleRate()\n{\n  return 104.0F;\n}\n\nint LSM6DS3Class::readGyroscope(float& x, float& y, float& z)\n{\n  int16_t data[3];\n\n  if (!readRegisters(LSM6DS3_OUTX_L_G, (uint8_t*)data, sizeof(data))) {\n    x = NAN;\n    y = NAN;\n    z = NAN;\n\n    return 0;\n  }\n\n  x = data[0] * 2000.0 / 32768.0;\n  y = data[1] * 2000.0 / 32768.0;\n  z = data[2] * 2000.0 / 32768.0;\n\n  return 1;\n}\n\nint LSM6DS3Class::gyroscopeAvailable()\n{\n  if (readRegister(LSM6DS3_STATUS_REG) & 0x02) {\n    return 1;\n  }\n\n  return 0;\n}\n\nfloat LSM6DS3Class::gyroscopeSampleRate()\n{\n  return 104.0F;\n}\n\nint LSM6DS3Class::readRegister(uint8_t address)\n{\n  uint8_t value;\n  \n  if (readRegisters(address, &value, sizeof(value)) != 1) {\n    return -1;\n  }\n  \n  return value;\n}\n\nint LSM6DS3Class::readRegisters(uint8_t address, uint8_t* data, size_t length)\n{\n  if (_spi != NULL) {\n    _spi->beginTransaction(_spiSettings);\n    digitalWrite(_csPin, LOW);\n    _spi->transfer(0x80 | address);\n    _spi->transfer(data, length);\n    digitalWrite(_csPin, HIGH);\n    _spi->endTransaction();\n  } else {\n    _wire->beginTransmission(_slaveAddress);\n    _wire->write(address);\n\n    if (_wire->endTransmission(false) != 0) {\n      return -1;\n    }\n\n    if (_wire->requestFrom(_slaveAddress, length) != length) {\n      return 0;\n    }\n\n    for (size_t i = 0; i < length; i++) {\n      *data++ = _wire->read();\n    }\n  }\n  return 1;\n}\n\nint LSM6DS3Class::writeRegister(uint8_t address, uint8_t value)\n{\n  if (_spi != NULL) {\n    _spi->beginTransaction(_spiSettings);\n    digitalWrite(_csPin, LOW);\n    _spi->transfer(address);\n    _spi->transfer(value);\n    digitalWrite(_csPin, HIGH);\n    _spi->endTransaction();\n  } else {\n    _wire->beginTransmission(_slaveAddress);\n    _wire->write(address);\n    _wire->write(value);\n    if (_wire->endTransmission() != 0) {\n      return 0;\n    }\n  }\n  return 1;\n}\n\n#ifdef ARDUINO_AVR_UNO_WIFI_REV2\n  LSM6DS3Class IMU(SPI, SPIIMU_SS, SPIIMU_INT);\n#else\n  LSM6DS3Class IMU_LSM6DS3(Wire, LSM6DS3_ADDRESS);\n#endif"
    }, {
      filename: "LSM6DS3/Arduino_LSM6DS3.h",
      code: "/*\n  This file is part of the Arduino_LSM6DS3 library.\n  Copyright (c) 2019 Arduino SA. All rights reserved.\n\n  This library is free software; you can redistribute it and/or\n  modify it under the terms of the GNU Lesser General Public\n  License as published by the Free Software Foundation; either\n  version 2.1 of the License, or (at your option) any later version.\n\n  This library is distributed in the hope that it will be useful,\n  but WITHOUT ANY WARRANTY; without even the implied warranty of\n  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n  Lesser General Public License for more details.\n\n  You should have received a copy of the GNU Lesser General Public\n  License along with this library; if not, write to the Free Software\n  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA\n*/\n\n#ifndef  _ARDUINO_LSM6DS3_H_\n#define  _ARDUINO_LSM6DS3_H_\n\n#include \"LSM6DS3.h\"\n\n#endif\n"
    }]
  };
  const extFacePanels = {};
  const ExtHandler = {
    onLoad: function onLoad(app, target) {
      const that = this;

      if (!that.__workerSetupInstance) {
        that.__workerSetupInstance = that.workerSetup({
          app
        }).then(() => {
          that.worker.remote.runExtension('onLoad', target.id);
        });
      }
    },
    onUnload: function onUnload(app) {
      this.__workerSetupInstance = null;
      this.worker.remote.runExtension('onUnload');
      this.worker.dispose();
    },
    onConnect: function onConnect(app, device) {
      this.worker.remote.runExtension('onConnect', device.id);
    },
    onDisconnect: function onDisconnect(app, device) {
      this.worker.remote.runExtension('onDisconnect', device.id);
    },
    onStopAll: function onStopAll(app, device) {
      this.worker.remote.runExtension('onStopAll', device.id);
    },
    beforeChangeUploadMode: function beforeChangeUploadMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeUploadMode', device.id);
    },
    beforeChangeDebugMode: function beforeChangeDebugMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeDebugMode', device.id);
    },
    afterChangeUploadMode: function afterChangeUploadMode(app, device) {
      this.worker.remote.runExtension('afterChangeUploadMode', device.id);
    },
    afterChangeDebugMode: function afterChangeDebugMode(app, device) {
      this.worker.remote.runExtension('afterChangeDebugMode', device.id);
    },
    onSelect: function onSelect(app, device) {
      if (!this.worker) {
        setTimeout(() => {
          this.onSelect(app, device);
        }, 200);
        return;
      }

      this.worker.remote.runExtension('onSelect', device.id);
    },
    onUnselect: function onUnselect(app, device) {
      this.worker.remote.runExtension('onUnselect', device.id);
    },
    beforeCodeUpload: function beforeCodeUpload(app, device) {
      this.worker.remote.runExtension('beforeCodeUpload', device.id);
    },
    afterCodeUpload: function afterCodeUpload(app, device) {
      this.worker.remote.runExtension('afterCodeUpload', device.id);
    },
    onRead: function onRead(app, device) {
      this.worker.remote.runExtension('onRead', device.id);
    },
    beforeFirmwareUpdate: function beforeFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('beforeFirmwareUpdate', device.id);
    },
    afterFirmwareUpdate: function afterFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('afterFirmwareUpdate', device.id);
    }
  };

  class ExtRenicsExtention {
    constructor() {
      this.checkFirmwareInForce = typeof checkFirmwareInForce !== 'undefined' ? checkFirmwareInForce : false;
      const handlerProxyUrl = window.MbApi.getExtResPath('renics_extention/handlerProxy.js', 'renics_extention');
      const that = this;

      that.workerSetup = async function (exports) {
        that.worker = await window.__web_worker_rpc.create(handlerProxyUrl, exports).then(worker => {
          worker.CONFIG.TIMEOUT = 42000;
          worker.CONFIG.HEARTBEAT = 4200;

          worker.onFail = () => {
            that.worker = null;
            that.workerSetup(exports);
            const app = exports.app;

            if (app) {
              app.workspace.resetEvents();
            }
          };

          return worker;
        });
      };

      this.funcs = {
        'SERIAL_PRINTLN': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('SERIAL_PRINTLN', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'buzzer': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('buzzer', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'led_control': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('led_control', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'setDigital': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('setDigital', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'is_pressed_button': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('is_pressed_button', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1719068300620': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1719068300620', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1719071535530': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1719071535530', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1721321922207': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1721321922207', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1698789325358': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1698789325358', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1699086551609': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1699086551609', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'accelerometr': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('accelerometr', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'when_core_started': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('when_core_started', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          },
          onAdd: (app, device, block) => {
            this.worker.remote.runBlock('when_core_started', 'onAdd', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            });
          },
          onRemove: (app, device, block) => {
            this.worker.remote.runBlock('when_core_started', 'onRemove', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            });
          }
        },
        'dataVariableCodesCode': [`get_variable('{VARIABLE}')`, 0]
      };
    }

    getInfo() {
      return {
        "id": "renics_extention",
        "targets": {
          "device": true,
          "name": "renics_extention",
          "icon": window.MbApi.getExtResPath('renics_extention/imgs/lALPBE1XYi3KSRXNAUDNAUA_320_320.png', 'renics_extention'),
          "enableCode": true,
          "enableUpload": ["serialport"],
          "enableOnline": ["serialport"],
          "shouldConnect": ["serialport"],
          "defaultOnline": false,
          "options": {
            "connect": {
              "ble": {
                "channel": "1"
              },
              "serialport": {
                "baudRate": "115200",
                "vendorId": "0x0403"
              }
            },
            "upload": {
              "middlewares": [{
                "name": "arduino",
                "params": {
                  "board": "mega",
                  "sources": extSources.arduino
                }
              }],
              "driver": {
                "name": "stk500v2"
              }
            },
            "firmware": {
              "driver": {}
            }
          },
          "settings": [],
          "categoriesOrder": ["base", "sensors", "events", "control", "operators", "data", "myBlocks"]
        },
        "codeTypes": ["arduinoc"],
        "version": "0.0.1",
        "platform": ["mblockpc", "mblockweb"],
        "categories": [{
          "name": "base",
          "colors": ["#0079FF", "#006DE6", "#0061CC"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [{
            "opcode": "SERIAL_PRINTLN",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "text": {
                "type": "string",
                "defaultValue": ""
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `Serial.println(/*{text}*/);`,
                "sections": {
                  "setup": `Serial.begin(115200);`
                }
              }
            },
            "handler": this.funcs.SERIAL_PRINTLN
          }, {
            "opcode": "buzzer",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "status": {
                "type": "number",
                "defaultValue": 1
              },
              "del": {
                "type": "number",
                "defaultValue": 1
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `tone(22, /*{del}*/, /*{status}*/);`
              }
            },
            "handler": this.funcs.buzzer
          }, {
            "opcode": "led_control",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "LED_CONTROL_STATUS"
              },
              "pin": {
                "type": "fieldMenu",
                "defaultValue": "45",
                "menu": "LED_CONTROL_PIN"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                  "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
              }
            },
            "handler": this.funcs.led_control
          }, {
            "opcode": "setDigital",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "pin": {
                "type": "fieldMenu",
                "defaultValue": "5",
                "menu": "SETDIGITAL_PIN"
              },
              "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "SETDIGITAL_STATUS"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                  "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
              }
            },
            "handler": this.funcs.setDigital
          }, {
            "opcode": "is_pressed_button",
            "blockType": "boolean",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "button_pin": {
                "type": "fieldMenu",
                "defaultValue": "23",
                "menu": "IS_PRESSED_BUTTON_BUTTON_PIN"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `!digitalRead(/*{button_pin}*/)`,
                "sections": {
                  "setup": `pinMode(/*{button_pin}*/, INPUT);`
                }
              }
            },
            "handler": this.funcs.is_pressed_button
          }, {
            "opcode": "BLOCK_1719068300620",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "pin": {
                "type": "fieldMenu",
                "defaultValue": "25",
                "menu": "BLOCK_1719068300620_PIN"
              },
              "status": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "SETDIGITAL_STATUS"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `digitalWrite(/*{pin}*/, /*{status}*/);`,
                "sections": {
                  "setup": `pinMode(/*{pin}*/, OUTPUT);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1719068300620
          }, {
            "opcode": "BLOCK_1719071535530",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "red": {
                "type": "number",
                "defaultValue": 1
              },
              "green": {
                "type": "number",
                "defaultValue": 1
              },
              "blue": {
                "type": "number",
                "defaultValue": 1
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `leds [0] = CRGB(/*{red}*/, /*{green}*/, /*{blue}*/);\r\nFastLED.show();`,
                "sections": {
                  "lib": `#include \"FastLED-2-final/FastLED.h\"`,
                  "declare": `#define NUM_LEDS 1\r\n#define DATA_PIN 43\r\nCRGB leds [ NUM_LEDS ];`,
                  "setup": `FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);\r\nFastLED.setBrightness(100);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1719071535530
          }, {
            "opcode": "BLOCK_1721321922207",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {},
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `notone();`
              }
            },
            "handler": this.funcs.BLOCK_1721321922207
          }],
          "menus": {
            "LED_CONTROL_STATUS": [{
              "text": "LED_CONTROL_STATUS_0",
              "value": "1"
            }, {
              "text": "LED_CONTROL_STATUS_1",
              "value": "0"
            }],
            "LED_CONTROL_PIN": [{
              "text": "LED_CONTROL_PIN_0",
              "value": "45"
            }, {
              "text": "LED_CONTROL_PIN_1",
              "value": "46"
            }, {
              "text": "LED_CONTROL_PIN_2",
              "value": "44"
            }],
            "SETDIGITAL_PIN": [{
              "text": "SETDIGITAL_PIN_0",
              "value": "5"
            }, {
              "text": "SETDIGITAL_PIN_1",
              "value": "6"
            }, {
              "text": "SETDIGITAL_PIN_2",
              "value": "7"
            }, {
              "text": "SETDIGITAL_PIN_3",
              "value": "15"
            }, {
              "text": "SETDIGITAL_PIN_4",
              "value": "16"
            }, {
              "text": "SETDIGITAL_PIN_5",
              "value": "17"
            }, {
              "text": "SETDIGITAL_PIN_6",
              "value": "18"
            }, {
              "text": "SETDIGITAL_PIN_7",
              "value": "23"
            }],
            "SETDIGITAL_STATUS": [{
              "text": "SETDIGITAL_STATUS_0",
              "value": "1"
            }, {
              "text": "SETDIGITAL_STATUS_1",
              "value": "0"
            }],
            "IS_PRESSED_BUTTON_BUTTON_PIN": [{
              "text": "IS_PRESSED_BUTTON_BUTTON_PIN_0",
              "value": "23"
            }, {
              "text": "IS_PRESSED_BUTTON_BUTTON_PIN_1",
              "value": "24"
            }],
            "BLOCK_1719068300620_PIN": [{
              "text": "BLOCK_1719068300620_PIN_0",
              "value": "25"
            }, {
              "text": "BLOCK_1719068300620_PIN_1",
              "value": "26"
            }, {
              "text": "BLOCK_1719068300620_PIN_2",
              "value": "27"
            }]
          }
        }, {
          "name": "sensors",
          "colors": ["#AB47BC", "#9B3EAB", "#8A3798"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [{
            "opcode": "BLOCK_1698789325358",
            "blockType": "string",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "ir_port": {
                "type": "fieldMenu",
                "defaultValue": "PORT_1",
                "menu": "BLOCK_1698789325358_IR_PORT"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `rangefinder.getDistance()`,
                "sections": {
                  "lib": `#include \"RenicsWire/RenicsWire.h\"`,
                  "declare": `RenicsIR  rangefinder(/*{ir_port}*/);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1698789325358
          }, {
            "opcode": "BLOCK_1699086551609",
            "blockType": "string",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "axis": {
                "type": "fieldMenu",
                "defaultValue": "ax",
                "menu": "BLOCK_1699086551609_AXIS"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `/*{axis}*/*9.81`,
                "sections": {
                  "lib": `#include \"LSM6DS3/Arduino_LSM6DS3.h\"`,
                  "declare": `float ax = 0, ay = 0, az = 0;`,
                  "setup": `IMU.begin();`,
                  "_loop": `  if (IMU.accelerationAvailable()) {\n    IMU.readAcceleration(ax, ay, az);\n  }`
                }
              }
            },
            "handler": this.funcs.BLOCK_1699086551609
          }, {
            "opcode": "accelerometr",
            "blockType": "string",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "axis": {
                "type": "fieldMenu",
                "defaultValue": "gx",
                "menu": "ACCELEROMETR_AXIS"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": "/*{axis}*/",
                "sections": {
                  "lib": `#include \"LSM6DS3/Arduino_LSM6DS3.h\"`,
                  "declare": `float gx = 0, gy = 0, gz = 0;`,
                  "setup": `IMU.begin();`,
                  "_loop": `  if (IMU.gyroscopeAvailable()) {\n    IMU.readGyroscope(gx, gy, gz);\n  }`
                }
              }
            },
            "handler": this.funcs.accelerometr
          }],
          "menus": {
            "BLOCK_1698789325358_IR_PORT": [{
              "text": "BLOCK_1698789325358_IR_PORT_0",
              "value": "PORT_1"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_1",
              "value": "PORT_2"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_2",
              "value": "PORT_3"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_3",
              "value": "PORT_4"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_4",
              "value": "PORT_5"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_5",
              "value": "PORT_6"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_6",
              "value": "PORT_7"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_7",
              "value": "PORT_8"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_8",
              "value": "PORT_9"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_9",
              "value": "PORT_10"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_10",
              "value": "PORT_11"
            }, {
              "text": "BLOCK_1698789325358_IR_PORT_11",
              "value": "PORT_12"
            }],
            "BLOCK_1699086551609_AXIS": [{
              "text": "BLOCK_1699086551609_AXIS_0",
              "value": "ax"
            }, {
              "text": "BLOCK_1699086551609_AXIS_1",
              "value": "ay"
            }, {
              "text": "BLOCK_1699086551609_AXIS_2",
              "value": "az"
            }],
            "ACCELEROMETR_AXIS": [{
              "text": "ACCELEROMETR_AXIS_0",
              "value": "gx"
            }, {
              "text": "ACCELEROMETR_AXIS_1",
              "value": "gy"
            }, {
              "text": "ACCELEROMETR_AXIS_2",
              "value": "gz"
            }]
          }
        }, {
          "name": "events",
          "colors": ["#FFBF00", "#E6AC00", "#CC9900"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [{
            "opcode": "when_core_started",
            "blockType": "hat",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {},
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "sections": {
                  "setup": "/*{$BRANCH}*/"
                }
              }
            },
            "handler": this.funcs.when_core_started
          }],
          "menus": {}
        }, {
          "name": "control",
          "colors": ["#FFAB19", "#FCA000", "#E08E00"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [],
          "menus": {}
        }, {
          "name": "operators",
          "colors": ["#59C059", "#46B746", "#3EA33E"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [],
          "menus": {}
        }, {
          "name": "data",
          "colors": ["#FF8C1A", "#FD7E00", "#E17000"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [{
            "opcode": "data_setvariableto",
            "blockType": "command",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "VARIABLE": {
                "type": "fieldVariable",
                "defaultValue": "",
                "menu": "DATA_SETVARIABLETO_VARIABLE"
              },
              "VALUE": {
                "type": "number",
                "defaultValue": 0
              }
            },
            "branchCount": 0,
            "codes": {
              "python": {
                "code": `set_variable('{VARIABLE}', {VALUE})`
              }
            }
          }, {
            "opcode": "data_changevariableby",
            "blockType": "command",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "VARIABLE": {
                "type": "fieldVariable",
                "defaultValue": "",
                "menu": "DATA_SETVARIABLETO_VARIABLE"
              },
              "VALUE": {
                "type": "number",
                "defaultValue": 1
              }
            },
            "branchCount": 0,
            "codes": {
              "python": {
                "code": `set_variable('{VARIABLE}', get_variable('{VARIABLE}') + {VALUE})`
              }
            }
          }, {
            "opcode": "data_variable",
            "blockType": "number",
            "checkboxInFlyout": true,
            "gap": 12,
            "arguments": {
              "VARIABLE": {
                "type": "fieldVariable",
                "defaultValue": "",
                "menu": "DATA_SETVARIABLETO_VARIABLE"
              }
            },
            "branchCount": 0,
            "codes": {
              "python": {
                "code": this.funcs.dataVariableCodesCode
              }
            }
          }],
          "menus": {
            "DATA_SETVARIABLETO_VARIABLE": [{
              "text": "DATA_SETVARIABLETO_VARIABLE_0",
              "value": ""
            }]
          }
        }, {
          "name": "myBlocks",
          "colors": ["#FF6680", "#FF4262", "#FF1F45"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [],
          "menus": {}
        }],
        "generators": extGenerators,
        "translationMap": extTranslationMap,
        "snippets": codeSnippets,
        "excludeBlocks": ["event_whenflagclicked", "event_whenkeypressed", "event_whengreaterthan", "event_whenthisspriteclicked", "event_whenbackdropswitchesto", "control_start_as_clone", "control_create_clone_of", "control_delete_this_clone", "control_stop", "event_whenbroadcastreceived", "event_broadcast", "event_broadcastandwait"],
        "generatorStartBlocks": ["BLOCK_1698789325358", "when_core_started"],
        "feature": ["worker"],
        "mustLoginBlocks": [],
        "disabledOffline": [],
        "disabledOnline": []
      };
    }

    getHandler() {
      if (typeof ExtHandler === 'object') {
        return ExtHandler;
      } else if (typeof ExtHandler === 'function') {
        return new ExtHandler();
      }
    }

  }

  var _default = ExtRenicsExtention;
  _exports.default = _default;
});